(*loadPath := "/nfs/thesis/o/o_hasan/hol/miller/RSA" ::
!loadPath;

loadPath := "/nfs/thesis/o/o_hasan/hol/miller/ho_prover" ::
!loadPath;

loadPath := "/nfs/thesis/o/o_hasan/hol/miller/subtypes" ::
!loadPath;

loadPath := "/nfs/thesis/o/o_hasan/hol/miller/formalize" ::
!loadPath;

loadPath := "/nfs/thesis/o/o_hasan/hol/miller/prob" ::
!loadPath;

loadPath := "/nfs/thesis/o/o_hasan/hol/miller/groups" ::
!loadPath;

loadPath := "/nfs/thesis/o/o_hasan/hol/cont_prob_dist" ::
!loadPath;



app load ["HolKernel", "Parse", "boolLib", "bossLib", "arithmeticTheory",
     "pred_setTheory", "listTheory", "sequenceTheory", "state_transformerTheory",
     "probabilityTheory", "formalizeUseful", "extra_numTheory", "combinTheory",
     "pairTheory", "realTheory", "realLib", "extra_boolTheory", "jrhUtils",
     "extra_pred_setTheory", "prob_algebraTheory", "probTheory", "realSimps",
     "extra_realTheory", "extra_pred_setTools", "measureTheory", "numTheory",
     "simpLib", "seqTheory", "prob_extraTheory", "probTools",
     "prob_extraTools", "pred_setLib", "limTheory"]; 
*)

open HolKernel Parse boolLib bossLib arithmeticTheory pred_setTheory
     listTheory sequenceTheory state_transformerTheory
     probabilityTheory formalizeUseful extra_numTheory combinTheory
     pairTheory realTheory realLib extra_boolTheory jrhUtils
     extra_pred_setTheory prob_algebraTheory probTheory realSimps
     extra_realTheory extra_pred_setTools measureTheory numTheory
     simpLib seqTheory prob_extraTheory probTools prob_extraTools 
     pred_setLib limTheory;

val _ = new_theory "std_unif";

fun LEAST_ELIM_TAC (asl, w) = let
  val least_terms = find_terms numSyntax.is_least w
  val tbc = TRY_CONV BETA_CONV
  fun doit t =
    if free_in t w then
      CONV_TAC (UNBETA_CONV t) THEN
      MATCH_MP_TAC whileTheory.LEAST_ELIM THEN
      CONV_TAC
        (FORK_CONV
           (BINDER_CONV tbc, (* ?n. P n *)
            BINDER_CONV      (* !n. (!m. m < n ==> ~P m) /\ P n ==> Q n *)
              (FORK_CONV
                 (FORK_CONV
                    (BINDER_CONV (RAND_CONV (RAND_CONV tbc)), (* !m.... *)
                     tbc), (* P n *)
                    tbc))))
    else NO_TAC
in
  FIRST (map doit least_terms)
end (asl, w);


val LAMBDA_LET = store_thm
  ("LAMBDA_LET",
   (--`!p f. (\(m,x). f m x) p = (let (a,b) = p in (f a b))`--),
	RW_TAC std_ss [LET_DEF]);

val LAMBDA_PAIR = store_thm
  ("LAMBDA_PAIR",
  (--`!m x p f. (\(m,x). f m x) p = f (FST p) (SND p)` --),
	RW_TAC std_ss [LAMBDA_LET] THEN RW_TAC std_ss [FST, SND]);

val REAL_SUB_ASSOC = store_thm
  ("REAL_SUB_ASSOC",
  (--`! (a: real) b c. a - b - c = a - (b + c)` --),
	REAL_ARITH_TAC);

val REAL_SUB_ASSOC2 = store_thm
  ("REAL_SUB_ASSOC2",
  (--`! (a: real) b c. a - b + c = a + (c - b)`--),
	REAL_ARITH_TAC);

val LT_SUC_LTE = store_thm
  ("LT_SUC_LTE",
  (--`!m n. m < (SUC n) = (m < n) \/ (m = n)`--),
	DECIDE_TAC);

val HALF_POW_SUC_LE_HALF_POW_N = store_thm
  ("HALF_POW_SUC_LE_HALF_POW_N",
  (--`!n. (1 / 2) pow SUC n <= (1 / 2) pow n`--),
	REWRITE_TAC [pow] THEN 
	FULL_SIMP_TAC std_ss [GSYM REAL_LE_RDIV_EQ, POW_HALF_POS] THEN
	FULL_SIMP_TAC std_ss [EQ_SYM_EQ, POW_HALF_POS, REAL_LT_IMP_NE,
                            REAL_LT_IMP_LE, REAL_DIV_REFL, HALF_LT_1 ] 
);

val HALF_POW_SUC_PLUS_SUCSUC_LE_HALF_POW = store_thm
  ("HALF_POW_SUC_PLUS_SUCSUC_LE_HALF_POW",
  (--`!n. (1 / 2) pow SUC n + (1 / 2) pow SUC (SUC n) <= (1 / 2) pow n`--),
	GEN_TAC THEN
	KNOW_TAC `(1 / 2) pow n = (1 / 2) pow SUC n + (1 / 2) pow SUC n` THEN1
	RW_TAC real_ss [REAL_DOUBLE,GSYM POW_HALF_TWICE] THEN
	ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC REAL_LE_ADD2 THEN
	RW_TAC std_ss [REAL_LE_REFL, HALF_POW_SUC_LE_HALF_POW_N]
);

val REAL_NE_LT_GT = store_thm
  ("REAL_NE_LT_GT",
  (--`!(a:real) (b:real). ~(a = b) = (a < b) \/ (b < a)`--),
	REAL_ARITH_TAC
);

val SUM_HALF_POW_SUC = store_thm
  ("SUM_HALF_POW_SUC",
  (--`!n. sum (0,n) (\n. (1/2) pow SUC n) = 1 - (1/2) pow n`--),
	Induct THENL [
		RW_TAC real_ss [sum], 
		RW_TAC std_ss [sum, ADD_CLAUSES] THEN
		REWRITE_TAC [GSYM REAL_EQ_SUB_LADD] THEN
		REWRITE_TAC [REAL_SUB_ASSOC] THEN
		FULL_SIMP_TAC std_ss [REAL_DOUBLE] THEN
		RW_TAC std_ss [GSYM POW_HALF_TWICE]]
);

val REAL_SEQ_LE_EXISTS_EQ = store_thm
  ("REAL_SEQ_LE_EXISTS_EQ",
  (--`!(a:num -> real) (b:real) (c:num -> real) (n:num). ?x.
                (a x = c x) /\ (a n <= b) /\ (b <= c n) ==> (b = a x)` --),
	REWRITE_TAC [REAL_LE_LT] THEN
	RW_TAC std_ss [LEFT_AND_OVER_OR, RIGHT_AND_OVER_OR] THEN
	EXISTS_TAC (--`n:num`--) THEN
	REAL_ARITH_TAC
); 

val SIMP_REAL_ARCH = store_thm
  ("SIMP_REAL_ARCH",
  (--`!x. ?n. x <= &n` --),
	REWRITE_TAC [REAL_LE_LT] THEN
	FULL_SIMP_TAC std_ss [EXISTS_OR_THM] THEN
	RW_TAC std_ss [] THEN
	DISJ1_TAC THEN
	MP_TAC (Q.SPEC `1` REAL_ARCH) THEN
	REWRITE_TAC [REAL_LT_01, REAL_MUL_RID] THEN
	RW_TAC std_ss []
);


val NUM_LT_IMP_ABS_GT_PLUS1_GT = store_thm
  ("NUM_LT_IMP_ABS_GT_PLUS1_GT",
  (--`!(x:real) (n:num). (!m. m < n ==> (&m < (abs x)))
                                        = (&n < (abs x) + 1 )` --),
	REPEAT GEN_TAC THEN
	REWRITE_TAC [EQ_IMP_THM] THEN
	CONJ_TAC THENL [
		REWRITE_TAC [GSYM REAL_LE] THEN
		REWRITE_TAC [IMP_DISJ_THM] THEN
		FULL_SIMP_TAC std_ss [NOT_FORALL_THM]  THEN
		REWRITE_TAC [REAL_NOT_LT] THEN
		ONCE_REWRITE_TAC [DISJ_SYM] THEN
		REWRITE_TAC [real_lt] THEN
		REWRITE_TAC [GSYM IMP_DISJ_THM] THEN
		DISCH_TAC THEN
		EXISTS_TAC (--`n:num - 1`--) THEN
		CONJ_TAC THENL [
			MATCH_MP_TAC SUB_LESS THEN
			RW_TAC arith_ss [] THEN
			REWRITE_TAC [GSYM REAL_LE] THEN
			MATCH_MP_TAC REAL_LE_TRANS THEN
			EXISTS_TAC (--`abs x + 1`--) THEN
			ASM_REWRITE_TAC [] THEN
			ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
			PROVE_TAC [ABS_POS, REAL_LE_ADDR],
			FULL_SIMP_TAC std_ss [GSYM REAL_LE_SUB_LADD] THEN
			MATCH_MP_TAC REAL_LE_TRANS THEN
			EXISTS_TAC (--`& n - 1`--) THEN
			ASM_REWRITE_TAC [REAL_SUB] THEN
			Cases_on `n - 1 = 0` THENL [
				RW_TAC std_ss [] THEN
				FULL_SIMP_TAC std_ss [SUB_EQ_0] THEN
				REWRITE_TAC [REAL_NEG_LE0] THEN
				KNOW_TAC `(n = 0) \/ (n = 1)` THENL
					[DECIDE_TAC, 
					RW_TAC arith_ss [REAL_LE_REFL],
					RW_TAC arith_ss [REAL_LE_01]], 
				RW_TAC std_ss [REAL_LE_REFL]]],
		DISCH_TAC THEN
		GEN_TAC THEN
		UNDISCH_TAC (--`& n < abs x + 1`--) THEN
		REWRITE_TAC [IMP_DISJ_THM] THEN
		REWRITE_TAC [REAL_NOT_LE, NOT_LESS, GSYM REAL_LE] THEN
		REWRITE_TAC [REAL_NOT_LT] THEN
		REWRITE_TAC [REAL_LE_LT] THEN
		REWRITE_TAC [GSYM DISJ_ASSOC] THEN
		Cases_on `& m < abs x` THENL [
			RW_TAC std_ss [],
			Cases_on `& n < & m` THENL [
				RW_TAC std_ss [],
				RW_TAC std_ss [] THEN
				FULL_SIMP_TAC std_ss [REAL_NOT_LT] THEN
				UNDISCH_TAC (--`& m <= & n`--) THEN
				REWRITE_TAC [REAL_LE_LT] THEN
				RW_TAC std_ss [] THENL [
					REWRITE_TAC [DISJ_ASSOC] THEN
					REWRITE_TAC [GSYM REAL_LE_LT] THEN
					DISJ1_TAC THEN
					KNOW_TAC `&m + 1 <= &n` THENL 
						[REWRITE_TAC [REAL_ADD] THEN
						REWRITE_TAC [GSYM ADD1] THEN
						FULL_SIMP_TAC std_ss [REAL_LE, REAL_LT] THEN
						MATCH_MP_TAC LESS_OR THEN
						ASM_REWRITE_TAC [], 
						MATCH_MP_TAC REAL_LE_TRANS THEN
						EXISTS_TAC (--`&m + 1`--) THEN
						ASM_REWRITE_TAC [] THEN
						RW_TAC std_ss [REAL_LE_RADD, REAL_LE_REFL]],
					PROVE_TAC [EQ_SYM_EQ]]]]]
);


val NUM_LT_IMP_ABS_NLE_PLUS1_GT  = store_thm
  ("NUM_LT_IMP_ABS_NLE_PLUS1_GT",
  (--`!(x:real) (n:num). (!m. m < n ==> ~(abs x <= & m)) 
					= (&n < (abs x) + 1 )` --),
	PROVE_TAC [NUM_LT_IMP_ABS_GT_PLUS1_GT, REAL_NOT_LE]		
);

val HALF_POW_TWO_POW = store_thm
  ("HALF_POW_TWO_POW",
  (--`!n. (1 / 2) pow n * 2 pow n = 1` --),
	RW_TAC real_ss [real_div, POW_ONE] THEN
	MATCH_MP_TAC REAL_MUL_LINV THEN
	MATCH_MP_TAC REAL_POS_NZ THEN
	RW_TAC real_ss [REAL_POW_LT]
);


val HALF_POW_TENDSTO_ZERO = store_thm
  ("HALF_POW_TENDSTO_ZERO",
  (--`(\n. (1/2) pow n) --> 0` --),
	MATCH_MP_TAC SEQ_POWER THEN
	RW_TAC real_ss [abs, REAL_LT_IMP_LE]
);

val TWO_HALF_POW_TENDSTO_ZERO = store_thm
  ("TWO_HALF_POW_TENDSTO_ZERO",
  (--`(\n. 2 * (1 / 2) pow n) --> 0` --),
	KNOW_TAC `0 = 2 * 0` THEN1 
		RW_TAC real_ss [] THEN
	KNOW_TAC `(\n. 2 * (1 / 2) pow n) = 
	(\n. (\n. 2) n * (\n. (1 / 2) pow n) n)` THEN1
		PROVE_TAC [BETA_THM] THEN
	PURE_ONCE_ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC SEQ_MUL THEN
	RW_TAC std_ss [HALF_POW_TENDSTO_ZERO, SEQ_CONST]
);

val REAL_SUB_2  = store_thm
  ("REAL_SUB_2",
  (--`!m n. & m - & n = (if n <= m then & (m - n) else ~& (n - m))` --),
	RW_TAC bossLib.arith_ss [REAL_EQ_SUB_RADD, REAL_ADD] THEN
	ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
	RW_TAC bossLib.arith_ss [GSYM real_sub, REAL_EQ_SUB_LADD, REAL_ADD]
);

(*---------------------------------------------------------------------------*);

val ceiling_def =
      Define
        `ceiling (x:real) = LEAST (n:num). x <= &n`;

val LB_CEILING = store_thm
  ("LB_CEILING",
  (--`!x. x <= &(ceiling x)` --),
	RW_TAC std_ss [ceiling_def] THEN
	LEAST_ELIM_TAC THEN
	Q.SPEC_THEN `1` MP_TAC REAL_ARCH THEN
	SIMP_TAC (srw_ss()) [] THEN
	PROVE_TAC [REAL_LT_IMP_LE]
);

val ABS_PLUS1_GT_CEILING_ABS = store_thm
  ("ABS_PLUS1_GT_CEILING_ABS",
  (--`!x.  &(ceiling(abs x)) < (abs x) + 1` --),
	RW_TAC std_ss [ceiling_def] THEN
	LEAST_ELIM_TAC THEN
	REWRITE_TAC [SIMP_REAL_ARCH] THEN
	PROVE_TAC [NUM_LT_IMP_ABS_GT_PLUS1_GT, REAL_NOT_LE]	
);

val UB_CEILING = store_thm
  ("UB_CEILING",
  (--`!x. (0 <= x) ==> &(ceiling(x)) < x + 1` --),
	GEN_TAC	THEN
	DISCH_TAC THEN
	KNOW_TAC `x = abs (x)` THEN1
		RW_TAC std_ss [abs] THEN	
	PROVE_TAC [ABS_PLUS1_GT_CEILING_ABS]	
);

val CEILING_NUM = store_thm
  ("CEILING_NUM",
  (--`!n. ceiling (&n) = n` --),
	GEN_TAC THEN
	MP_TAC (Q.SPEC `&n` LB_CEILING) THEN
	MP_TAC (Q.SPEC `&n` ABS_PLUS1_GT_CEILING_ABS) THEN
	RW_TAC arith_ss [ABS_N, REAL_LE, REAL_LT, REAL_ADD]
);

val CEILING_ABS_POS = store_thm
  ("CEILING_ABS_POS",
  (--`!x. 0 <= &(ceiling (abs x))`--),
	GEN_TAC THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`abs x`--) THEN
	REWRITE_TAC [LB_CEILING, ABS_POS]
);

val CEIL_MONO = store_thm
  ("CEIL_MONO",
  (--`!m n. (0 <= m) /\ (0 <= n) /\ (m <= n) ==> 
			(ceiling m) <= (ceiling n)` --),
	RW_TAC std_ss [] THEN
	KNOW_TAC `ceiling m <= ceiling n = (ceiling m < SUC (ceiling n))` THEN1
	RW_TAC arith_ss [] THEN
	ASM_REWRITE_TAC [GSYM REAL_LT, ADD1, GSYM REAL_ADD] THEN
	MATCH_MP_TAC REAL_LTE_TRANS THEN
	EXISTS_TAC (--`m + 1r`--) THEN
	RW_TAC std_ss [UB_CEILING] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`n + 1r`--) THEN
	RW_TAC std_ss [REAL_LE_RADD, LB_CEILING]
);	

val TWO_POWNX_LE_CEILING_2POWNX = store_thm
  ("TWO_POWNX_LE_CEILING_2POWNX",
  (--`!(x:real) (n:num).
	( (\n. ((2 pow n) * x) * ((1/2) pow n)) n <= 
			(\n. &(ceiling ((2 pow n) * x)) * ((1/2) pow n)) n)` --),
	BETA_TAC THEN
	REPEAT GEN_TAC THEN
	MATCH_MP_TAC REAL_LE_RMUL_IMP THEN
	RW_TAC std_ss [LB_CEILING, REAL_LT_IMP_LE,POW_HALF_POS]		
);

val TWO_POWNX_LE_CEILING_2POWNX = store_thm
  ("TWO_POWNX_LE_CEILING_2POWNX",
  (--`!(x:real) (n:num).
	( (\n. ((2 pow n) * x) * ((1/2) pow n)) n <= 
			(\n. &(ceiling ((2 pow n) * x)) * ((1/2) pow n)) n)` --),
	BETA_TAC THEN
	REPEAT GEN_TAC THEN
	MATCH_MP_TAC REAL_LE_RMUL_IMP THEN
	RW_TAC std_ss [LB_CEILING, REAL_LT_IMP_LE,POW_HALF_POS]	
);

val CEILING_2POWNX_LE_2POWNX_PLUS1 = store_thm
  ("CEILING_2POWNX_LE_2POWNX_PLUS1",
  (--`!(x:real) (n:num). (0 <= x) ==>
	(\n. (&(ceiling ((2 pow n) * x)) * ((1/2) pow n))) n  <= 
				(\n. (((2 pow n) * x) + 1) * ((1/2) pow n)) n` --),
	BETA_TAC THEN
	REPEAT GEN_TAC THEN
	DISCH_TAC THEN
	MATCH_MP_TAC REAL_LE_RMUL_IMP THEN
	RW_TAC std_ss [REAL_LT_IMP_LE, POW_HALF_POS] THEN
	MATCH_MP_TAC REAL_LT_IMP_LE THEN
	MATCH_MP_TAC UB_CEILING THEN
	RW_TAC real_ss [REAL_LE_MUL, POW_POS, REAL_LT_IMP_LE]
);

val TWO_POW_X_CEIL_HALF_POW_TENDS = store_thm
  ("TWO_POW_X_CEIL_HALF_POW_TENDS",
  (--`!(x:real).
	((\n. ((2 pow n) * x) * ((1/2) pow n)) --> x)` --),
	RW_TAC std_ss [] THEN
	ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
	REWRITE_TAC [REAL_MUL_ASSOC] THEN
	ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
	RW_TAC real_ss [HALF_POW_TWO_POW, SEQ_CONST]
);

val TWO_POW_X_PLUS1_HALF_POW_TENDS = store_thm
  ("TWO_POW_X_PLUS1_HALF_POW_TENDS",
  (--`!(x:real).
        ((\n. ((2 pow n) * x + 1) * ((1/2) pow n)) --> x)` --),
	RW_TAC std_ss [REAL_ADD_RDISTRIB] THEN
	KNOW_TAC `(\n. 2 pow n * x * (1 / 2) pow n + 1 * (1 / 2) pow n) = 
		(\n. (\n. (2 pow n * x) * (1 / 2) pow n) n + (\n. (1/2) pow n) n)` THENL [
	ABS_TAC THEN
	RW_TAC real_ss [BETA_THM],
	ASM_REWRITE_TAC [] THEN
	ONCE_REWRITE_TAC [GSYM REAL_ADD_RID] THEN
	KNOW_TAC `(\n. (\n. 2 pow n * x * (1 / 2) pow n) n + (\n. (1 / 2) pow n) n + 0) =
                (\n. (\n. 2 pow n * x * (1 / 2) pow n) n + (\n. (1 / 2) pow n) n)` THEN1
	RW_TAC real_ss [] THEN
	ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC SEQ_ADD THEN
	RW_TAC std_ss [HALF_POW_TENDSTO_ZERO, TWO_POW_X_CEIL_HALF_POW_TENDS]]
);

val UNIQ_NUM_IN_REAL_RANGE_ONE = store_thm
  ("UNIQ_NUM_IN_REAL_RANGE_ONE",
  (--`!x m n. (x <= &n) /\ (&n < x + 1) /\ 
			(x <= &m) /\ (&m < x + 1) ==> (&n = &m)` --),
	GEN_TAC THEN
	GEN_TAC THEN
	Induct THENL [
	RW_TAC std_ss [] THEN
	KNOW_TAC `&m < 1` THENL [
		MATCH_MP_TAC REAL_LTE_TRANS THEN
		EXISTS_TAC (--`(x:real) + 1`--) THEN
		RW_TAC real_ss [GSYM REAL_LE_SUB_LADD],
		FULL_SIMP_TAC std_ss [REAL_OF_NUM_EQ,REAL_LT] THEN
		DECIDE_TAC],
	FULL_SIMP_TAC std_ss [] THEN
	RW_TAC std_ss [] THEN
	KNOW_TAC `&n < &m` THENL [
		MATCH_MP_TAC REAL_LTE_TRANS THEN
		EXISTS_TAC (--`x:real`--) THEN
		FULL_SIMP_TAC std_ss [ADD1, GSYM REAL_ADD, REAL_LT_RADD],
		KNOW_TAC `&m < &(SUC n) + 1` THENL [
			MATCH_MP_TAC REAL_LTE_TRANS THEN
			EXISTS_TAC (--`(x:real) + 1`--) THEN
			RW_TAC std_ss [REAL_LE_RADD],
			FULL_SIMP_TAC std_ss [REAL_LE, REAL_LT, REAL_ADD, REAL_OF_NUM_EQ] THEN
			DECIDE_TAC]]]
);

val CEILING_TWO_POWNX_MONO_SUC_HELPER = store_thm
  ("CEILING_TWO_POWNX_MONO_SUC_HELPER",
  (--`!x m n. (x <= &n) /\ (&n < x + 1) /\ (x <= &m) ==>
	&n <= &m` --),
	RW_TAC std_ss [] THEN
	REWRITE_TAC [REAL_LE_LT] THEN
	Cases_on `&m < x + 1` THENL [
		DISJ2_TAC THEN
		PROVE_TAC [UNIQ_NUM_IN_REAL_RANGE_ONE],
		DISJ1_TAC THEN
		MATCH_MP_TAC REAL_LTE_TRANS THEN
		EXISTS_TAC (--`(x:real) + 1`--) THEN
		FULL_SIMP_TAC std_ss [REAL_NOT_LT]]

);


val CEILING_TWO_POWNX_MONO_SUC= store_thm
  ("CEILING_TWO_POWNX_MONO_SUC",
  (--`!n x. (0 <= x)  ==>
	(\n. (&(ceiling ((2 pow n) * x)) * ((1/2) pow n))) (SUC n) <=
		(\n. (&(ceiling ((2 pow n) * x)) * ((1/2) pow n))) n` --),
	RW_TAC std_ss [ceiling_def] THEN
	LEAST_ELIM_TAC THEN
	REWRITE_TAC [SIMP_REAL_ARCH] THEN
	GEN_TAC THEN
	LEAST_ELIM_TAC THEN
	REWRITE_TAC [SIMP_REAL_ARCH] THEN
	KNOW_TAC `!n. abs (2 pow n * x) = (2 pow n * x)` THENL [
		RW_TAC std_ss [ABS_REFL] THEN
	MATCH_MP_TAC REAL_LE_MUL THEN
	ASM_REWRITE_TAC [] THEN
	RW_TAC real_ss [POW_POS, REAL_LT_IMP_LE],
	KNOW_TAC `2 pow SUC n * x = abs (2 pow SUC n * x)` THEN1
		PROVE_TAC [EQ_SYM_EQ] THEN
	KNOW_TAC `2 pow n * x = abs (2 pow n * x)` THEN1
		PROVE_TAC [EQ_SYM_EQ] THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	REWRITE_TAC [NUM_LT_IMP_ABS_NLE_PLUS1_GT] THEN
	FULL_SIMP_TAC std_ss [ABS_ABS] THEN
	RW_TAC std_ss [] THEN
	REWRITE_TAC [pow, REAL_MUL_ASSOC] THEN
	RW_TAC std_ss [REAL_LE_RMUL, POW_HALF_POS,REAL_LT_IMP_LE] THEN
	RW_TAC real_ss [GSYM REAL_LE_RDIV_EQ] THEN
	RW_TAC real_ss [real_div, REAL_INV_INV] THEN
	REWRITE_TAC [GSYM REAL_LE] THEN
	KNOW_TAC `2 pow SUC n * x <= & (n' * 2)` THENL [
		REWRITE_TAC [GSYM REAL_MUL] THEN
		ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
		RW_TAC std_ss [pow] THEN
		REWRITE_TAC [REAL_MUL_ASSOC] THEN
		ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
		REWRITE_TAC [REAL_MUL_ASSOC] THEN
		RW_TAC real_ss [REAL_LE_RMUL],
		PROVE_TAC [CEILING_TWO_POWNX_MONO_SUC_HELPER]]]
);

val CEILING_TWO_POWNX_MONO = store_thm
  ("CEILING_TWO_POWNX_MONO",
  (-- `!x. (0 <= x) ==>
	mono (\n. (&(ceiling ((2 pow n) * x)) * ((1/2) pow n)))`--),
	RW_TAC std_ss [MONO_SUC] THEN
	DISJ2_TAC THEN
	PROVE_TAC [CEILING_TWO_POWNX_MONO_SUC]
);

val CEILING_TWO_POWNX_BOUNDED = store_thm
  ("CEILING_TWO_POWNX_BOUNDED",
  (--`!x. (0 <= x)  ==>
	bounded(mr1, $>=) (\n. (&(ceiling ((2 pow n) * x)) * ((1/2) pow n)))` --),
	GEN_TAC THEN
	DISCH_TAC THEN
	REWRITE_TAC [SEQ_BOUNDED] THEN
	EXISTS_TAC (--`(x:real) + 1`--) THEN
	Induct THENL [
		RW_TAC real_ss [pow, ABS_N] THEN
		MP_TAC (Q.SPEC `(x:real)` ABS_PLUS1_GT_CEILING_ABS) THEN
		RW_TAC std_ss [abs],
		MATCH_MP_TAC REAL_LET_TRANS THEN
		EXISTS_TAC (--`abs ((\n. & (ceiling (2 pow n * x)) * (1 / 2) pow n) n)`--) THEN
		ASM_REWRITE_TAC [] THEN
		MP_TAC (Q.SPECL [`n`, `x`] CEILING_TWO_POWNX_MONO_SUC) THEN
		FULL_SIMP_TAC std_ss [BETA_THM] THEN
		KNOW_TAC `0 <= & (ceiling (2 pow n * x)) * (1 / 2) pow n` THEN1
			PROVE_TAC [REAL_LE_MUL, REAL_POS, POW_HALF_POS,REAL_LT_IMP_LE] THEN
		KNOW_TAC `0 <= & (ceiling (2 pow SUC n * x)) * (1 / 2) pow SUC n` THEN1
			PROVE_TAC [REAL_LE_MUL, REAL_POS, POW_HALF_POS,REAL_LT_IMP_LE] THEN
		RW_TAC std_ss [abs]]
);

val CEILING_TWO_POWNX_CONVERGES = store_thm
  ("CEILING_TWO_POWNX_CONVERGES",
  (--`!(x:real). (0 <= x) ==>
	(\n. (&(ceiling ((2 pow n) * x)) * ((1/2) pow n))) -->
		lim (\n. (&(ceiling ((2 pow n) * x)) * ((1/2) pow n)))` --),
	GEN_TAC THEN
	DISCH_TAC THEN
	REWRITE_TAC [lim] THEN
	SELECT_ELIM_TAC THEN
	REWRITE_TAC [GSYM convergent] THEN
	MATCH_MP_TAC SEQ_BCONV  THEN
	RW_TAC std_ss [CEILING_TWO_POWNX_BOUNDED, CEILING_TWO_POWNX_MONO]
);

val CEILING_TWO_POWNX_CONVERGENT = store_thm
  ("CEILING_TWO_POWNX_CONVERGENT",
  (--`!(x:real). (0 <= x) ==>
	(convergent (\n. & (ceiling (2 pow n * x)) * (1 / 2) pow n))` --),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC SEQ_BCONV  THEN
	RW_TAC std_ss [CEILING_TWO_POWNX_BOUNDED, CEILING_TWO_POWNX_MONO]
);

val UB_LIM_CEILING_TWO_POWNX = store_thm
  ("UB_LIM_CEILING_TWO_POWNX",
  (--`!(x:real). (0 <= x) ==>
                lim (\n. & (ceiling (2 pow n * x)) * (1 / 2) pow n) <= x` --),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC SEQ_LE THEN
	EXISTS_TAC (--`(\n. (&(ceiling ((2 pow n) * x)) * ((1/2) pow n)))`--) THEN
	EXISTS_TAC (--`(\n. ((2 pow n) * x + 1) * ((1/2) pow n))`--) THEN
	REWRITE_TAC [TWO_POW_X_PLUS1_HALF_POW_TENDS] THEN
	CONJ_TAC THENL [
		FULL_SIMP_TAC std_ss [CEILING_TWO_POWNX_CONVERGES],
		EXISTS_TAC (--`0:num`--) THEN
		RW_TAC arith_ss [CEILING_2POWNX_LE_2POWNX_PLUS1]]
);

val LB_LIM_CEILING_TWO_POWNX = store_thm
  ("LB_LIM_CEILING_TWO_POWNX",
  (--`!(x:real) . (0 <= x) ==>
                x <= lim (\n. & (ceiling (2 pow n * x)) * (1 / 2) pow n)` --),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC SEQ_LE THEN
	EXISTS_TAC (--`(\n. ((2 pow n) * x) * ((1/2) pow n))`--) THEN
	EXISTS_TAC (--`(\n. (&(ceiling ((2 pow n) * x)) * ((1/2) pow n)))`--) THEN
	REWRITE_TAC [TWO_POW_X_CEIL_HALF_POW_TENDS] THEN
	CONJ_TAC THENL [
		FULL_SIMP_TAC std_ss [CEILING_TWO_POWNX_CONVERGES],
		EXISTS_TAC (--`0:num`--) THEN
		RW_TAC arith_ss [TWO_POWNX_LE_CEILING_2POWNX]]
);

val  LIM_CEILING_TWO_POWNX = store_thm
  ("LIM_CEILING_TWO_POWNX",
  (--`!(x:real). (0 <= x) ==>
                (lim (\n. & (ceiling (2 pow n * x)) * (1 / 2) pow n) = x)` --),
	RW_TAC std_ss [] THEN
	MP_TAC (Q.SPEC `x` UB_LIM_CEILING_TWO_POWNX) THEN
	MP_TAC (Q.SPEC `x` LB_LIM_CEILING_TWO_POWNX) THEN
	RW_TAC std_ss [GSYM REAL_LE_ANTISYM]	
);

val CEILING_TWO_POWNX_TENDSTO_X = store_thm
  ("CEILING_TWO_POWNX_TENDSTO_X",
  (--`!(x:real). (0 <= x) ==>
		(\n. & (ceiling (2 pow n * x)) * (1 / 2) pow n) --> x` --),
	RW_TAC std_ss [] THEN
	MP_TAC (Q.SPEC `x` LIM_CEILING_TWO_POWNX) THEN
	FULL_SIMP_TAC std_ss [] THEN
	REWRITE_TAC [lim] THEN
	SELECT_ELIM_TAC THEN
	CONJ_TAC THENL [
	RW_TAC std_ss [GSYM convergent, CEILING_TWO_POWNX_CONVERGENT],
	PROVE_TAC []]
);

val CEIL_TW0_POW_GE_1 = store_thm
  ("CEIL_TW0_POW_GE_1",
  (--`!x n. (0 < x) ==>
	1 <= ceiling ((2 pow n) * x)` --),
	RW_TAC arith_ss [LE_LT1] THEN
	ONCE_REWRITE_TAC [ADD_SYM] THEN
	MATCH_MP_TAC LESS_ADD_NONZERO THEN
	REWRITE_TAC [NOT_ZERO_LT_ZERO] THEN
	REWRITE_TAC [GSYM REAL_LT] THEN
	MATCH_MP_TAC REAL_LTE_TRANS THEN
	EXISTS_TAC (--`(2 pow n * x)`--) THEN
	RW_TAC std_ss [LB_CEILING] THEN
	RW_TAC real_ss [REAL_LT_RMUL_0, REAL_POW_LT]
);

val CEILING_TWO_POWNX_MINUS_ONE_TENDSTO_X = store_thm
  ("CEILING_TWO_POWNX_MINUS_ONE_TENDSTO_X",
  (-- `!(x:real). (0 <= x) ==>
                (\n. &(ceiling (2 pow n * x) - 1) * (1 / 2) pow n) --> x` --),
	RW_TAC std_ss [REAL_LE_LT] THENL [
	KNOW_TAC `!n. & (ceiling (2 pow n * x) - 1) = & (ceiling (2 pow n * x)) - 1` THENL [
		REWRITE_TAC [REAL_SUB_2] THEN
		RW_TAC std_ss [CEIL_TW0_POW_GE_1],
		KNOW_TAC `(\n. & (ceiling (2 pow n * x) - 1) * (1 / 2) pow n) = 
			(\n. (\n. & (ceiling (2 pow n * x)) * 
				(1 / 2) pow n) n - (\n. 1 * (1 / 2) pow n) n)` THENL [
			ABS_TAC THEN
			FULL_SIMP_TAC std_ss [GSYM REAL_SUB_RDISTRIB],
			ASM_REWRITE_TAC [] THEN
			KNOW_TAC `x = x - 0` THEN1
				RW_TAC real_ss [] THEN
			ONCE_ASM_REWRITE_TAC [] THEN
			MATCH_MP_TAC SEQ_SUB THEN
			RW_TAC std_ss [HALF_POW_TENDSTO_ZERO, REAL_MUL_LID,REAL_LT_IMP_LE,
				REAL_SUB_RZERO, CEILING_TWO_POWNX_TENDSTO_X]]],
			RW_TAC arith_ss [REAL_MUL_RZERO, CEILING_NUM, REAL_MUL_LZERO, SEQ_CONST]]
);

val CEILING_TWO_POWNX_PLUS_ONE_TENDSTO_X = store_thm
  ("CEILING_TWO_POWNX_PLUS_ONE_TENDSTO_X",
  (--`!(x:real). (0 <= x) ==>
                (\n. &(ceiling (2 pow n * x) + 1) * (1 / 2) pow n) --> x` --),
	RW_TAC std_ss [GSYM REAL_ADD] THEN
	RW_TAC std_ss [REAL_ADD_RDISTRIB] THEN
	KNOW_TAC `(\n. & (ceiling (2 pow n * x)) *
        (1 / 2) pow n + 1 * (1 / 2) pow n) =
                (\n. (\n. & (ceiling (2 pow n * x)) *
                (1 / 2) pow n) n + (\n. 1 * (1 / 2) pow n) n)` THEN1
		PROVE_TAC [BETA_THM] THEN
	ASM_REWRITE_TAC [] THEN
	KNOW_TAC `x = x + 0` THEN1
		RW_TAC real_ss [] THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC SEQ_ADD THEN
	RW_TAC std_ss [HALF_POW_TENDSTO_ZERO, REAL_MUL_LID,
                REAL_ADD_RID, CEILING_TWO_POWNX_TENDSTO_X]
);

val CEILING_2POWNX_MINUS1_LT_XHALF_POW = store_thm
  ("CEILING_2POWNX_MINUS1_LT_XHALF_POW",
  (--`!n x. (0 <= x) ==>
	(& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n < x`  --),
	RW_TAC std_ss [] THEN
	RW_TAC std_ss [POW_HALF_POS, GSYM REAL_LT_RDIV_EQ] THEN
	KNOW_TAC `x / (1 / 2) pow n = (2 pow n * x)` THEN1
		RW_TAC real_ss [real_div,POW_ONE, REAL_INV_INV, REAL_MUL_SYM] THEN
	ASM_REWRITE_TAC [REAL_LT_SUB_RADD] THEN
	MATCH_MP_TAC UB_CEILING THEN
	RW_TAC real_ss [REAL_LE_MUL, POW_POS]
);

val XHALF_POW_LE_CEILING_2POWNX = store_thm
  ("XHALF_POW_LE_CEILING_2POWNX",
  (--`!n x. (0 <= x) ==>
	x <= & (ceiling (2 pow n * x)) * (1 / 2) pow n` --),
	RW_TAC std_ss [] THEN
	RW_TAC std_ss [POW_HALF_POS, GSYM REAL_LE_LDIV_EQ] THEN
	KNOW_TAC `x / (1 / 2) pow n = (2 pow n * x)` THEN1
		RW_TAC real_ss [real_div,POW_ONE, REAL_INV_INV, REAL_MUL_SYM] THEN
	PROVE_TAC [LB_CEILING]
);

(*--------------------------------------------------------------------------*)

val std_unif_disc_def = Define `
	(std_unif_disc (0:num) (s:num -> bool) = (0,s)) /\
	(std_unif_disc (SUC n) s = 
		((if shd (SND (std_unif_disc n s)) then 
			((1/2) pow (SUC n) + FST (std_unif_disc n s)) else
				FST (std_unif_disc n s),
				stl (SND (std_unif_disc n s)))))`;

val unif_two_pow_def = Define `
        (unif_two_pow (0:num) (s:num -> bool) = ((0:num),s)) /\
        (unif_two_pow (SUC n) s =
                ((if shd (SND (unif_two_pow n s)) then
                        (2 * FST (unif_two_pow n s) + 1) else
                              2 *  FST (unif_two_pow n s ),
                                stl (SND (unif_two_pow n s)))))`;



val SND_STD_UNIF_EQ_UNIF_TWO_POW = store_thm
  ("SND_STD_UNIF_EQ_UNIF_TWO_POW",
  (--`!m n s. (SND (std_unif_disc n s)) = (SND (unif_two_pow n s))` --),
	GEN_TAC THEN
	Induct THENL [
		RW_TAC real_ss [std_unif_disc_def, unif_two_pow_def],
		RW_TAC real_ss [std_unif_disc_def, unif_two_pow_def]] 
);

val TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW = store_thm
  ("TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW",
  (--`!s n. (2 pow n) * (FST (std_unif_disc n s)) = & (FST (unif_two_pow n s))` --),

	GEN_TAC THEN
	Induct THENL [
	RW_TAC real_ss [pow, std_unif_disc_def, unif_two_pow_def],
	RW_TAC std_ss [std_unif_disc_def, unif_two_pow_def, 
		SND_STD_UNIF_EQ_UNIF_TWO_POW,REAL_LDISTRIB ] THENL [
		KNOW_TAC `!n. 2 pow  n * (1 / 2) pow  n = 1` THEN1
			PROVE_TAC [REAL_MUL_SYM, HALF_POW_TWO_POW] THEN
		FULL_SIMP_TAC std_ss [pow] THEN
		REWRITE_TAC [GSYM REAL_MUL_ASSOC] THEN
		RW_TAC real_ss [REAL_EQ_LMUL],
		ASM_REWRITE_TAC [pow, GSYM REAL_MUL] THEN
		ONCE_REWRITE_TAC [GSYM REAL_MUL_ASSOC] THEN
		PROVE_TAC [REAL_EQ_LMUL]]]
);

val UNIF_TWO_POW_MONAD = store_thm
  ("UNIF_TWO_POW_MONAD",
  (-- `(unif_two_pow 0 = UNIT (0: num)) /\
        (!n. ((unif_two_pow (SUC n)) =
                BIND (unif_two_pow n)
                        (\m. BIND sdest (\b. UNIT
                                (if b then (2 * m + 1) else 2 * m)))))` --),
	RW_TAC arith_ss [BIND_DEF, UNIT_DEF] THEN
	RW_TAC arith_ss [unif_two_pow_def, GSYM EQ_EXT_EQ] THEN
	RW_TAC arith_ss [o_DEF] THEN
	RW_TAC arith_ss [sdest_def] THEN
	RW_TAC arith_ss [unif_two_pow_def, GSYM EQ_EXT_EQ] THEN
	RW_TAC std_ss [LAMBDA_PAIR]
);

val UNIF_TWO_POW_INDEP = store_thm
  ("UNIF_TWO_POW_INDEP",
  (-- `!n. unif_two_pow n IN indep_fn` --),
	Induct THENL [
	 RW_TAC std_ss [UNIF_TWO_POW_MONAD, INDEP_FN_UNIT],
	 RW_TAC std_ss [UNIF_TWO_POW_MONAD, INDEP_FN_UNIT] THEN
	 MATCH_MP_TAC INDEP_FN_BIND THEN
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC INDEP_FN_BIND THEN
	RW_TAC std_ss [INDEP_FN_UNIT, INDEP_FN_SDEST]]
);

val STD_UNIF_DISC_MONAD = store_thm
  ("STD_UNIF_DISC_MONAD",
  (--`(std_unif_disc 0 = UNIT (0: real)) /\
        (!n. ((std_unif_disc (SUC n)) =
                BIND (std_unif_disc  n)
                        (\m. BIND sdest (\b. UNIT 
				(if b then ((1/2) pow (SUC n) + m) else m)))))` --),
	RW_TAC arith_ss [BIND_DEF, UNIT_DEF] THEN
	RW_TAC arith_ss [std_unif_disc_def, GSYM EQ_EXT_EQ] THEN
	RW_TAC arith_ss [o_DEF] THEN
	RW_TAC arith_ss [sdest_def] THEN
	RW_TAC arith_ss [std_unif_disc_def, GSYM EQ_EXT_EQ] THEN
	RW_TAC std_ss [LAMBDA_PAIR]
);

val STD_UNIF_DISC_INDEP = store_thm
  ("STD_UNIF_DISC_INDEP",
  (--`!n. std_unif_disc n IN indep_fn` --),
	Induct THENL [
	 RW_TAC std_ss [STD_UNIF_DISC_MONAD, INDEP_FN_UNIT],
	 RW_TAC std_ss [STD_UNIF_DISC_MONAD, INDEP_FN_UNIT] THEN
	 MATCH_MP_TAC INDEP_FN_BIND THEN
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC INDEP_FN_BIND THEN
	RW_TAC std_ss [INDEP_FN_UNIT, INDEP_FN_SDEST]]
);

val UB_STD_UNIF_DISC = store_thm
  ("UB_STD_UNIF_DISC",
  (--`!n s.((\n. FST (std_unif_disc n s)) n)  <= 1 - (1/2) pow n` --),
	Induct THENL [
		RW_TAC real_ss [std_unif_disc_def ],
		FULL_SIMP_TAC std_ss [std_unif_disc_def] THEN
		RW_TAC std_ss [] THENL [
			ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
			FULL_SIMP_TAC std_ss  [GSYM REAL_LE_SUB_LADD] THEN
			ONCE_REWRITE_TAC [REAL_SUB_ASSOC] THEN
			PROVE_TAC [REAL_DOUBLE, GSYM POW_HALF_TWICE ],
			KNOW_TAC `1 - (1 / 2) pow n < 1 - (1 / 2) pow SUC n` THENL [
				REWRITE_TAC [REAL_LT_SUB_RADD] THEN
				REWRITE_TAC [pow] THEN
				REWRITE_TAC [ REAL_SUB_ASSOC2] THEN
				REWRITE_TAC [REAL_LT_ADDR] THEN
				REWRITE_TAC [REAL_SUB_LT] THEN
				FULL_SIMP_TAC std_ss [GSYM REAL_LT_RDIV_EQ, POW_HALF_POS] THEN
				FULL_SIMP_TAC std_ss [EQ_SYM_EQ, POW_HALF_POS, REAL_LT_IMP_NE,
					REAL_DIV_REFL, HALF_LT_1 ],
				PROVE_TAC [REAL_LE_TRANS, REAL_LT_IMP_LE]]]]
);

val STD_UNIF_DISC_LT1 = store_thm
  ("STD_UNIF_DISC_LT1",
  (--`!n s.((\n. FST (std_unif_disc n s)) n)  < (1: real)` --),
	REPEAT GEN_TAC THEN
	KNOW_TAC `1 - (1/2) pow n < 1` THEN1
		PROVE_TAC [REAL_LT_ADDR, REAL_LT_SUB_RADD,POW_HALF_POS] THEN
	PROVE_TAC [UB_STD_UNIF_DISC, REAL_LET_TRANS]
);


val LB_STD_UNIF_DISC = store_thm
  ("LB_STD_UNIF_DISC",
  (--`!n s. 0 <= ((\n. FST (std_unif_disc n s)) n)` --),
	Induct THENL [
		RW_TAC std_ss [std_unif_disc_def] THEN
		REWRITE_TAC [REAL_LE_REFL ],
		RW_TAC std_ss [std_unif_disc_def] THENL [
		FULL_SIMP_TAC std_ss [POW_HALF_POS, REAL_LT_IMP_LE, REAL_LE_ADD],
		FULL_SIMP_TAC std_ss []]]
);

val STD_UNIF_DISC_BOUNDED = store_thm
  ("STD_UNIF_DISC_BOUNDED",
  (--`!s. bounded(mr1, $>=) (\n. FST (std_unif_disc n s))` --),
	REWRITE_TAC [SEQ_BOUNDED] THEN
	GEN_TAC THEN
	EXISTS_TAC (--`(1:real)`--) THEN
	PROVE_TAC [LB_STD_UNIF_DISC, STD_UNIF_DISC_LT1, ABS_REFL]
);


val STD_UNIF_DISC_MONO = store_thm
  ("STD_UNIF_DISC_MONO",
  (-- `!m n. m <= n ==> (((\n. FST (std_unif_disc n s)) m <= 
		(\n. FST (std_unif_disc n s)) n))` --),
	GEN_TAC THEN
	Induct THENL [
		RW_TAC real_ss [std_unif_disc_def],
		KNOW_TAC ` SUC n <= n = F` THEN1
			DECIDE_TAC THEN
		FULL_SIMP_TAC std_ss [std_unif_disc_def, LE] THEN
		RW_TAC std_ss [] THEN
		FULL_SIMP_TAC std_ss [std_unif_disc_def, REAL_LE_REFL] THEN
		ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
		ONCE_REWRITE_TAC [GSYM REAL_ADD_RID] THEN
		REWRITE_TAC [GSYM REAL_ADD_ASSOC] THEN
		KNOW_TAC `(1 / 2) pow SUC n + 0 = (1 / 2) pow SUC n` THEN1
			REAL_ARITH_TAC THEN
		FULL_SIMP_TAC std_ss [REAL_LE_ADD2, 
			POW_HALF_POS, REAL_LT_IMP_LE] THEN
		FULL_SIMP_TAC std_ss [std_unif_disc_def, REAL_LE_REFL] THEN
		FULL_SIMP_TAC std_ss [] ]
);

val STD_UNIF_DISC_CONVERGENT = store_thm
  ("STD_UNIF_DISC_CONVERGENT",
  (--`!s. convergent (\n. FST (std_unif_disc n s))` --),
	GEN_TAC THEN
	MATCH_MP_TAC SEQ_BCONV THEN
	CONJ_TAC THEN
	RW_TAC std_ss [STD_UNIF_DISC_BOUNDED] THEN
	REWRITE_TAC [mono] THEN
	RW_TAC std_ss [STD_UNIF_DISC_MONO]
);

val STD_UNIF_DISC_SUCN_N_HALF_POW = store_thm
  ("STD_UNIF_DISC_SUCN_N_HALF_POW",
  (--`!s n.
	(\n. FST (std_unif_disc n s)) (SUC n) <=
		(\n. FST (std_unif_disc n s)) n + (1/2) pow (SUC n)` --),
	GEN_TAC THEN
	Induct THENL [
		RW_TAC real_ss [std_unif_disc_def],
		RW_TAC std_ss [std_unif_disc_def] THENL [
		PROVE_TAC [REAL_LE_REFL, REAL_ADD_ASSOC, REAL_ADD_SYM],
		PROVE_TAC [REAL_LE_REFL,REAL_ADD_SYM],
		PROVE_TAC [REAL_LE_ADDR, POW_HALF_POS, REAL_LT_IMP_LE],
		PROVE_TAC [REAL_LE_ADDR, POW_HALF_POS, REAL_LT_IMP_LE]]]
);


val STD_UNIF_DISC_M_N_SUM_HALF_POW = store_thm
  ("STD_UNIF_DISC_M_N_SUM_HALF_POW",
  (--`!n s m. n < m ==>
         (\n. FST (std_unif_disc n s)) m <=
		(\n. FST (std_unif_disc n s)) n + 
			sum (n, m - n) (\n. (1/2) pow (SUC n))` --),
	GEN_TAC THEN
	GEN_TAC THEN
	Induct THENL [
		RW_TAC arith_ss [],
		REWRITE_TAC [LT_SUC_LTE] THEN
		RW_TAC std_ss [] THENL [
			KNOW_TAC `SUC (m:num) - n = SUC (m - n)` THEN1
				DECIDE_TAC THEN
			FULL_SIMP_TAC arith_ss [sum] THEN
			MATCH_MP_TAC REAL_LE_TRANS THEN
			EXISTS_TAC (--`FST (std_unif_disc m s) + (1/2) pow (SUC m)`--) THEN
			CONJ_TAC THENL [
				PROVE_TAC [STD_UNIF_DISC_SUCN_N_HALF_POW, BETA_THM],
				PROVE_TAC [REAL_LE_RADD, REAL_ADD_ASSOC]],
			KNOW_TAC `SUC (m:num) - m = SUC 0` THEN1
				DECIDE_TAC THEN
			ASM_REWRITE_TAC [sum] THEN
			RW_TAC arith_ss [REAL_LE_LADD, REAL_ADD_LID] THEN
			PROVE_TAC [STD_UNIF_DISC_SUCN_N_HALF_POW, BETA_THM]]]
);


val STD_UNIF_DISC_DIFFERENCE  = store_thm
  ("STD_UNIF_DISC_DIFFERENCE",
  (--`!n s m. n < m ==>
        (\n. FST (std_unif_disc n s)) m  <
             (\n. FST (std_unif_disc n s)) n + (1 / 2) pow n` --),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC REAL_LET_TRANS THEN
	EXISTS_TAC (--`(\n. FST (std_unif_disc n s)) n +
                        sum (n, m - n) (\n. (1/2) pow (SUC n))`--) THEN
	CONJ_TAC THENL [
		PROVE_TAC [STD_UNIF_DISC_M_N_SUM_HALF_POW, BETA_THM],
		RW_TAC std_ss [REAL_LT_LADD] THEN
		ONCE_REWRITE_TAC [SUM_DIFF ] THEN
		FULL_SIMP_TAC arith_ss [] THEN
		REWRITE_TAC [SUM_HALF_POW_SUC] THEN
		ONCE_REWRITE_TAC [REAL_LT_SUB_RADD] THEN
		REWRITE_TAC [GSYM REAL_SUB_ASSOC2] THEN
		KNOW_TAC `!(a:real) b. a - a + b = b ` THEN1
			REAL_ARITH_TAC THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		REWRITE_TAC [REAL_LT_SUB_RADD] THEN
		FULL_SIMP_TAC std_ss [REAL_LT_ADDR, POW_HALF_POS ]]
);

val STD_UNIF_DISC_EQ_EVENTS = store_thm
  ("STD_UNIF_DISC_EQ_EVENTS",
 (--`!n x. {s | FST (std_unif_disc n s) = x} IN events bern`--),
     REPEAT GEN_TAC  THEN
     KNOW_TAC  `{s | FST (std_unif_disc n s) = x} = 
	((\y. y = x) o FST o std_unif_disc n)` THEN1
  			PSET_TAC [o_DEF] THEN
     ASM_REWRITE_TAC [] THEN
     MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
     RW_TAC std_ss [STD_UNIF_DISC_INDEP]);

val STD_UNIF_DISC_LE_EVENTS = store_thm
  ("STD_UNIF_DISC_LE_EVENTS",
 (--`!n x. {s | FST (std_unif_disc n s) <= x} IN events bern`--),
     REPEAT GEN_TAC  THEN
     KNOW_TAC  `{s | FST (std_unif_disc n s) <= x} = 
	((\y. y <= x) o FST o std_unif_disc n)` THEN1
  			PSET_TAC [o_DEF] THEN
     ASM_REWRITE_TAC [] THEN
     MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
     RW_TAC std_ss [STD_UNIF_DISC_INDEP]);

val STD_UNIF_DISC_EQ_EVENTS = store_thm
  ("STD_UNIF_DISC_EQ_EVENTS",
 (--`!n x. {s | FST (std_unif_disc n s) = x} IN events bern`--),
     REPEAT GEN_TAC  THEN
     KNOW_TAC  `{s | FST (std_unif_disc n s) = x} = 
	((\y. y = x) o FST o std_unif_disc n)` THEN1
  			PSET_TAC [o_DEF] THEN
     ASM_REWRITE_TAC [] THEN
     MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
     RW_TAC std_ss [STD_UNIF_DISC_INDEP]);

(*---------------------------------------------------------------------------*)
val std_unif_cont_def = Define `
	std_unif_cont s = lim (\n. FST (std_unif_disc n s))`;


val LB_STD_UNIF_CONT = store_thm
  ("LB_STD_UNIF_CONT",
  (--`!s. 0 <= std_unif_cont s` --),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC LE_SEQ_IMP_LE_LIM THEN
	EXISTS_TAC (--`(\n. FST (std_unif_disc n s))`--) THEN
	RW_TAC std_ss [LB_STD_UNIF_DISC] THEN
	REWRITE_TAC [std_unif_cont_def] THEN
	RW_TAC std_ss [STD_UNIF_DISC_CONVERGENT, GSYM SEQ_LIM]
);


val UB_STD_UNIF_CONT  = store_thm
  ("UB_STD_UNIF_CONT",
  (--`!s. std_unif_cont s <= 1` --),
	GEN_TAC THEN
	MATCH_MP_TAC SEQ_LE_IMP_LIM_LE THEN
	EXISTS_TAC (--`(\n. FST (std_unif_disc n s))`--) THEN
	RW_TAC std_ss [STD_UNIF_DISC_LT1, REAL_LT_IMP_LE] THEN
	REWRITE_TAC [std_unif_cont_def] THEN
	RW_TAC std_ss [STD_UNIF_DISC_CONVERGENT, GSYM SEQ_LIM]
);

val STD_UNIF_CONT_LE_STD_UNIF_DISC_HALF_POW = store_thm
  ("STD_UNIF_CONT_LE_STD_UNIF_DISC_HALF_POW",
  (--`!(s:num -> bool) n. 
	std_unif_cont s <=
		(\n. FST (std_unif_disc n s))n + 
			(1/2) pow n` --),
	GEN_TAC THEN
	Induct THENL [
		RW_TAC std_ss [sum, pow, REAL_ADD_LID,std_unif_disc_def ] THEN
		RW_TAC std_ss [UB_STD_UNIF_CONT],
		MATCH_MP_TAC SEQ_LE_IMP_LIM_LE THEN
		EXISTS_TAC (--`(\n. FST (std_unif_disc n s))`--) THEN
		CONJ_TAC THENL [
			X_GEN_TAC (--`m:num`--) THEN
			Q.SPEC_TAC (`SUC n`, `n`) THEN
			KILL_ALL_TAC THEN
			GEN_TAC THEN
			MP_TAC (SPECL [(--`(n: num)`--), (--`(m:num)`--)]  LESS_CASES) THEN
			RW_TAC std_ss [] THENL [
				PROVE_TAC [STD_UNIF_DISC_DIFFERENCE, REAL_LT_IMP_LE, BETA_THM],
				MATCH_MP_TAC REAL_LE_TRANS THEN
				EXISTS_TAC (--`FST (std_unif_disc n s)`--) THEN
				RW_TAC std_ss [REAL_LE_ADDR, POW_HALF_POS, REAL_LT_IMP_LE] THEN
				PROVE_TAC [STD_UNIF_DISC_MONO, BETA_THM]],
			REWRITE_TAC [std_unif_cont_def] THEN
			RW_TAC std_ss [STD_UNIF_DISC_CONVERGENT, GSYM SEQ_LIM]]]
);

val STD_UNIF_CONT_GE_STD_UNIF_DISC = store_thm
  ("STD_UNIF_CONT_GE_STD_UNIF_DISC",
  (--`!(s:num -> bool) n.
	(\n. FST (std_unif_disc n s))n <= std_unif_cont s` --),
	REPEAT GEN_TAC THEN
	MATCH_MP_TAC SEQ_MONO_LE  THEN
	REWRITE_TAC [GSYM ADD1] THEN
	CONJ_TAC THENL [
		GEN_TAC THEN
		MATCH_MP_TAC STD_UNIF_DISC_MONO THEN
		DECIDE_TAC,
		REWRITE_TAC [std_unif_cont_def] THEN
		RW_TAC std_ss [STD_UNIF_DISC_CONVERGENT, GSYM SEQ_LIM]]
);


(*---------------------------------------------------------------------------*)

val UNIF_DISC_CEIL_SUBSET_CONT = store_thm
  ("UNIF_DISC_CEIL_SUBSET_CONT",
  (--`!x n. (0 <= x) ==> {s | FST (std_unif_disc n s) <= 
	(& (ceiling (2 pow n * x)) - 2) * (1 / 2) pow n}
		SUBSET {s | std_unif_cont s <= x}` --),
	RW_TAC std_ss [] THEN
	REWRITE_TAC [SUBSET_DEF] THEN
	REWRITE_TAC [SPECIFICATION] THEN
	X_GEN_TAC (--`(s:num -> bool)`--) THEN
	PSET_TAC [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`FST (std_unif_disc n s) + (1/2) pow n`--) THEN
	CONJ_TAC THENL [
		PROVE_TAC [STD_UNIF_CONT_LE_STD_UNIF_DISC_HALF_POW, BETA_THM],
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`(& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n`--) THEN
		RW_TAC std_ss [CEILING_2POWNX_MINUS1_LT_XHALF_POW, REAL_LT_IMP_LE] THEN
		REWRITE_TAC [GSYM REAL_LE_SUB_LADD] THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`(& (ceiling (2 pow n * x)) - 2) * (1 / 2) pow n`--) THEN
		ASM_REWRITE_TAC [] THEN
		KNOW_TAC `(& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n - (1 / 2) pow n =
                	((& (ceiling (2 pow n * x)) - 1) - 1 ) * (1 / 2) pow n` THENL [
			FULL_SIMP_TAC std_ss [REAL_SUB_RDISTRIB] THEN
			REWRITE_TAC [REAL_SUB_ASSOC, REAL_MUL_LID],
			RW_TAC real_ss [REAL_SUB_ASSOC, REAL_DOUBLE]]]
);

val CONT_SUBSET_UNIF_DISC_CEIL = store_thm
  ("CONT_SUBSET_UNIF_DISC_CEIL",
  (--`!x n. (0 <= x) ==> {s | std_unif_cont s <= x}
	SUBSET {s | FST (std_unif_disc n s) <= 
		(& (ceiling (2 pow n * x)) * (1 / 2) pow n)}`--),
	RW_TAC std_ss [] THEN
	REWRITE_TAC [SUBSET_DEF] THEN
	REWRITE_TAC [SPECIFICATION] THEN
	X_GEN_TAC (--`(s:num -> bool)`--) THEN
	PSET_TAC [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`std_unif_cont s`--) THEN
	CONJ_TAC THENL [
		PROVE_TAC [STD_UNIF_CONT_GE_STD_UNIF_DISC, BETA_THM],
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`(x:real)`--) THEN
		PROVE_TAC [XHALF_POW_LE_CEILING_2POWNX]]
);

val CONT_SUBSET_UNIF_DISC_LE = store_thm
  ("CONT_SUBSET_UNIF_DISC_LE",
  (--`!x n.{s | std_unif_cont s <= x}
	SUBSET {s | FST (std_unif_disc n s) <= x}`--),
        RW_TAC std_ss [] THEN
	REWRITE_TAC [SUBSET_DEF] THEN
	REWRITE_TAC [SPECIFICATION] THEN
	X_GEN_TAC (--`(s:num -> bool)`--) THEN
	PSET_TAC [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`std_unif_cont s`--) THEN
	CONJ_TAC THENL [
		PROVE_TAC [STD_UNIF_CONT_GE_STD_UNIF_DISC, BETA_THM],
		PROVE_TAC []]
);

val CONT_EQX_SUBSET_UNIF_DISC_CEIL_CEIL_SUB1 = store_thm
  ("CONT_EQX_SUBSET_UNIF_DISC_CEIL_CEIL_SUB1",
  (--`!x n. (0 <= x)  ==>
	{s | std_unif_cont s = x} SUBSET 
		{s | (FST (std_unif_disc n s) =
          & (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
         (FST (std_unif_disc n s) =
          (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)}` --),
	RW_TAC std_ss [] THEN
	REWRITE_TAC [SUBSET_DEF] THEN
	REWRITE_TAC [SPECIFICATION] THEN
	X_GEN_TAC (--`(s:num -> bool)`--) THEN
	PSET_TAC [] THEN
	RW_TAC std_ss [GSYM REAL_LE_ANTISYM] THEN
	RW_TAC std_ss [PROVE [] (--`!a b c d.(a /\ b) \/ (c /\ d) = 
	(a \/ c) /\ (b \/ c) /\ (a \/ d) /\ (b \/ d)`--)] THENL [
		DISJ1_TAC THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`std_unif_cont s`--) THEN
		CONJ_TAC THENL [
			PROVE_TAC [STD_UNIF_CONT_GE_STD_UNIF_DISC],
			RW_TAC std_ss [POW_HALF_POS, GSYM REAL_LE_LDIV_EQ] THEN
			RW_TAC real_ss [real_div, POW_INV, REAL_INV_INV] THEN
			PROVE_TAC [LB_CEILING, REAL_MUL_SYM]],

		RW_TAC std_ss [POW_HALF_POS, GSYM REAL_LE_LDIV_EQ,
					 GSYM REAL_LE_RDIV_EQ] THEN
		RW_TAC real_ss [real_div, POW_INV, REAL_INV_INV,REAL_LE_SUB_LADD ] THEN
			ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
		REWRITE_TAC [TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW, REAL_LE, 
			GSYM LESS_EQ, REAL_ADD, GSYM ADD1] THEN
		RW_TAC std_ss [REAL_LET_TOTAL, GSYM REAL_LT, GSYM REAL_LE],

		DISJ1_TAC THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`std_unif_cont s`--) THEN
		CONJ_TAC THENL [
			PROVE_TAC [STD_UNIF_CONT_GE_STD_UNIF_DISC],
			RW_TAC std_ss [POW_HALF_POS, GSYM REAL_LE_LDIV_EQ] THEN
			RW_TAC real_ss [real_div, POW_INV, REAL_INV_INV] THEN
			PROVE_TAC [LB_CEILING, REAL_MUL_SYM]],

		DISJ2_TAC THEN
		RW_TAC std_ss [POW_HALF_POS,GSYM REAL_LE_RDIV_EQ] THEN
		RW_TAC real_ss [real_div, POW_INV, REAL_INV_INV,REAL_LE_SUB_RADD ] THEN
		ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
		REWRITE_TAC [TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW, REAL_LE, REAL_ADD] THEN
		ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
		UNDISCH_TAC (--`0 <= std_unif_cont s`--) THEN
		RW_TAC std_ss [REAL_LE_LT] THENL [
			KNOW_TAC `ceiling (2 pow n * std_unif_cont s) = 
				SUC (ceiling (2 pow n * std_unif_cont s) - 1)` THENL [
				REWRITE_TAC [ADD1] THEN
				RW_TAC arith_ss [CEIL_TW0_POW_GE_1, SUB_ADD],
			ONCE_ASM_REWRITE_TAC [] THEN
			REWRITE_TAC [GSYM LESS_EQ] THEN
			RW_TAC std_ss [GSYM REAL_LT,GSYM REAL_ADD,
				GSYM TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW] THEN
			KNOW_TAC ` & (ceiling (2 pow n * std_unif_cont s) - 1) = 
				& (ceiling (2 pow n * std_unif_cont s)) - 1` THENL [
				REWRITE_TAC [REAL_SUB_2] THEN
				MP_TAC (Q.SPECL [`std_unif_cont s`, `n`] CEIL_TW0_POW_GE_1) THEN
				RW_TAC std_ss [],
				ONCE_ASM_REWRITE_TAC [] THEN
				KNOW_TAC `2 pow n * FST (std_unif_disc n s) + 1 = 
					2 pow n * (FST (std_unif_disc n s) + (1/2) pow n)` THEN1
				FULL_SIMP_TAC real_ss [real_div, REAL_MUL_RINV, 
					REAL_ADD_LDISTRIB, POW_ONE,
						REAL_POW_LT, REAL_LT_IMP_NE, EQ_SYM_EQ] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
				FULL_SIMP_TAC real_ss [GSYM REAL_LT_LDIV_EQ, REAL_POW_LT, 
					ADD1, REAL_LT_IMP_NE, EQ_SYM_EQ] THEN
				KNOW_TAC `ceiling (std_unif_cont s * 2 pow n) - 1 + 1 = 
					 ceiling (2 pow n * std_unif_cont s)` THENL [
					ONCE_ASM_REWRITE_TAC [] THEN
					PROVE_TAC [REAL_MUL_SYM],
					ONCE_ASM_REWRITE_TAC [] THEN
					KNOW_TAC `!x. x / 2 pow n = x * (1/2) pow n` THEN1
						RW_TAC real_ss [real_div, POW_ONE] THEN
					ONCE_ASM_REWRITE_TAC [] THEN
					REWRITE_TAC [POW_ONE, REAL_MUL_LID] THEN
					MATCH_MP_TAC REAL_LTE_TRANS THEN
					EXISTS_TAC (--`std_unif_cont s`--) THEN
					RW_TAC std_ss [CEILING_2POWNX_MINUS1_LT_XHALF_POW, 
							REAL_LT_IMP_LE] THEN
					PROVE_TAC [STD_UNIF_CONT_LE_STD_UNIF_DISC_HALF_POW]]]],
				UNDISCH_TAC (--`0 = std_unif_cont s`--) THEN
				ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
				RW_TAC real_ss [CEILING_NUM]]]
);


(*---------------------------------------------------------------------------*)

val all_std_unif_disc_le_def = Define `
	all_std_unif_disc_le x = IMAGE (\n. {s | FST (std_unif_disc n s) <= x}) UNIV`;

val all_std_unif_disc_eq_def = Define `
	all_std_unif_disc_eq x = IMAGE (\n. {s | (FST (std_unif_disc n s) =
          & (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
         (FST (std_unif_disc n s) =
          (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)}) UNIV`;


val IN_ALL_STD_UNIF_DISC_LE = store_thm
  ("IN_ALL_STD_UNIF_DISC_LE",
  (--`!x n. {s |  FST (std_unif_disc n s) <= x} IN all_std_unif_disc_le x`--),
  RW_TAC std_ss [all_std_unif_disc_le_def, IMAGE_DEF, IN_UNIV] THEN
  SRW_TAC [][EXTENSION] THEN
  PROVE_TAC []);

val ALL_STD_UNIF_DISC_LE_ELEMENTS  = store_thm
  ("ALL_STD_UNIF_DISC_LE_ELEMENTS",
 (--`!a x. a IN (all_std_unif_disc_le x) ==> 
	?n. a = {s |  FST (std_unif_disc n s) <= x}`--),
  REPEAT GEN_TAC THEN
  REWRITE_TAC [all_std_unif_disc_le_def, IMAGE_DEF, IN_UNIV] THEN
  SRW_TAC [][EXTENSION]);

val ALL_STD_UNIF_DISC_LE_COUNTABLE = store_thm
  ("ALL_STD_UNIF_DISC_LE_COUNTABLE",
   (--`!x. countable (all_std_unif_disc_le x)`--),
  RW_TAC std_ss [all_std_unif_disc_le_def, COUNTABLE_IMAGE_NUM]);

val BIGINTER_ALL_STD_UNIF_DISC_LE_EVENTS_BERN = store_thm
  ("BIGINTER_ALL_STD_UNIF_DISC_LE_EVENTS_BERN",
  (--`!(x:real). BIGINTER (all_std_unif_disc_le x) IN events bern`--),
	GEN_TAC THEN
	MATCH_MP_TAC EVENTS_COUNTABLE_INTER THEN
	RW_TAC std_ss [ALL_STD_UNIF_DISC_LE_COUNTABLE, PROB_SPACE_BERN, SUBSET_DEF, IN_IMAGE] THEN
	KNOW_TAC `?n. x' = {s | FST (std_unif_disc n s) <= x}` THEN1
		RW_TAC std_ss [ALL_STD_UNIF_DISC_LE_ELEMENTS] THEN
	ASM_REWRITE_TAC [STD_UNIF_DISC_LE_EVENTS]);

val STD_UNIF_CONT_BIGINTER_ALL_STD_UNIF_LE = store_thm
  ("STD_UNIF_CONT_BIGINTER_ALL_STD_UNIF_LE",
  (--`!x. {s | std_unif_cont s <= x} =
                BIGINTER (all_std_unif_disc_le x)`--),
  RW_TAC std_ss [all_std_unif_disc_le_def, EXTENSION, 
			IN_BIGINTER_IMAGE, IN_UNIV] THEN
  EQ_TAC THENL [
  MP_TAC CONT_SUBSET_UNIF_DISC_LE THEN
  FULL_SIMP_TAC std_ss [SUBSET_DEF],
  REWRITE_TAC [SPECIFICATION] THEN
  PSET_TAC [std_unif_cont_def] THEN
  MATCH_MP_TAC SEQ_LE_IMP_LIM_LE THEN
  EXISTS_TAC (--`(\n. FST (std_unif_disc n x'))`--) THEN
  RW_TAC std_ss [] THEN
  RW_TAC std_ss [STD_UNIF_DISC_CONVERGENT, GSYM SEQ_LIM]]);

val STD_UNIF_CONT_LE_EVENTS_BERN = store_thm
  ("STD_UNIF_CONT_EVENTS_BERN",
  (--`!x. {s | std_unif_cont s <= x} IN events bern`--),
  RW_TAC std_ss [STD_UNIF_CONT_BIGINTER_ALL_STD_UNIF_LE, BIGINTER_ALL_STD_UNIF_DISC_LE_EVENTS_BERN]);


val ALL_STD_UNIF_DISC_EQ_ELEMENTS  = store_thm
  ("ALL_STD_UNIF_DISC_EQ_ELEMENTS",
 (--`!a x. a IN (all_std_unif_disc_eq x) ==> 
	?n. a = {s | (FST (std_unif_disc n s) =
          & (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
         (FST (std_unif_disc n s) =
          (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)}`--),
  REPEAT GEN_TAC THEN
  REWRITE_TAC [all_std_unif_disc_eq_def, IMAGE_DEF, IN_UNIV] THEN
  SRW_TAC [][EXTENSION]);


val ALL_STD_UNIF_DISC_EQ_COUNTABLE = store_thm
  ("ALL_STD_UNIF_DISC_EQ_COUNTABLE",
   (--`!x. countable (all_std_unif_disc_eq x)`--),
  RW_TAC std_ss [all_std_unif_disc_eq_def, COUNTABLE_IMAGE_NUM]);

val BIGINTER_ALL_STD_UNIF_DISC_EQ_EVENTS_BERN = store_thm
  ("BIGINTER_ALL_STD_UNIF_DISC_EQ_EVENTS_BERN",
  (--`!(x:real). BIGINTER (all_std_unif_disc_eq x) IN events bern`--),
	GEN_TAC THEN
	MATCH_MP_TAC EVENTS_COUNTABLE_INTER THEN
	RW_TAC std_ss [ALL_STD_UNIF_DISC_EQ_COUNTABLE, PROB_SPACE_BERN, SUBSET_DEF, IN_IMAGE] THEN
	KNOW_TAC `?n. x' = {s | (FST (std_unif_disc n s) =
          & (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
         (FST (std_unif_disc n s) =
          (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)}` THEN1
		RW_TAC std_ss [ALL_STD_UNIF_DISC_EQ_ELEMENTS] THEN
                ASM_REWRITE_TAC [] THEN
                KNOW_TAC `{s |
     		(FST (std_unif_disc n s) =
      		& (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
     		(FST (std_unif_disc n s) =
      		(& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)} = 
		{s |
     		(FST (std_unif_disc n s) = & (ceiling (2 pow n * x)) * (1 / 2) pow n)} UNION
		{s |
     		(FST (std_unif_disc n s) = (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)}` THENL [
				PSET_TAC [],
				ONCE_ASM_REWRITE_TAC [] THEN
				MATCH_MP_TAC EVENTS_UNION THEN
				RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_DISC_EQ_EVENTS]]);


val STD_UNIF_CONT_BIGINTER_ALL_STD_UNIF_EQ_GE0 = store_thm
  ("STD_UNIF_CONT_BIGINTER_ALL_STD_UNIF_EQ_GE0",
  (--`!x. 0 <= x ==> ({s | std_unif_cont s = x} =
                BIGINTER (all_std_unif_disc_eq x))`--),
  RW_TAC std_ss [all_std_unif_disc_eq_def, EXTENSION, 
			IN_BIGINTER_IMAGE, IN_UNIV] THEN
  EQ_TAC THENL [
  MP_TAC CONT_EQX_SUBSET_UNIF_DISC_CEIL_CEIL_SUB1 THEN
  FULL_SIMP_TAC std_ss [SUBSET_DEF],
  REWRITE_TAC [SPECIFICATION] THEN
  PSET_TAC [std_unif_cont_def] THEN
  REWRITE_TAC [GSYM REAL_LE_ANTISYM] THEN
  CONJ_TAC THENL [
	MATCH_MP_TAC SEQ_LE THEN
        EXISTS_TAC (--`(\n. FST (std_unif_disc n x'))`--) THEN
	EXISTS_TAC (--`(\n. & (ceiling (2 pow n * x)) * (1 / 2) pow n)`--) THEN
        RW_TAC std_ss [CEILING_TWO_POWNX_TENDSTO_X, STD_UNIF_DISC_CONVERGENT, GSYM SEQ_LIM] THEN
        EXISTS_TAC (--`0:num`--) THEN
        RW_TAC arith_ss [] THEN
        POP_ASSUM (MP_TAC o Q.SPEC `n`) THEN
        RW_TAC std_ss [] THENL [
	FULL_SIMP_TAC std_ss [REAL_LE_REFL],
	FULL_SIMP_TAC std_ss [REAL_SUB_RDISTRIB, REAL_LE_SUB_RADD, REAL_LE_ADDR,
	REAL_POW_LT, HALF_POS, REAL_LT_IMP_LE, REAL_MUL_LID]],

	MATCH_MP_TAC SEQ_LE THEN
        EXISTS_TAC (--`(\n. (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)`--) THEN
        EXISTS_TAC (--`(\n. FST (std_unif_disc n x'))`--) THEN
        RW_TAC std_ss [STD_UNIF_DISC_CONVERGENT, GSYM SEQ_LIM] THENL [
        	UNDISCH_TAC (--`0 <= x`--) THEN
		RW_TAC std_ss [REAL_LE_LT] THENL [
			KNOW_TAC `!n. & (ceiling (2 pow n * x)) - 1 = 
					& (ceiling (2 pow n * x) - 1)` THEN1
				(REWRITE_TAC [REAL_SUB_2] THEN
				RW_TAC std_ss [CEIL_TW0_POW_GE_1]) THEN
                        ASM_REWRITE_TAC [] THEN
                        RW_TAC std_ss [CEILING_TWO_POWNX_MINUS_ONE_TENDSTO_X, REAL_LT_IMP_LE],    
                        RW_TAC std_ss [REAL_MUL_RZERO, CEILING_NUM, 
					REAL_MUL_LZERO, REAL_SUB_LZERO] THEN
                        KNOW_TAC `0 = ~1 * 0` THEN1 RW_TAC real_ss [] THEN
                        KNOW_TAC `(\n. ~1 * (1 / 2) pow n) = 
				(\n. (\n. ~1)n * (\n.(1 / 2) pow n)n)` THEN1 RW_TAC std_ss [] THEN
			ONCE_ASM_REWRITE_TAC [] THEN
                        MATCH_MP_TAC SEQ_MUL THEN
                        RW_TAC std_ss [SEQ_CONST] THEN
                        MATCH_MP_TAC SEQ_POWER THEN
                        RW_TAC real_ss [abs]],

		EXISTS_TAC (--`0:num`--) THEN
		RW_TAC arith_ss [] THEN
		POP_ASSUM (MP_TAC o Q.SPEC `n`) THEN
		RW_TAC std_ss [] THENL [
		FULL_SIMP_TAC std_ss [REAL_SUB_RDISTRIB, REAL_LE_SUB_RADD, REAL_LE_ADDR,
			REAL_POW_LT, HALF_POS, REAL_LT_IMP_LE, REAL_MUL_LID],
		FULL_SIMP_TAC std_ss [REAL_LE_REFL]]]]]);

val STD_UNIF_CONT_EQ_EVENTS_BERN_GE0 = store_thm
  ("STD_UNIF_CONT_EQ_EVENTS_BERN_GE0",
  (--`!x. 0 <= x ==> ({s | std_unif_cont s = x} IN events bern)`--),
  RW_TAC std_ss [STD_UNIF_CONT_BIGINTER_ALL_STD_UNIF_EQ_GE0, BIGINTER_ALL_STD_UNIF_DISC_EQ_EVENTS_BERN]);

val STD_UNIF_CONT_EQ_EVENTS_BERN_LT1 = store_thm
  ("STD_UNIF_CONT_EQ_EVENTS_BERN_LT1",
  (--`!x. x < 0 ==> ({s | std_unif_cont s = x} IN events bern)`--),
  RW_TAC std_ss [] THEN
  KNOW_TAC `{s | std_unif_cont s = x} = {}` THENL [
  REWRITE_TAC [GSYM GSPEC_F] THEN
  REWRITE_TAC [SPECIFICATION] THEN
  PSET_TAC []  THEN
  DISJ2_TAC THEN
  REWRITE_TAC [REAL_NE_LT_GT] THEN
  DISJ2_TAC THEN
  MATCH_MP_TAC REAL_LTE_TRANS THEN
  EXISTS_TAC (--`0:real`--) THEN
  RW_TAC std_ss [LB_STD_UNIF_CONT],
  RW_TAC std_ss [EVENTS_EMPTY, PROB_SPACE_BERN]]);

val STD_UNIF_CONT_EQ_EVENTS_BERN = store_thm
  ("STD_UNIF_CONT_EQ_EVENTS_BERN",
  (--`!x. ({s | std_unif_cont s = x} IN events bern)`--),
  REPEAT GEN_TAC THEN
  MP_TAC (Q.SPECL [`x`, `0`] REAL_LTE_TOTAL) THEN
  RW_TAC std_ss [] THENL [
  RW_TAC std_ss [STD_UNIF_CONT_EQ_EVENTS_BERN_LT1],
  RW_TAC std_ss [STD_UNIF_CONT_EQ_EVENTS_BERN_GE0]]);

val STD_UNIF_CONT_LT_EVENTS_BERN = store_thm
  ("STD_UNIF_CONT_LT_EVENTS_BERN",
  (--`!x. ({s | std_unif_cont s < x} IN events bern)`--),
  GEN_TAC THEN
  KNOW_TAC `{s | std_unif_cont s < x} = 
	{s | std_unif_cont s <= x} DIFF {s | std_unif_cont s = x}` THENL [
 	PSET_TAC [DIFF_DEF, REAL_LE_LT, RIGHT_AND_OVER_OR] THEN
        RW_TAC std_ss  [REAL_NE_LT_GT, LEFT_AND_OVER_OR, REAL_LT_ANTISYM],
  	ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC EVENTS_DIFF THEN
	RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN, STD_UNIF_CONT_LE_EVENTS_BERN]]);


val PROB_UNIF_DISC_CEIL_LE_PROB_CONT = store_thm
  ("PROB_UNIF_DISC_CEIL_LE_PROB_CONT",
  (--`!x n. (0 <= x) ==> (prob bern {s | FST (std_unif_disc n s) <=
        (& (ceiling (2 pow n * x)) - 2) * (1 / 2) pow n} 
					<= prob bern {s | std_unif_cont s <= x})` --),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC PROB_INCREASING THEN
	RW_TAC std_ss [UNIF_DISC_CEIL_SUBSET_CONT, PROB_SPACE_BERN,
			STD_UNIF_DISC_LE_EVENTS, STD_UNIF_CONT_LE_EVENTS_BERN]
);


val PROB_CONT_LE_PROB_UNIF_DISC_CEIL  = store_thm
  ("PROB_CONT_LE_PROB_UNIF_DISC_CEIL",
  (--`!x n. (0 <= x) ==> prob bern {s | std_unif_cont s <= x}
        <= prob bern {s | FST (std_unif_disc n s) <=
                (& (ceiling (2 pow n * x)) * (1 / 2) pow n) }` --),
        RW_TAC std_ss [] THEN
	MATCH_MP_TAC PROB_INCREASING THEN
	RW_TAC std_ss [CONT_SUBSET_UNIF_DISC_CEIL, PROB_SPACE_BERN,
			STD_UNIF_DISC_LE_EVENTS, STD_UNIF_CONT_LE_EVENTS_BERN]
);

val PROB_CONT_EQX_LE_PROB_DISC_CEIL_CEIL_SUB1 = store_thm
  ("PROB_CONT_EQX_LE_PROB_DISC_CEIL_CEIL_SUB1",
  (--`!x n. (0 <= x)  ==> prob bern {s | std_unif_cont s = x}
        <= prob bern {s | (FST (std_unif_disc n s) =
          & (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
         (FST (std_unif_disc n s) =
          (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)}` --),
	RW_TAC std_ss [] THEN
        MATCH_MP_TAC PROB_INCREASING THEN
	RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN,
			CONT_EQX_SUBSET_UNIF_DISC_CEIL_CEIL_SUB1] THEN
        KNOW_TAC `{s |
     		(FST (std_unif_disc n s) =
      		& (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
     		(FST (std_unif_disc n s) =
      		(& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)} = 
		{s |
     		(FST (std_unif_disc n s) = & (ceiling (2 pow n * x)) * (1 / 2) pow n)} UNION
		{s |
     		(FST (std_unif_disc n s) = (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)}` THENL [
				PSET_TAC [],
				ONCE_ASM_REWRITE_TAC [] THEN
				MATCH_MP_TAC EVENTS_UNION THEN
				RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_DISC_EQ_EVENTS]]);



(*---------------------------------------------------------------------------*)


val CDF_UNIF_DISC_LT0 = store_thm
  ("CDF_UNIF_DISC_LT0",
  (--`!n x. x < 0 ==>
        (prob bern {s | FST (std_unif_disc n s) <= x} = 0)` --),
	RW_TAC std_ss [] THEN
	KNOW_TAC `!s. x < FST (std_unif_disc n s)` THENL [
		GEN_TAC THEN
		MATCH_MP_TAC REAL_LTE_TRANS THEN
		EXISTS_TAC (--`(0:real)`--) THEN
		ASM_REWRITE_TAC [] THEN
		PROVE_TAC [LB_STD_UNIF_DISC, BETA_THM],
		FULL_SIMP_TAC std_ss [real_lt] THEN
		REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
		MATCH_MP_TAC RAND_THM THEN
		PSET_TAC [EMPTY_DEF]]
);


val PMF_UNIF_DISC_LT0 = store_thm
  ("PMF_UNIF_DISC_LT0",
  (--`!n x. x < 0 ==>
        (prob bern {s | FST (std_unif_disc n s) = x} = 0)`--),
	RW_TAC std_ss [] THEN
	REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
	MATCH_MP_TAC RAND_THM THEN
	PSET_TAC [EMPTY_DEF] THEN
	RW_TAC std_ss [REAL_NE_LT_GT] THEN
	DISJ2_TAC THEN
        DISJ2_TAC THEN
	MATCH_MP_TAC REAL_LTE_TRANS THEN
	EXISTS_TAC (--`(0:real)`--) THEN
	ASM_REWRITE_TAC [] THEN
	PROVE_TAC [LB_STD_UNIF_DISC, BETA_THM]
);


val CDF_UNIF_DISC_GE1 = store_thm
  ("CDF_UNIF_DISC_GE1",
  (--`!n x. 1 <= x ==>
        (prob bern {s | FST (std_unif_disc n s) <= x} = 1)` --),
	RW_TAC std_ss [] THEN
	KNOW_TAC `!s. FST (std_unif_disc n s) <= x` THENL [
		GEN_TAC THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`(1:real)`--) THEN
		PROVE_TAC [STD_UNIF_DISC_LT1, REAL_LT_IMP_LE],
                REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
                MATCH_MP_TAC RAND_THM THEN
	        PSET_TAC  [UNIV_DEF]]
);


val PMF_UNIF_DISC_GE1 = store_thm
  ("PMF_UNIF_DISC_GE1",
  (--`!n x. 1 <= x ==>
        (prob bern {s | FST (std_unif_disc n s) = x} = 0)` --),
	RW_TAC std_ss [] THEN
	REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
	MATCH_MP_TAC RAND_THM THEN
	PSET_TAC [EMPTY_DEF] THEN
	DISJ2_TAC THEN
	RW_TAC std_ss [REAL_NE_LT_GT] THEN
	DISJ1_TAC THEN
	MATCH_MP_TAC REAL_LTE_TRANS THEN
	EXISTS_TAC (--`(1:real)`--) THEN
	ASM_REWRITE_TAC [] THEN
	PROVE_TAC [STD_UNIF_DISC_LT1]
);


val PMF_STD_UNIF_DISC_GE0_LT1 = store_thm
  ("PMF_STD_UNIF_DISC_GE0_LT1",
  (--`!n m. (m < (2 ** n)) ==>
         (prob bern {s | FST (std_unif_disc n s) = &m / & (2 ** n)} =
                                                1 / & (2 ** n))` --),
	Induct THENL [
	RW_TAC arith_ss [EXP, std_unif_disc_def] THEN
	KNOW_TAC `m = 0` THEN1
		DECIDE_TAC THEN
        RW_TAC real_ss [] THEN
        REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
        MATCH_MP_TAC RAND_THM THEN
	PSET_TAC [UNIV_DEF],

	RW_TAC std_ss [] THEN
	SUFF_TAC `prob bern {s | FST (std_unif_disc (SUC n) s) = & m / & (2 ** SUC n)} = 
			1 / 2 * prob bern {s | FST (std_unif_disc n s) = &(m DIV 2) / & (2 ** n)}` THENL [
		STRIP_TAC THEN
		ASM_REWRITE_TAC [] THEN
		KNOW_TAC `(m DIV 2) < 2 ** n` THENL [	
			REWRITE_TAC [GSYM REAL_LT] THEN
			MATCH_MP_TAC REAL_LET_TRANS THEN
			EXISTS_TAC (--`&m/2`--) THEN
			FULL_SIMP_TAC real_ss [REAL_LT_LDIV_EQ, EXP, REAL_MUL_SYM] THEN
			RW_TAC real_ss [REAL_LE_RDIV_EQ] THEN
			ONCE_REWRITE_TAC [MULT_SYM] THEN
			MATCH_MP_TAC LESS_EQ_TRANS THEN
			EXISTS_TAC (--`2 * (m DIV 2) + (m MOD 2)`--) THEN
			RW_TAC arith_ss [LESS_EQ_REFL, LESS_EQ_ADD, GSYM DIV_TWO],

			FULL_SIMP_TAC std_ss [] THEN
			REWRITE_TAC [GSYM REAL_MUL, real_div, REAL_MUL_LID, EXP, GSYM REAL_MUL] THEN
			ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
			MATCH_MP_TAC REAL_INV_MUL THEN
			KNOW_TAC `!m. 0 < 2 ** m` THEN1
				PROVE_TAC [TWO, ZERO_LESS_EXP] THEN
			FULL_SIMP_TAC std_ss [GSYM REAL_LT, GSYM REAL_LT_NZ] THEN
			RW_TAC real_ss []],

		KILL_ALL_TAC THEN
		RW_TAC std_ss [GSYM REAL_POW] THEN
		RW_TAC real_ss [REAL_POW_LT, REAL_EQ_RDIV_EQ] THEN
		KNOW_TAC `!n s. FST (std_unif_disc n s) * 2 pow n = & (FST (unif_two_pow n s))` THENL [
			REPEAT GEN_TAC THEN
			ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
			RW_TAC std_ss [TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW],

			ASM_REWRITE_TAC [] THEN
			RW_TAC std_ss [unif_two_pow_def] THEN
			(CONV_TAC o RATOR_CONV o ONCE_REWRITE_CONV) [EQ_SYM_EQ] THEN
			RW_TAC std_ss [COND_RAND, COND_EXPAND] THEN
			(CONV_TAC o RATOR_CONV o ONCE_REWRITE_CONV) [EQ_SYM_EQ] THEN
			RW_TAC std_ss [LEFT_AND_OVER_OR, RIGHT_AND_OVER_OR] THEN
			RW_TAC std_ss [PROVE [] (--`~X /\ X = F`--)] THEN
			RW_TAC std_ss [PROVE [] (--`~a /\ c \/ b /\ a \/ b /\ c =
                                        a /\ b \/ ~a /\ c`--)] THEN
			MP_TAC (Q.SPEC `m` EVEN_ODD_EXISTS_EQ) THEN
			MP_TAC (Q.SPEC `m` EVEN_OR_ODD) THEN
			STRIP_TAC THENL [
				RW_TAC std_ss [] THEN
				RW_TAC std_ss [DIV_TWO_CANCEL] THEN
				REWRITE_TAC [REAL_OF_NUM_EQ] THEN
				KNOW_TAC `!(k:num) m. ~(2 * k + 1 = 2 * m)` THENL [
					REPEAT STRIP_TAC THEN
					SUFF_TAC `~(SUC (2 * k) = 2 * m)` THEN1
						DECIDE_TAC THEN
					PROVE_TAC [EVEN_DOUBLE, ODD_DOUBLE, EVEN_ODD],

					RW_TAC std_ss [DECIDE (--`(2:num * a = 2 * b) = (a = b)`--)] THEN
					SUFF_TAC `prob bern ($= m' o FST o unif_two_pow n 
						INTER halfspace F o SND o unif_two_pow n) =  
						1 / 2 * prob bern {s | FST (unif_two_pow n s) = m'}` THENL [
							DISCH_THEN (MP_TAC o SYM) THEN
							RW_TAC std_ss [] THEN
							MATCH_MP_TAC RAND_THM THEN
							PSET_TAC [o_DEF] THEN
                                                        FULL_SIMP_TAC bool_ss [halfspace_def, CONJ_SYM] THEN
							PROVE_TAC [EQ_SYM_EQ],
							

							MP_TAC (Q.SPECL [`unif_two_pow n`, `$= m'`, `halfspace F`] 							  (INST_TYPE [alpha |-> numSyntax.num] INDEP_FN_PROB)) THEN
							RW_TAC std_ss [UNIF_TWO_POW_INDEP, 
                                                               EVENTS_BERN_BASIC, PROB_BERN_BASIC] THEN
                                                        SUFF_TAC `$= m' o FST o unif_two_pow n = 
								{s | FST (unif_two_pow n s) = m'}`
								   THEN1 RW_TAC std_ss [REAL_MUL_SYM, o_DEF] THEN
							SET_EQ_TAC THEN
    							RW_TAC std_ss [GSPECIFICATION] THEN
    							RW_TAC std_ss [SPECIFICATION, o_THM] THEN
    							PROVE_TAC [EQ_SYM_EQ]]],


				RW_TAC std_ss [] THEN
				RW_TAC std_ss [DIV_TWO_CANCEL] THEN
				REWRITE_TAC [REAL_OF_NUM_EQ] THEN
				KNOW_TAC `!k m. ~(2 * k = SUC (2 * m))` THEN1
					PROVE_TAC [EVEN_DOUBLE, ODD_DOUBLE, EVEN_ODD] THEN
				RW_TAC std_ss [DECIDE (--`(2 * a + 1 = SUC (2 * b)) = (a = b)`--)] THEN
				SUFF_TAC `prob bern ($= m' o FST o unif_two_pow n 
					INTER halfspace T o SND o unif_two_pow n) =
                                                1 / 2 * prob bern {s | FST (unif_two_pow n s) = m'}` THENL [
					DISCH_THEN (MP_TAC o SYM) THEN
					RW_TAC std_ss [] THEN
					MATCH_MP_TAC RAND_THM THEN
					PSET_TAC [o_DEF] THEN
                                        FULL_SIMP_TAC bool_ss [halfspace_def, CONJ_SYM] THEN
					PROVE_TAC [EQ_SYM_EQ],

					MP_TAC (Q.SPECL [`unif_two_pow n`, `$= m'`, `halfspace T`] 							  (INST_TYPE [alpha |-> numSyntax.num] INDEP_FN_PROB)) THEN
					RW_TAC std_ss [UNIF_TWO_POW_INDEP, 
                                                     EVENTS_BERN_BASIC, PROB_BERN_BASIC] THEN
                                        SUFF_TAC `$= m' o FST o unif_two_pow n = 										{s | FST (unif_two_pow n s) = m'}`										   THEN1 RW_TAC std_ss [REAL_MUL_SYM, o_DEF] THEN
					SET_EQ_TAC THEN
    					RW_TAC std_ss [GSPECIFICATION] THEN
    					RW_TAC std_ss [SPECIFICATION, o_THM] THEN
  					PROVE_TAC [EQ_SYM_EQ]]]]]]

);

val CDF_UNIF_DISC_GE0_LT1 = store_thm
  ("CDF_UNIF_DISC_GE0_LT1",
  (--`!n m. (m < (2 ** n)) ==>
         	(prob bern {s | FST (std_unif_disc n s) <= &m / & (2 ** n)} = 
				&(SUC m) / & (2 ** n))`--),
	GEN_TAC THEN
	Induct THENL [
		RW_TAC real_ss [REAL_LE_LT] THEN
		KNOW_TAC `prob bern {s | FST (std_unif_disc n s) < 0 \/ (FST (std_unif_disc n s) = 0)} =
                				prob bern {s | (FST (std_unif_disc n s) = 0)}` THENL [
			MATCH_MP_TAC RAND_THM THEN
                        PSET_TAC [] THEN
			KNOW_TAC `!s. FST (std_unif_disc n s) < 0 = F` THEN1
				PROVE_TAC [REAL_NOT_LT, LB_STD_UNIF_DISC] THEN
			PROVE_TAC [],

			ASM_REWRITE_TAC [] THEN
			MP_TAC (Q.SPECL [`n`, `0`] PMF_STD_UNIF_DISC_GE0_LT1) THEN
			RW_TAC real_ss []],

		RW_TAC std_ss [] THEN
		Q.PAT_ASSUM `X ==> Y` MP_TAC THEN
		KNOW_TAC `m < 2 ** n` THEN1
			RW_TAC arith_ss [] THEN
		POP_ASSUM (fn th => RW_TAC std_ss [th]) THEN
		KNOW_TAC `{s | FST (std_unif_disc n s) <= & (SUC m) / & (2 ** n)} = 
			{s | FST (std_unif_disc n s) <= & m / & (2 ** n)} UNION
			     {s | FST (std_unif_disc n s) = & (SUC m) / & (2 ** n)}` THENL [
			PSET_TAC [o_DEF] THEN
			REWRITE_TAC [GSYM REAL_MUL, real_div, REAL_MUL_LID, EXP, GSYM REAL_MUL] THEN
			RW_TAC std_ss [GSYM REAL_POW] THEN
			RW_TAC real_ss [GSYM real_div, REAL_LE_RDIV_EQ, REAL_EQ_RDIV_EQ, REAL_POW_LT] THEN
			KNOW_TAC `!n s. FST (std_unif_disc n s) * 2 pow n = & (FST (unif_two_pow n s))` THENL [
				REPEAT GEN_TAC THEN
				ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
				RW_TAC std_ss [TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW],

				ASM_REWRITE_TAC [] THEN
				RW_TAC arith_ss [REAL_LE, REAL_OF_NUM_EQ]],
			POP_ASSUM (fn th => RW_TAC std_ss [th]) THEN
			KNOW_TAC  `prob bern ({s | FST (std_unif_disc n s) <= & m / & (2 ** n)} UNION
       				{s | FST (std_unif_disc n s) = & (SUC m) / & (2 ** n)}) =
				prob bern ({s | FST (std_unif_disc n s) <= & m / & (2 ** n)}) +
				prob bern ({s | FST (std_unif_disc n s) = & (SUC m) / & (2 ** n)})` THENL [
		 	KNOW_TAC  `prob bern ({s | FST (std_unif_disc n s) <= & m / & (2 ** n)} UNION
       				{s | FST (std_unif_disc n s) = & (SUC m) / & (2 ** n)}) =
    				prob bern ((\x.  x <= & m / & (2 ** n)) o FST o std_unif_disc n UNION
				(\x. x = & (SUC m) / & (2 ** n)) o FST o std_unif_disc n)` THENL [
			MATCH_MP_TAC RAND_THM THEN
  			PSET_TAC [o_DEF],
 			KNOW_TAC  `prob bern ({s | FST (std_unif_disc n s) <= & m / & (2 ** n)}) = 
			         prob bern ((\x. x <= & m / & (2 ** n)) o FST o std_unif_disc n)` THENL	[
			MATCH_MP_TAC RAND_THM THEN
  			PSET_TAC [o_DEF],
                        KNOW_TAC  `prob bern ({s | FST (std_unif_disc n s) = & (SUC m) / & (2 ** n)}) = 
				prob bern ((\x. x = & (SUC m) / & (2 ** n)) o FST o std_unif_disc n)` THENL [
			MATCH_MP_TAC RAND_THM THEN
  			PSET_TAC [o_DEF],
			ASM_REWRITE_TAC [] THEN
			MATCH_MP_TAC PROB_ADDITIVE THEN
			ASSUME_TAC (Q.SPEC `n` STD_UNIF_DISC_INDEP) THEN
			RW_TAC std_ss [INDEP_FN_FST_EVENTS, PROB_SPACE_BERN] THEN
			KILL_TAC THEN
                        PSET_TAC [o_DEF] THEN
			RW_TAC std_ss [GSYM REAL_POW] THEN
			RW_TAC real_ss [GSYM real_div, REAL_LE_RDIV_EQ,
					 REAL_EQ_RDIV_EQ, REAL_POW_LT] THEN
			KNOW_TAC `!n s. FST (std_unif_disc n s) * 2 pow n = 
							& (FST (unif_two_pow n s))` THENL [
			REPEAT GEN_TAC THEN
			ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
			RW_TAC std_ss [TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW],

			ASM_REWRITE_TAC [] THEN
			RW_TAC arith_ss [REAL_LE, REAL_OF_NUM_EQ] THEN
					
			RW_TAC arith_ss [DISJOINT_DEF, INTER_DEF] THEN
			REWRITE_TAC [EMPTY_DEF] THEN
			RW_TAC std_ss [SPECIFICATION] THEN
			RW_TAC arith_ss [] THEN
			PSET_TAC []]]]],
			ASM_REWRITE_TAC [] THEN
			RW_TAC std_ss [PMF_STD_UNIF_DISC_GE0_LT1] THEN
			RW_TAC std_ss [PMF_STD_UNIF_DISC_GE0_LT1, REAL_DIV_ADD, GSYM ADD1, REAL_ADD]]]]);















val PROB_UNIF_DISC_CEIL_TWO_POW_BY_TWO_POW = store_thm
  ("PROB_UNIF_DISC_CEIL_TWO_POW_BY_TWO_POW",
  (--`!x n. (0 <= x) /\ (x < 1) ==>
	(prob bern {s | FST (std_unif_disc n s) =
		& (ceiling (2 pow n * x)) / 2 pow n} <= (1 / 2) pow n)` --),
	RW_TAC std_ss [REAL_POW] THEN
	Cases_on `ceiling (& (2 ** n) * x) < 2 ** n` THENL [
		RW_TAC std_ss [PMF_STD_UNIF_DISC_GE0_LT1, real_div, 
			REAL_LE_REFL, REAL_POW_INV, REAL_MUL_LID, REAL_POW],

		UNDISCH_TAC (--`~(ceiling (& (2 ** n) * x) < 2 ** n)`--) THEN
		RW_TAC std_ss [LESS_OR_EQ, NOT_LESS] THENL [
			FULL_SIMP_TAC std_ss [GSYM REAL_LT, GSYM REAL_POW] THEN
			UNDISCH_TAC (--`2 pow n < & (ceiling (2 pow n * x))`--) THEN
			CONV_TAC CONTRAPOS_CONV THEN
			RW_TAC std_ss [REAL_NOT_LT, REAL_POW] THEN
			MATCH_MP_TAC REAL_LE_TRANS THEN
			EXISTS_TAC (--`& (ceiling (& (2 ** n)))`--) THEN
			CONJ_TAC THENL [
				REWRITE_TAC [REAL_LE, GSYM REAL_POW] THEN
				MATCH_MP_TAC CEIL_MONO THEN
				RW_TAC real_ss [POW_POS, REAL_LE_MUL] THEN
				MATCH_MP_TAC REAL_LE_TRANS THEN
				EXISTS_TAC (--`2 pow n * 1`--) THEN
				CONJ_TAC THENL [
					MATCH_MP_TAC REAL_LE_LMUL_IMP THEN
					RW_TAC real_ss [REAL_POW_LT, REAL_LT_IMP_LE],
					RW_TAC real_ss [REAL_LE_REFL]],

				RW_TAC std_ss [REAL_LE_REFL, CEILING_NUM]],

			UNDISCH_TAC (--`2 ** n = ceiling (& (2 ** n) * x)`--) THEN
			ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
			RW_TAC std_ss [] THEN
			FULL_SIMP_TAC real_ss [GSYM REAL_POW, REAL_DIV_REFL, REAL_POW_LT, 
				REAL_LT_IMP_NE, EQ_SYM_EQ] THEN
			MATCH_MP_TAC REAL_LE_TRANS THEN
			EXISTS_TAC (--`0r`--) THEN
			RW_TAC real_ss [REAL_LE_INV_EQ, GSYM REAL_POW_INV,
				 real_div, REAL_MUL_LID, POW_ONE, POW_POS] THEN
			MATCH_MP_TAC REAL_EQ_IMP_LE THEN
			REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
			MATCH_MP_TAC RAND_THM THEN
			REWRITE_TAC [EMPTY_DEF, PROB_BERN_BASIC] THEN
			REWRITE_TAC [EXTENSION] THEN  PSET_TAC [] THEN
			RW_TAC std_ss [REAL_NE_LT_GT] THEN
			PROVE_TAC [STD_UNIF_DISC_LT1]]]
);


val PROB_DISC_UNIF_EQ_CEIL2POW_OR_CEIL2POW_MINUS1 = store_thm
  ("PROB_DISC_UNIF_EQ_CEIL2POW_OR_CEIL2POW_MINUS1",
  (--`!x n. (0 <= x) /\ (x <= 1) ==>
	(prob bern
           {s |
              (FST (std_unif_disc n s) =
               & (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
              (FST (std_unif_disc n s) =
               (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)} <= 
			2 * (1/2) pow n)` --),
	RW_TAC std_ss [] THEN
	KNOW_TAC `{s | 
              (FST (std_unif_disc n s) =
               & (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
              (FST (std_unif_disc n s) =
               (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)} = 
		(\t. t = & (ceiling (2 pow n * x)) * (1 / 2) pow n) 
			 o FST o std_unif_disc n UNION
		(\t. t = (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)
			o FST o std_unif_disc n` THEN1
		PSET_TAC [o_DEF] THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	KNOW_TAC  `prob bern
   	   ((\t. t = & (ceiling (2 pow n * x)) * (1 / 2) pow n) o FST o
   	    std_unif_disc n UNION
   	    (\t. t = (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n) o FST o
   	    std_unif_disc n) = 
		prob bern ((\t. t = & (ceiling (2 pow n * x)) * (1 / 2) pow n) o FST o
   	    std_unif_disc n) + 
		prob bern ((\t. t = (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n) o FST o
   	    std_unif_disc n)` THENL [
		MATCH_MP_TAC PROB_ADDITIVE THEN
		ASSUME_TAC (Q.SPEC `n` STD_UNIF_DISC_INDEP) THEN
		RW_TAC std_ss [INDEP_FN_FST_EVENTS, PROB_SPACE_BERN] THEN
		PSET_TAC [o_DEF] THEN
		REWRITE_TAC [real_div, REAL_POW_INV, REAL_MUL_LID] THEN
		RW_TAC std_ss [GSYM real_div] THEN
		RW_TAC real_ss [REAL_POW_LT, REAL_EQ_RDIV_EQ] THEN
		ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
		REWRITE_TAC [TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW, 
			REAL_EQ_SUB_LADD, REAL_ADD, REAL_OF_NUM_EQ] THEN
                PSET_TAC [o_DEF, DISJOINT_DEF] THEN
		DECIDE_TAC,

		ONCE_ASM_REWRITE_TAC [] THEN
		RW_TAC std_ss [o_DEF] THEN
                KNOW_TAC `(\x'.	FST (std_unif_disc n x') = & (ceiling (2 pow n * x)) * (1 / 2) pow n) = 
			  {s | FST (std_unif_disc n s) = & (ceiling (2 pow n * x)) * (1 / 2) pow n}` THEN1
			PSET_TAC [] THEN
		KNOW_TAC `(\x'.FST (std_unif_disc n x') = (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n) =
			  {s | FST (std_unif_disc n s) = (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n}` THEN1
			PSET_TAC [] THEN
 		ONCE_ASM_REWRITE_TAC []  THEN POP_ASSUM K_TAC THEN POP_ASSUM K_TAC THEN
		UNDISCH_TAC (--`0 <= x`--) THEN
		RW_TAC std_ss [REAL_LE_LT] THENL [
			REWRITE_TAC [GSYM REAL_LE_LT] THEN
			KNOW_TAC `!n. & (ceiling (2 pow n * x)) - 1 = &(ceiling (2 pow n * x) - 1)` THENL [
				REWRITE_TAC [REAL_SUB_2] THEN
				RW_TAC std_ss [CEIL_TW0_POW_GE_1],

			ASM_REWRITE_TAC [] THEN
			KNOW_TAC `& (ceiling (2 pow n * x) - 1) * (1 / 2) pow n = 
				& (ceiling (2 pow n * x) - 1) / & (2 ** n)` THEN1
				RW_TAC std_ss [real_div, GSYM REAL_POW, REAL_MUL_LID, REAL_POW_INV] THEN
			ASM_REWRITE_TAC [] THEN
			KNOW_TAC `(ceiling (2 pow n * x) - 1) < 2 ** n` THENL [
				REWRITE_TAC [GSYM REAL_LT, GSYM REAL_POW] THEN
				KNOW_TAC `!n. & (ceiling (2 pow n * x) - 1) = 
						& (ceiling (2 pow n * x)) - 1` THENL [
					REWRITE_TAC [REAL_SUB_2] THEN
					RW_TAC std_ss [CEIL_TW0_POW_GE_1],

					ONCE_ASM_REWRITE_TAC [] THEN
					REWRITE_TAC [REAL_LT_SUB_RADD] THEN
					MATCH_MP_TAC REAL_LTE_TRANS THEN
					EXISTS_TAC (--`(2 pow n * x) + 1`--) THEN
					RW_TAC real_ss [REAL_POW_LT, REAL_LT_IMP_LE,
 				               REAL_LT_RADD, UB_CEILING, REAL_LT_MUL] THEN
					MATCH_MP_TAC REAL_LE_TRANS THEN
					EXISTS_TAC (--`2 pow n * 1`--) THEN
					CONJ_TAC THENL [
						RW_TAC real_ss [REAL_POW_LT, REAL_LE_LMUL],
						RW_TAC real_ss [REAL_LE_REFL]]],

					RW_TAC std_ss [PMF_STD_UNIF_DISC_GE0_LT1] THEN
					REWRITE_TAC [GSYM REAL_LE_SUB_LADD] THEN
					KNOW_TAC `& (ceiling (2 pow n * x)) * (1 / 2) pow n = 
						& (ceiling (2 pow n * x)) / 2 pow n` THEN1
						RW_TAC std_ss [real_div, REAL_MUL_LID, REAL_POW_INV] THEN
					FULL_SIMP_TAC std_ss [] THEN
					UNDISCH_TAC (--`(x:real) <= 1`--) THEN
					RW_TAC std_ss [REAL_LE_LT] THENL [
						REWRITE_TAC [GSYM REAL_LE_LT] THEN
						MATCH_MP_TAC REAL_LE_TRANS THEN
						EXISTS_TAC (--`(1 / 2) pow n`--) THEN
						RW_TAC std_ss [PROB_UNIF_DISC_CEIL_TWO_POW_BY_TWO_POW,
										 REAL_LT_IMP_LE] THEN
						RW_TAC std_ss [real_div, GSYM REAL_POW, 
							REAL_MUL_LID, REAL_POW_INV, GSYM REAL_POW] THEN
						REWRITE_TAC [ REAL_LE_SUB_LADD] THEN
						RW_TAC real_ss [REAL_DOUBLE, REAL_LE_REFL],
 
						REWRITE_TAC [GSYM REAL_LE_LT, REAL_MUL_RID, 
									REAL_POW, CEILING_NUM] THEN
						FULL_SIMP_TAC real_ss [REAL_DIV_REFL, GSYM REAL_POW, 
							REAL_POW_LT, REAL_LT_IMP_NE, EQ_SYM_EQ] THEN
						MATCH_MP_TAC REAL_LE_TRANS THEN
						EXISTS_TAC (--`0:real`--) THEN
						CONJ_TAC THENL [
							MATCH_MP_TAC REAL_EQ_IMP_LE THEN
							MATCH_MP_TAC PMF_UNIF_DISC_GE1 THEN
							RW_TAC std_ss [REAL_LE_REFL],

							REWRITE_TAC [real_div, REAL_LE_SUB_LADD, 
								GSYM REAL_DOUBLE, 
								GSYM REAL_POW_INV, POW_ONE, 
								REAL_LE_RADD] THEN
							REWRITE_TAC [REAL_MUL_LID, REAL_INV_1OVER] THEN
							RW_TAC std_ss [POW_HALF_POS, REAL_LT_IMP_LE]]]]],
				REWRITE_TAC [GSYM REAL_LE_LT] THEN
				RW_TAC arith_ss [GSYM REAL_LE_LT, REAL_MUL_RZERO, 
				REAL_SUB_RDISTRIB, REAL_MUL_LID, CEILING_NUM, REAL_MUL_LZERO] THEN
				KNOW_TAC `0 - (1 / 2) pow n < 0` THEN1
					RW_TAC std_ss [REAL_LT_SUB_RADD, REAL_ADD_LID, POW_HALF_POS] THEN
				RW_TAC std_ss [PMF_UNIF_DISC_LT0, REAL_ADD_RID] THEN
				MATCH_MP_TAC REAL_LE_TRANS THEN
				EXISTS_TAC (--`(1 / 2) pow n`--) THEN
				RW_TAC std_ss [GSYM REAL_DOUBLE, REAL_LE_ADDR,
						 POW_HALF_POS, REAL_LT_IMP_LE] THEN
				MATCH_MP_TAC REAL_EQ_IMP_LE THEN
				MP_TAC (Q.SPECL [`n`, `0`] PMF_STD_UNIF_DISC_GE0_LT1) THEN
				REWRITE_TAC [GSYM REAL_LT, GSYM REAL_POW, real_div] THEN
				RW_TAC real_ss [REAL_POW_INV, REAL_POW_LT]]]
);

val PMF_STD_UNIF_CONT_LE_TWICE_HALF_POW = store_thm
  ("PMF_STD_UNIF_CONT_LE_TWICE_HALF_POW",
  (--`!x n.
         (0 <= x) /\ (x <= 1) ==>
		prob bern {s | std_unif_cont s = x} <= 2 * (1 / 2) pow n` --),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`prob bern
           {s |
              (FST (std_unif_disc n s) =
               & (ceiling (2 pow n * x)) * (1 / 2) pow n) \/
              (FST (std_unif_disc n s) =
               (& (ceiling (2 pow n * x)) - 1) * (1 / 2) pow n)}`--) THEN
	RW_TAC std_ss [PROB_DISC_UNIF_EQ_CEIL2POW_OR_CEIL2POW_MINUS1, 
			PROB_CONT_EQX_LE_PROB_DISC_CEIL_CEIL_SUB1]
);

val PMF_STD_UNIF_CONT_LE0 = store_thm
  ("PMF_STD_UNIF_CONT_LE0",
  (--`!x. (0 <= x) /\ (x <= 1) ==>
	prob bern {s | std_unif_cont s = x} <= 0` --),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC SEQ_LE THEN
	EXISTS_TAC (--`(\(n:num). prob bern {s | std_unif_cont s = x})`--) THEN
	EXISTS_TAC (--`(\(n:num). 2 * (1 / 2) pow n)`--) THEN
	RW_TAC std_ss [TWO_HALF_POW_TENDSTO_ZERO, SEQ_CONST] THEN
	EXISTS_TAC (--`0:num`--) THEN
	RW_TAC std_ss [PMF_STD_UNIF_CONT_LE_TWICE_HALF_POW]
);

val PROB_LB_UB_STD_UNIF_CONT_RANGE_EQ0 = store_thm
  ("PROB_LB_UB_STD_UNIF_CONT_RANGE_EQ0",
  (--`!x. (0 <= x) /\ (x <= 1) ==>
	(prob bern {s | std_unif_cont s = x} = 0)` --),
	RW_TAC std_ss [] THEN
	MP_TAC (Q.SPEC `x` PMF_STD_UNIF_CONT_LE0) THEN
	REWRITE_TAC [REAL_LE_LT] THEN
	KNOW_TAC `prob bern {s | std_unif_cont s = x} < 0 = F` THENL [
	RW_TAC std_ss [REAL_NOT_LT] THEN
	MATCH_MP_TAC PROB_POSITIVE THEN
	RW_TAC std_ss [PROB_SPACE_BERN, STD_UNIF_CONT_EQ_EVENTS_BERN],
	ASM_REWRITE_TAC [] THEN
	PROVE_TAC [GSYM REAL_LE_LT]]
);

val PMF_STD_UNIF_CONT = store_thm
  ("PMF_STD_UNIF_CONT",
  (-- `!x. (prob bern {s | std_unif_cont s = x} = 0)`--),
	RW_TAC std_ss [] THEN
	MP_TAC (Q.SPECL [`(x: real)`, `(1:real)`]  REAL_LET_TOTAL) THEN
	RW_TAC std_ss [] THENL [
		MP_TAC (Q.SPECL [`(0: real)`, `(x:real)`]  REAL_LET_TOTAL) THEN
		RW_TAC std_ss [] THENL [
			RW_TAC std_ss [PROB_LB_UB_STD_UNIF_CONT_RANGE_EQ0],
			REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
			MATCH_MP_TAC RAND_THM THEN
			REWRITE_TAC [GSYM GSPEC_F] THEN
			PSET_TAC [] THEN
 			DISJ2_TAC THEN
			RW_TAC std_ss [REAL_NE_LT_GT] THEN
			DISJ2_TAC THEN
			MATCH_MP_TAC REAL_LTE_TRANS THEN
			EXISTS_TAC (--`(0:real)`--) THEN
			PROVE_TAC [LB_STD_UNIF_CONT]],

			REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
			MATCH_MP_TAC RAND_THM THEN
			REWRITE_TAC [GSYM GSPEC_F] THEN
			PSET_TAC [] THEN
			DISJ2_TAC THEN
			RW_TAC std_ss [REAL_NE_LT_GT] THEN
			DISJ1_TAC THEN
			MATCH_MP_TAC REAL_LET_TRANS THEN
			EXISTS_TAC (--`(1:real)`--) THEN
			PROVE_TAC [UB_STD_UNIF_CONT]]
);




val PROB_UNIF_DISC_LE_CEIL_TWO_POW_MINUS2 = store_thm
  ("PROB_UNIF_DISC_LE_CEIL_TWO_POW_MINUS2",
  (--`!x n. (0 <= x) /\ (x < 1) ==> (prob bern {s | FST (std_unif_disc n s) <=
        (& (ceiling (2 pow n * x)) - 2) * (1 / 2) pow n} = 
		&(ceiling (2 pow n * x) - 1) * (1 / 2) pow n)` --),
	RW_TAC std_ss [] THEN
	Cases_on `2 <=  (ceiling (2 pow n * x))` THENL [
		RW_TAC std_ss [REAL_SUB_2] THEN
		KNOW_TAC `(ceiling (2 pow n * x) - 2) < 2 ** n` THENL [
			RW_TAC std_ss [LESS_EQ_SUB_LESS, GSYM REAL_LT] THEN
			MATCH_MP_TAC REAL_LT_TRANS THEN
			EXISTS_TAC (--`(2 pow n * x) + 1`--) THEN
			KNOW_TAC `0 <= 2 pow n * x` THEN1
				RW_TAC real_ss [REAL_LE_MUL, POW_POS] THEN
			RW_TAC std_ss [UB_CEILING, GSYM REAL_ADD, GSYM REAL_POW] THEN
			KNOW_TAC `2 + 2 pow n = 2 pow n + 2` THEN1
				PROVE_TAC [REAL_ADD_SYM] THEN
			ASM_REWRITE_TAC [] THEN
			MATCH_MP_TAC REAL_LT_ADD2 THEN
			RW_TAC real_ss [] THEN
			MATCH_MP_TAC REAL_LTE_TRANS THEN
			EXISTS_TAC (--`2 pow n * 1`--) THEN
			CONJ_TAC THENL [
				MATCH_MP_TAC REAL_LT_LMUL_IMP THEN
			RW_TAC real_ss [REAL_POW_LT],
			RW_TAC real_ss [REAL_LE_REFL]],

			KNOW_TAC `& (ceiling (2 pow n * x) - 2) * (1 / 2) pow n =
             		   & (ceiling (2 pow n * x) - 2) / & (2 ** n)` THEN1
				RW_TAC std_ss [real_div, GSYM REAL_POW, REAL_MUL_LID, REAL_POW_INV] THEN
			ASM_REWRITE_TAC [] THEN
			RW_TAC std_ss [CDF_UNIF_DISC_GE0_LT1] THEN
			RW_TAC arith_ss [real_div, GSYM REAL_POW, REAL_MUL_LID, REAL_POW_INV, ADD1]],

		KNOW_TAC `ceiling (2 pow n * x) <= 1` THEN1
			FULL_SIMP_TAC arith_ss [NOT_LESS_EQUAL] THEN
		KNOW_TAC `& (ceiling (2 pow n * x) - 1) = 0` THEN1
			RW_TAC arith_ss [REAL_OF_NUM_EQ] THEN
		KNOW_TAC `(& (ceiling (2 pow n * x)) - 2) * (1 / 2) pow n < 0` THENL [
			RW_TAC std_ss [REAL_DIV_LZERO, POW_HALF_POS, GSYM REAL_LT_RDIV_EQ] THEN
			REWRITE_TAC [REAL_LT_SUB_RADD, REAL_ADD_LID] THEN
			MATCH_MP_TAC REAL_LET_TRANS THEN
			EXISTS_TAC (--`1r`--) THEN
			RW_TAC real_ss [REAL_LE],
		RW_TAC real_ss [CDF_UNIF_DISC_LT0]]]
);

val PROB_STD_UNIF_LE_CEIL_SUC_2POW = store_thm
  ("PROB_STD_UNIF_LE_CEIL_SUC_2POW",
  (--`!x n. (0 <= x) /\ (x < 1) ==>
        (prob bern {s | FST (std_unif_disc n s) <=
                (& (ceiling (2 pow n * x)) * (1 / 2) pow n)}
                                <= & (ceiling (2 pow n * x) + 1) * (1 / 2) pow n)`--),
                REWRITE_TAC [real_div, REAL_POW_INV, REAL_MUL_LID] THEN
                RW_TAC std_ss [GSYM real_div] THEN
                RW_TAC real_ss [REAL_POW_LT, REAL_LE_RDIV_EQ] THEN
                ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
                UNDISCH_TAC (--`0 <= x`--) THEN
                RW_TAC std_ss [REAL_LE_LT] THENL [
                        REWRITE_TAC [GSYM REAL_LE_LT] THEN
                        KNOW_TAC `prob bern {s | FST (std_unif_disc n s) * 2 pow n
                                <= & (ceiling (2 pow n * x))} = prob bern {s | & (FST (unif_two_pow n s))
                                        <= & (ceiling (2 pow n * x))}` THENL [
                        MATCH_MP_TAC RAND_THM THEN
                        REWRITE_TAC [EXTENSION] THEN PSET_TAC [] THEN
                        PROVE_TAC [TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW, REAL_MUL_SYM],

                        ASM_REWRITE_TAC [REAL_LE] THEN
                        KNOW_TAC `ceiling (2 pow n * x) = SUC (ceiling (2 pow n * x) - 1)` THENL [
                                REWRITE_TAC [ADD1] THEN
                                RW_TAC arith_ss [CEIL_TW0_POW_GE_1, SUB_ADD],

                        REWRITE_TAC [GSYM REAL_LE_LT] THEN
                        ONCE_ASM_REWRITE_TAC [] THEN
                        KNOW_TAC `{s | FST (unif_two_pow n s) <=  (SUC ((ceiling (2 pow n * x) - 1)))} =
                                (\t. t <= (ceiling (2 pow n * x) - 1)) o FST o unif_two_pow n UNION
                                        (\t. t = SUC ((ceiling (2 pow n * x) - 1))) o FST o unif_two_pow n` THENL [
                                PSET_TAC [o_DEF] THEN
                                RW_TAC std_ss [DISJ_SYM, LE],

                                ONCE_ASM_REWRITE_TAC [] THEN
                                KNOW_TAC  `prob bern ((\t. t <= ceiling (2 pow n * x) - 1) o FST o unif_two_pow n UNION
                                        (\t. t = SUC (ceiling (2 pow n * x) - 1)) o FST o unif_two_pow n) =
                                        prob bern ((\t. t <= ceiling (2 pow n * x) - 1) o FST o unif_two_pow n) +
                                        prob bern ((\t. t = SUC (ceiling (2 pow n * x) - 1)) o FST o unif_two_pow n)` THENL [
                                        MATCH_MP_TAC PROB_ADDITIVE THEN
                                        ASSUME_TAC (Q.SPEC `n` UNIF_TWO_POW_INDEP) THEN
                                        RW_TAC std_ss [INDEP_FN_FST_EVENTS, PROB_SPACE_BERN] THEN
                                        PSET_TAC [o_DEF, DISJOINT_DEF] THEN
                                        DECIDE_TAC,

                                        ONCE_ASM_REWRITE_TAC [] THEN
                                        RW_TAC std_ss [o_DEF, GSYM REAL_LE,GSYM REAL_OF_NUM_EQ ] THEN
                                        REWRITE_TAC [GSYM TWO_POW_STD_UNIF_DISC_EQ_UNIF_TWO_POW] THEN
                        
					KNOW_TAC `SUC (ceiling (2 pow n * x) - 1) = ceiling (2 pow n * x)` THENL [
                                                ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
                                                UNDISCH_TAC (--`ceiling (2 pow n * x) =
                                                        SUC (ceiling (2 pow n * x) - 1)`--) THEN
                                                RW_TAC std_ss [],
                                                FULL_SIMP_TAC std_ss [] THEN
                                                ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
                                                RW_TAC real_ss [REAL_POW_LT, GSYM REAL_LE_RDIV_EQ] THEN
                                                ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
                                                RW_TAC real_ss [REAL_POW_LT, GSYM REAL_EQ_RDIV_EQ,
                                                                GSYM REAL_LE_RDIV_EQ, REAL_POW] THEN
                                                KNOW_TAC `ceiling (x * & (2 ** n)) - 1 < 2 ** n` THENL [
                                                    REWRITE_TAC [GSYM REAL_LT, GSYM REAL_POW] THEN
                                                        ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
                                                        KNOW_TAC `!n. & (ceiling (2 pow n * x) - 1) =
                                                                & (ceiling (2 pow n * x)) - 1` THENL [
                                                                REWRITE_TAC [REAL_SUB_2] THEN
                                                                RW_TAC std_ss [CEIL_TW0_POW_GE_1],

                                                                ASM_REWRITE_TAC [] THEN
                                                                REWRITE_TAC [REAL_LT_SUB_RADD] THEN
                                                                MATCH_MP_TAC REAL_LT_TRANS THEN
                                                                EXISTS_TAC (--`(2 pow n * x) + 1`--) THEN
                                                                RW_TAC real_ss [REAL_POW_LT, REAL_LT_IMP_LE,
                                                                        REAL_LT_RADD, UB_CEILING, REAL_LT_MUL] THEN
                                                                MATCH_MP_TAC REAL_LTE_TRANS THEN
                                                                EXISTS_TAC (--`2 pow n * 1`--) THEN
                                                                CONJ_TAC THENL [
                                                                        RW_TAC real_ss [REAL_POW_LT, REAL_LT_LMUL],
                                                                        RW_TAC real_ss [REAL_LE_REFL]]],
                        					
                        KNOW_TAC  `prob bern (\x'.FST (std_unif_disc n x') <= & (ceiling (x * & (2 ** n)) - 1) / & (2 ** n))
                                  = prob bern {s | FST (std_unif_disc n s) <= & (ceiling (x * & (2 ** n)) - 1) / & (2 ** n)}` THEN1 (
			MATCH_MP_TAC RAND_THM THEN
  			PSET_TAC []) THEN
                        KNOW_TAC `prob bern (\x'.FST (std_unif_disc n x') = & (ceiling (x * & (2 ** n))) / & (2 ** n)) 
                                = prob bern {s | FST (std_unif_disc n s)  = & (ceiling (x * & (2 ** n))) / & (2 ** n)}` THEN1 (
			MATCH_MP_TAC RAND_THM THEN
  			PSET_TAC []) THEN
                        ASM_REWRITE_TAC [] THEN POP_ASSUM K_TAC THEN POP_ASSUM K_TAC THEN                                 

								FULL_SIMP_TAC std_ss [GSYM REAL_POW,
                                                                                CDF_UNIF_DISC_GE0_LT1] THEN
								ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
			


                                                                
                                                                ASM_REWRITE_TAC [] THEN
                                                                ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
                                                                REWRITE_TAC [GSYM REAL_LE_SUB_LADD] THEN
                                                                MATCH_MP_TAC REAL_LE_TRANS THEN
                                                                EXISTS_TAC (--`(1 / 2) pow n`--) THEN
			

                                                                RW_TAC std_ss [PROB_UNIF_DISC_CEIL_TWO_POW_BY_TWO_POW,
                                                                                REAL_LT_IMP_LE] THEN
                                                                RW_TAC std_ss [real_div, REAL_RDISTRIB,
                                                                        GSYM REAL_ADD, REAL_MUL_LID] THEN
                                                                REWRITE_TAC [REAL_LE_SUB_LADD] THEN
                                                                PROVE_TAC [REAL_ADD_SYM, REAL_LE_REFL, REAL_POW_INV]]]]]]],
        RW_TAC std_ss [GSYM REAL_LE_LT, REAL_MUL_LZERO, CEILING_NUM, REAL_MUL_RZERO, ADD_CLAUSES] THEN
        ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
        RW_TAC real_ss [GSYM REAL_LE_RDIV_EQ, REAL_POW_LT, REAL_POW] THEN
        KNOW_TAC `0 < 2 ** n` THENL [
                RW_TAC std_ss [GSYM REAL_LT, GSYM REAL_POW] THEN
                MATCH_MP_TAC REAL_POW_LT THEN
                RW_TAC real_ss [],
                MP_TAC (Q.SPECL [`n`, `0`] CDF_UNIF_DISC_GE0_LT1) THEN
                RW_TAC std_ss [real_div, REAL_MUL_LZERO, REAL_LE_REFL]]]
);

val PROB_CONT_LE_CEIL_SUC_2POW = store_thm
  ("PROB_CONT_LE_CEIL_SUC_2POW",
  (--`!x n. (0 <= x) /\ (x < 1) ==> prob bern {s | std_unif_cont s <= x}
        <= & (ceiling (2 pow n * x) + 1) * (1 / 2) pow n` --),
        RW_TAC std_ss [] THEN
        MATCH_MP_TAC REAL_LE_TRANS THEN
        EXISTS_TAC (--`prob bern {s | FST (std_unif_disc n s) <=
                (& (ceiling (2 pow n * x)) * (1 / 2) pow n)}`--) THEN
        RW_TAC std_ss [PROB_CONT_LE_PROB_UNIF_DISC_CEIL, PROB_STD_UNIF_LE_CEIL_SUC_2POW]
);
val CEIL_TWO_POW_MINUS2_LE_PROB_CONT = store_thm
  ("CEIL_TWO_POW_MINUS2_LE_PROB_CONT",
  (--`!x n. (0 <= x) /\ (x < 1) ==>
        (&(ceiling (2 pow n * x) - 1) * (1 / 2) pow n
                <= prob bern {s | std_unif_cont s <= x})` --),
        RW_TAC std_ss [GSYM PROB_UNIF_DISC_LE_CEIL_TWO_POW_MINUS2,
                PROB_UNIF_DISC_CEIL_LE_PROB_CONT]
);


val CDF_UNIF_CONT_LT0 = store_thm
  ("CDF_UNIF_CONT_LT0",
  (--`!x. (x < 0)  ==>
        (prob bern { s | std_unif_cont s <= x} = 0)` --),
        RW_TAC std_ss [] THEN
        KNOW_TAC `!s. x < std_unif_cont s` THENL [
                GEN_TAC THEN
                MATCH_MP_TAC REAL_LTE_TRANS THEN
                EXISTS_TAC (--`(0:real)`--) THEN
                ASM_REWRITE_TAC [] THEN
                PROVE_TAC [LB_STD_UNIF_CONT],
                FULL_SIMP_TAC std_ss [real_lt] THEN
                REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
                MATCH_MP_TAC RAND_THM THEN
                REWRITE_TAC [GSPEC_F]]
);

val CDF_UNIF_CONT_GE1 = store_thm
  ("CDF_UNIF_CONT_GE1",
  (--`!n x. 1 <= x ==>
        (prob bern {s | std_unif_cont s <= x} = 1)` --),
        RW_TAC std_ss [] THEN
        KNOW_TAC `!s. std_unif_cont s <= x` THENL [
        GEN_TAC THEN
        MATCH_MP_TAC REAL_LE_TRANS THEN
        EXISTS_TAC (--`(1:real)`--) THEN
        RW_TAC std_ss [UB_STD_UNIF_CONT],
        RW_TAC std_ss [GSPEC_T, PROB_BERN_BASIC]]
);
val CDF_UNIF_CONT_GE0_LT1 = store_thm
  ("CDF_UNIF_CONT_GE0_LT1",
  (--`!x. (0 <= x) /\ (x < 1) ==>
        (prob bern {s | std_unif_cont s <= x} = x)` --),
        RW_TAC std_ss [GSYM REAL_LE_ANTISYM] THENL [
        MATCH_MP_TAC SEQ_LE THEN
        EXISTS_TAC (--`(\(n:num). prob bern {s | std_unif_cont s <= x})`--) THEN
        EXISTS_TAC (--`\(n:num). & (ceiling (2 pow n * x) + 1) * (1 / 2) pow n`--) THEN
        RW_TAC std_ss [SEQ_CONST, CEILING_TWO_POWNX_PLUS_ONE_TENDSTO_X] THEN
        EXISTS_TAC (--`0:num`--) THEN
        RW_TAC arith_ss [PROB_CONT_LE_CEIL_SUC_2POW],
        MATCH_MP_TAC SEQ_LE THEN
        EXISTS_TAC (--`\(n:num). &(ceiling (2 pow n * x) - 1) * (1 / 2) pow n`--) THEN
        EXISTS_TAC (--`(\(n:num). prob bern {s | std_unif_cont s <= x})`--) THEN
        RW_TAC std_ss [SEQ_CONST, CEILING_TWO_POWNX_MINUS_ONE_TENDSTO_X] THEN
        EXISTS_TAC (--`0:num`--) THEN
        RW_TAC arith_ss [CEIL_TWO_POW_MINUS2_LE_PROB_CONT]]
);

val CDF_UNIF_CONT = store_thm
  ("CDF_UNIF_CONT",
  (--`!x. (prob bern {s | std_unif_cont s <= x} =
                (if (x < 0) then 0 else
                        (if (x < 1) then x else 1)))` --),
        RW_TAC std_ss [CDF_UNIF_CONT_LT0] THEN
        FULL_SIMP_TAC std_ss [REAL_NOT_LT, CDF_UNIF_CONT_GE0_LT1] THEN
        FULL_SIMP_TAC std_ss [CDF_UNIF_CONT_GE1, REAL_NOT_LT]
);

val CDF_UNIF_CONT_CONTL = store_thm
  ("CDF_UNIF_CONT_CONTL",
  (--`!x. (0 <= x) /\ (x < 1)==>
        ((\x. prob bern {s | std_unif_cont s <= x}) contl x)` --),
        GEN_TAC THEN
        MP_TAC CDF_UNIF_CONT THEN
        RW_TAC std_ss [contl] THENL [
                PROVE_TAC [REAL_LET_ANTISYM, AND_IMP_INTRO],
                REWRITE_TAC [LIM] THEN
        REWRITE_TAC [REAL_SUB_RZERO] THEN
        X_GEN_TAC (--`e:real`--) THEN
        DISCH_TAC THEN
        EXISTS_TAC (--`e:real`--) THEN
        ASM_REWRITE_TAC[] THEN
        BETA_TAC THEN
        RW_TAC std_ss [] THENL [
        REWRITE_TAC [REAL_SUB_LZERO, ABS_NEG] THEN
        FULL_SIMP_TAC std_ss [GSYM ABS_REFL] THEN
        MATCH_MP_TAC REAL_LT_TRANS THEN
        EXISTS_TAC (--`abs x'`--) THEN
        ASM_REWRITE_TAC [] THEN
        MATCH_MP_TAC REAL_LTE_TRANS THEN
        EXISTS_TAC (--`~(x':real)`--) THEN
        FULL_SIMP_TAC std_ss [GSYM REAL_LT_SUB_LADD, REAL_SUB_LZERO] THEN
        MP_TAC (Q.SPECL [`0r`, `(x':real)`] REAL_LET_TOTAL) THEN
        RW_TAC std_ss [] THENL [
        MATCH_MP_TAC REAL_LE_TRANS THEN
        EXISTS_TAC (--`(x':real)`--) THEN
        FULL_SIMP_TAC std_ss [ABS_LE, GSYM REAL_LE_NEGL],
        KNOW_TAC `abs x' = ~x'` THEN1
        FULL_SIMP_TAC std_ss [GSYM REAL_NOT_LE, abs] THEN
        ASM_REWRITE_TAC [REAL_LE_REFL]],
        KNOW_TAC `x + x' - x = x'` THEN1
        REAL_ARITH_TAC THEN
        ASM_REWRITE_TAC [] ,
        KNOW_TAC `0 < 1 - x` THEN1
        RW_TAC real_ss [REAL_SUB_LT] THEN
        RW_TAC std_ss [REAL_LT_IMP_LE, abs] THEN
        MATCH_MP_TAC REAL_LET_TRANS THEN
        EXISTS_TAC (--`abs x'`--) THEN
        RW_TAC std_ss [] THEN
        MATCH_MP_TAC REAL_LE_TRANS THEN
        EXISTS_TAC (--`(x':real)`--) THEN
        RW_TAC std_ss [REAL_LE_SUB_RADD, ABS_LE] THEN
        PROVE_TAC [GSYM REAL_NOT_LT, REAL_ADD_SYM]]]
);



(* ------------------------------------------------------------------------------*)


val STD_UNIF_DISC_SUC_MONO_SUBSET = store_thm
  ("STD_UNIF_DISC_SUC_MONO_SUBSET",
(--`!n  x. (\n. {s | FST (std_unif_disc n s) <= x}) (SUC n)
                        SUBSET (\n. {s | FST (std_unif_disc n s) <= x} ) n`--),
	BETA_TAC THEN
	RW_TAC std_ss [std_unif_disc_def] THEN
	REWRITE_TAC [GSYM real_ge] THEN
	RW_TAC std_ss [COND_RAND, COND_EXPAND] THEN
	REWRITE_TAC [real_ge] THEN
	RW_TAC std_ss [LEFT_AND_OVER_OR, RIGHT_AND_OVER_OR] THEN
	RW_TAC std_ss [PROVE [] (--`~X /\ X = F`--)] THEN
	RW_TAC std_ss [PROVE []
                (--`~a /\ c \/ b /\ a \/ b /\ c = a /\ b \/ ~a /\ c`--)] THEN
	ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
	RW_TAC std_ss [GSYM REAL_LE_SUB_LADD] THEN
	PSET_TAC [] THEN
	KNOW_TAC `x - (1 / 2) pow SUC n <= x` THEN1
	RW_TAC std_ss [REAL_LE_SUB_RADD] THEN
	RW_TAC std_ss [REAL_LE_ADDR, POW_HALF_POS, REAL_LT_IMP_LE] THEN
	RW_TAC std_ss [REAL_LE_TRANS] THEN
	PROVE_TAC [REAL_LE_TRANS]);

val BIGINTER_INDUCT_STEP = store_thm
  ("BIGINTER_INDUCT_STEP",
  (--`!(A: num -> ('a -> bool)) (n: num) (k:num).
   (BIGINTER (IMAGE A {n | (n <= SUC k)}) =
    (A (SUC k)) INTER (BIGINTER (IMAGE A {n | (n <= k)})))`--),
	RW_TAC std_ss [BIGINTER_def, IMAGE_DEF] THEN
	RW_TAC std_ss [PROVE [LE]
                (--`n <= SUC k = (n <= k) \/ (n = SUC k)`--)] THEN
        CONV_TAC (ONCE_DEPTH_CONV SET_SPEC_CONV)  THEN
        CONV_TAC (ONCE_DEPTH_CONV SET_SPEC_CONV)  THEN
	RW_TAC std_ss [LEFT_AND_OVER_OR]  THEN
	RW_TAC std_ss [EXISTS_OR_THM, DISJ_IMP_THM,
                FORALL_AND_THM, GSPEC_AND,GSPEC_ID, INTER_COMM ]);

val MONO_NON_INC_BIGINTER_N = store_thm
  ("MONO_NON_INC_BIGINTER_N",
  (--`!(A: num -> ('a -> bool)) (k:num).
        (!j. ((A (SUC j)) SUBSET (A j)))
        ==> ((A k) = BIGINTER (IMAGE A {n | (n <= k)}))`--),
	RW_TAC std_ss [] THEN
	Induct_on `k` THENL [
		RW_TAC arith_ss [] THEN
		REWRITE_TAC [BIGINTER_def, IMAGE_DEF] THEN
		CONV_TAC (ONCE_DEPTH_CONV SET_SPEC_CONV) THEN
                CONV_TAC (ONCE_DEPTH_CONV SET_SPEC_CONV) THEN
		FULL_SIMP_TAC std_ss [] THEN
		REWRITE_TAC [GSPEC_ID],
		RW_TAC std_ss [ BIGINTER_INDUCT_STEP] THEN
		KNOW_TAC `BIGINTER (IMAGE A {n | n <= k}) = A k` THEN1
			PROVE_TAC [EQ_SYM_EQ] THEN
		ONCE_ASM_REWRITE_TAC [] THEN 
		PROVE_TAC [SUBSET_INTER_ABSORPTION]]);


val STD_UNIF_MONO_NON_INC_BIGINTER_N = store_thm
  ("STD_UNIF_MONO_NON_INC_BIGINTER_N",
  (--`!(k: num) (x: real).
        ((\n. {s | FST (std_unif_disc n s) <= x}) k = BIGINTER
                (IMAGE (\n. { s | FST (std_unif_disc n s) <= x}) {n | (n <= k)}))`--),
REPEAT GEN_TAC THEN
MATCH_MP_TAC MONO_NON_INC_BIGINTER_N THEN
RW_TAC std_ss [STD_UNIF_DISC_SUC_MONO_SUBSET]);




val _ = export_theory();

