open HolKernel Parse boolLib bossLib arithmeticTheory pred_setTheory
     listTheory sequenceTheory state_transformerTheory
     probabilityTheory formalizeUseful extra_numTheory combinTheory
     pairTheory realTheory realLib extra_boolTheory jrhUtils
     extra_pred_setTheory prob_algebraTheory probTheory realSimps
     extra_realTheory extra_pred_setTools measureTheory numTheory
     simpLib prob_extraTheory probTools prob_extraTools pred_setLib
     seqTheory std_unifTheory subtypeTheory prob_uniformTheory 
     prob_bernoulliTheory prob_bernoulli_pTheory binomialTheory
     prob_uniformTheory prob_bernoulliTheory disc_expecTheory transcTheory;
     
val _ = new_theory "disc_variance";

val expec_fn_def = Define
        `expec_fn (f: num -> real) (R: (num -> bool) -> num#(num -> bool)) =
                suminf (\n. (f n) * prob bern {s | (f (FST (R s)) = (f n)) /\ (FST (R s) = n)})`;


val variance_def = Define
        `variance (R: (num -> bool) -> num#(num -> bool)) =
		expec_fn ((\x. ((&x) - (expec R)) pow 2): num -> real) R`;

val std_dev_def  = Define
        `std_dev R = sqrt (variance R)`;

val EXPEC_EXPEC_FN = store_thm
 ("EXPEC_EXPEC_FN",
 (--`!R. expec R = expec_fn (\x. &x) R`--),
	RW_TAC std_ss [expec_fn_def, expec_def, REAL_INJ]);

val EXPEC_FN = store_thm
 ("EXPEC_FN",
 (--`!R f. expec_fn f R = 
	suminf (\n. (f n) * prob bern {s | (FST (R s) = n)})`--),
	RW_TAC std_ss [expec_fn_def] THEN
	SUFF_TAC `!n. prob bern {s | (f (FST (R s)) = f n) /\ (FST (R s) = n)} = 
		prob bern {s | FST (R s) = n}`  THEN1
		RW_TAC std_ss []  THEN
	
	GEN_TAC  THEN
	MATCH_MP_TAC RAND_THM  THEN
	REWRITE_TAC [EXTENSION]  THEN
	PSET_TAC [GSPECIFICATION]  THEN
	PROVE_TAC []);



val EXPEC_VAR_CONSTANT = store_thm
 ("EXPEC_VAR_CONSTANT",
 (--`!c R f. (R IN indep_fn) /\ 
	(prob bern {s | FST (R s) = c} = 1) ==>
                        (expec_fn f R = f c)`--),
RW_TAC std_ss [EXPEC_FN] THEN
ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
MATCH_MP_TAC SUM_UNIQ THEN
KNOW_TAC `!n. prob bern {s | FST (R s) = n} = 
	(if c = n then 1 else 0)` THEN1 (
	REPEAT STRIP_TAC THEN
	Cases_on `(c = n)` THEN1
		RW_TAC std_ss [] THEN
		
		RW_TAC std_ss [] THEN
		SUFF_TAC `prob bern {s | FST (R s) = n} + 
			prob bern {s | FST (R s) = c} <= 1` THEN1 (
			RW_TAC real_ss [GSYM REAL_LE_SUB_LADD] THEN
			SUFF_TAC `0 <= prob bern {s | FST (R s) = n}` THEN1
				RW_TAC std_ss [GSYM REAL_LE_ANTISYM] THEN		

				MATCH_MP_TAC PROB_POSITIVE THEN
				RW_TAC std_ss [PROB_SPACE_BERN, INDEP_FN_SET_FST_EVENTS]) THEN
				
		KNOW_TAC `prob bern {s | FST (R s) = n} + prob bern {s | FST (R s) = c} =
			prob bern ({s | FST (R s) = n} UNION {s | FST (R s) = c})` THEN1 (
			ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
			MATCH_MP_TAC  PROB_ADDITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN, INDEP_FN_SET_FST_EVENTS,
				DISJOINT_DEF] THEN
			REWRITE_TAC [EXTENSION] THEN
			PSET_TAC [GSPECIFICATION] THEN
			RW_TAC arith_ss []) THEN
		ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC  PROB_LE_1 THEN
		RW_TAC std_ss [PROB_SPACE_BERN] THEN
		MATCH_MP_TAC EVENTS_UNION THEN
		RW_TAC std_ss [PROB_SPACE_BERN, INDEP_FN_SET_FST_EVENTS]) THEN
ASM_REWRITE_TAC [] THEN
RW_TAC std_ss [sums, SEQ] THEN
EXISTS_TAC (--`SUC c:num`--) THEN
Induct THEN1
        RW_TAC real_ss [GREATER_OR_EQ, sum] THEN
	
	RW_TAC real_ss [sum] THEN
	FULL_SIMP_TAC arith_ss [] THEN
	KNOW_TAC `sum (0,c) (\n'. f n' * (if c = n' then 1 else 0)) = 0` THEN1 (
		KNOW_TAC `0 = sum (0, c) (\r. 0)` THEN1
			RW_TAC std_ss [SUM_0]  THEN
		ONCE_ASM_REWRITE_TAC []  THEN
		POP_ASSUM K_TAC  THEN
		MATCH_MP_TAC SUM_EQ  THEN
		RW_TAC real_ss [SUM_0])  THEN
	RW_TAC std_ss [ABS_0]);


val PMF_SUMS_1 = store_thm
  ("PMF_SUMS_1",
  (--`!R. (R IN indep_fn) ==>
		((\n. prob bern {s | FST (R s) = n}) sums 1)`--),
	REPEAT STRIP_TAC THEN
	REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
    	KNOW_TAC `!n. (\n. prob bern {s | FST (R s) = n}) =
                  (prob bern o (\n. {s | FST (R s) = n}))` THEN1 
       		RW_TAC std_ss [o_DEF] THEN
    	ONCE_ASM_REWRITE_TAC [] THEN
    	MATCH_MP_TAC PROB_COUNTABLY_ADDITIVE THEN
    	RW_TAC std_ss [PROB_SPACE_BERN, DISJOINT_DEF, 
		INTER_DEF, SPECIFICATION, IN_FUNSET] THENL [
		    ONCE_REWRITE_TAC [GSYM SPECIFICATION] THEN
		    RW_TAC std_ss [INDEP_FN_SET_FST_EVENTS],

                    PSET_TAC [GSPECIFICATION] THEN
                    DISJ2_TAC THEN
                    CCONTR_TAC THEN
                    PROVE_TAC [],

                    RW_TAC std_ss [EXTENSION, IN_UNIV, IN_BIGUNION_IMAGE,
                                      GSPECIFICATION] THEN
                    EXISTS_TAC (--`(x:(num -> bool))`--) THEN
                    PROVE_TAC []]);

val EXPEC_FN_CONSTANT = store_thm
 ("EXPEC_FN_CONSTANT",
 (--`!c R. (R IN indep_fn) ==> (expec_fn (\n. c) R = c)`--),
	RW_TAC std_ss [EXPEC_FN] THEN
	KNOW_TAC `(\n. c * prob bern {s | FST (R s) = n}) sums (c * 1)` THEN1 (
    		KNOW_TAC `!n. c * prob bern {s | FST (R s) = n} = 
			c * (\n. prob bern {s | FST (R s) = n}) n` THEN1
         		RW_TAC std_ss [] THEN
    		ONCE_ASM_REWRITE_TAC [] THEN
    		MATCH_MP_TAC SER_CMUL THEN
    		RW_TAC std_ss [PMF_SUMS_1]) THEN
	FULL_SIMP_TAC real_ss [SUM_UNIQ, EQ_SYM_EQ]);


val EXPEC_FN_MUL_LINEAR = store_thm
 ("EXPEC_FN_MUL_LINEAR",
 (--`!b R f. (summable (\n. (f n) * prob bern {s | FST (R s) =  n})) ==>
                    (expec_fn (\n. b * (f n)) R = b * (expec_fn f R))`--),
	RW_TAC std_ss [EXPEC_FN] THEN
	KNOW_TAC `!n. b * f n * prob bern {s | FST (R s) = n} = 
                 b * (\n. f n * prob bern {s | FST (R s) = n}) n` THEN1 
    		RW_TAC std_ss [REAL_MUL_ASSOC] THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	MATCH_MP_TAC SUMINF_CMUL THEN
	PROVE_TAC []);

val EXPEC_FN_ADD_LINEAR = store_thm
 ("EXPEC_FN_ADD_LINEAR",
 (--`!a R f. (summable (\n. (f n) * prob bern {s | FST (R s) =  n})) /\ 
         (R IN indep_fn) ==>
                    (expec_fn (\n. a + (f n)) R = a + (expec_fn f R))`--),
	RW_TAC std_ss [EXPEC_FN, REAL_ADD_RDISTRIB, summable] THEN
	KNOW_TAC `suminf
      		(\n. a * prob bern 
		{s | FST (R s) = n} + f n * prob bern {s | FST (R s) = n}) = 
             suminf (\n. a * prob bern {s | FST (R s) = n}) +
	     suminf (\n. f n * prob bern {s | FST (R s) = n})` THEN1 (
    		KNOW_TAC `!n. (\n. a * prob bern {s | FST (R s) = n} 
		+ f n * prob bern {s | FST (R s) = n}) =
                 (\n. (\n. a * prob bern {s | FST (R s) = n}) n + 
		      (\n. f n * prob bern {s | FST (R s) = n}) n)` THEN1
          	RW_TAC std_ss [] THEN
    	ONCE_ASM_REWRITE_TAC [] THEN
    	MATCH_MP_TAC SUMINF_ADD THEN
    	KNOW_TAC `(\n. a * prob bern {s | FST (R s) = n}) sums (a * 1)` THEN1 (
          	KNOW_TAC `!n. (\n. a * prob bern {s | FST (R s) = n}) =
	                   (\n. a * (\n. prob bern {s | FST (R s) = n}) n)` THEN1 
              		RW_TAC std_ss [] THEN
          	ONCE_ASM_REWRITE_TAC [] THEN
          	MATCH_MP_TAC SER_CMUL THEN
          	RW_TAC std_ss [PMF_SUMS_1]) THEN
    	PROVE_TAC [summable]) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	RW_TAC std_ss [REAL_EQ_RADD] THEN
	KNOW_TAC `(\n. a * prob bern {s | FST (R s) = n}) = 
             (\n. (\n. a) n * prob bern {s | FST (R s) = n})` THEN1
    		RW_TAC std_ss [] THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	REWRITE_TAC [GSYM EXPEC_FN] THEN
	MATCH_MP_TAC EXPEC_FN_CONSTANT THEN
	ASM_REWRITE_TAC []);

val EXPEC_FN_LINEAR = store_thm
 ("EXPEC_FN_LINEAR",
 (--`!a b R f. (summable (\n. (f n) * prob bern {s | FST (R s) =  n})) /\ 
         (R IN indep_fn) ==>
                    (expec_fn (\n. a + (b*(f n))) R = a + (b * (expec_fn f R)))`--),
	RW_TAC std_ss [EXPEC_FN, REAL_ADD_RDISTRIB, summable] THEN
	KNOW_TAC `suminf
      (\n. a * prob bern {s | FST (R s) = n} + b * f n * prob bern {s | FST (R s) = n}) = 
             suminf (\n. a * (\n. prob bern {s | FST (R s) = n}) n) +
	     suminf (\n. (\n. b * f n) n * (\n. prob bern {s | FST (R s) = n}) n)` THEN1 (
    	KNOW_TAC `(\n. a * prob bern {s | FST (R s) = n} + 
	b * f n * prob bern {s | FST (R s) = n}) =
                 (\n. (\n. a * (\n. prob bern {s | FST (R s) = n}) n) n + 
		      (\n. (\n. b * f n) n * 
			(\n. prob bern {s | FST (R s) = n}) n) n)` THEN1
          	RW_TAC std_ss [] THEN
    	ONCE_ASM_REWRITE_TAC [] THEN
    	MATCH_MP_TAC SUMINF_ADD THEN
    	KNOW_TAC `(\n. a * (\n. prob bern {s | FST (R s) = n}) n) sums (a * 1)` THEN1 (
          	MATCH_MP_TAC SER_CMUL THEN
          	RW_TAC std_ss [PMF_SUMS_1]) THEN
    	KNOW_TAC `(\n. (\n. b * f n) n * 
	(\n. prob bern {s | FST (R s) = n}) n) sums (b * s)` THEN1 (
          	KNOW_TAC `(\n. (\n. b * f n) n * (\n. prob bern {s | FST (R s) = n}) n) = 
	               (\n. b * (\n. f n * prob bern {s | FST (R s) = n}) n)` THEN1 
              		RW_TAC std_ss [REAL_MUL_ASSOC] THEN
          	ONCE_ASM_REWRITE_TAC [] THEN
          	MATCH_MP_TAC SER_CMUL THEN
          	RW_TAC std_ss []) THEN
    	PROVE_TAC [summable]) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	KNOW_TAC `suminf (\n. (\n. b * f n) n * (\n. prob bern {s | FST (R s) = n}) n) =
                    b * suminf (\x. f x * prob bern {s | FST (R s) = x})` THEN1 (
    	KNOW_TAC `((\n. (\n. b * f n) n * (\n. prob bern {s | FST (R s) = n}) n) = 
                 (\n. (\n. b * f n) n * prob bern {s | FST (R s) = n})) /\
                 ((\x. f x * prob bern {s | FST (R s) = x}) = 
		  (\x. (\x. f x) x * prob bern {s | FST (R s) = x}))` THEN1
        	RW_TAC std_ss [] THEN
    	ONCE_ASM_REWRITE_TAC [] THEN
    	REWRITE_TAC [GSYM EXPEC_FN, ETA_THM] THEN
    	MATCH_MP_TAC EXPEC_FN_MUL_LINEAR THEN
    	PROVE_TAC [summable]) THEN
	RW_TAC std_ss [REAL_EQ_RADD] THEN
	KNOW_TAC `(\n. a * prob bern {s | FST (R s) = n}) = 
             (\n. (\n. a) n * prob bern {s | FST (R s) = n})` THEN1
       		RW_TAC std_ss [] THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	REWRITE_TAC [GSYM EXPEC_FN] THEN
	MATCH_MP_TAC EXPEC_FN_CONSTANT THEN
	ASM_REWRITE_TAC []);

val EXPEC_FN_TWO_FN = store_thm
 ("EXPEC_FN_TWO_FN",
 (--`!R f g. summable (\n. f n * prob bern {s | FST (R s) = n}) /\
	   summable (\n. g n * prob bern {s | FST (R s) = n}) ==>
		(expec_fn (\x. f x + g x) R = expec_fn f R + expec_fn g R)`--),
	RW_TAC std_ss [EXPEC_FN, REAL_ADD_RDISTRIB] THEN
	KNOW_TAC `(\x. f x * prob bern {s | FST (R s) = x} +
         	  g x * prob bern {s | FST (R s) = x}) = 
	     (\x. (\x. f x * prob bern {s | FST (R s) = x}) x + 
		  (\x. g x * prob bern {s | FST (R s) = x}) x)` THEN1
		RW_TAC std_ss [] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	MATCH_MP_TAC SUMINF_ADD THEN
	RW_TAC std_ss [SUMINF_ADD]);



val VARIANCE_SUMMABLE = store_thm
 ("VARIANCE_SUMMABLE",
 (--`!(R: (num -> bool) -> num#(num -> bool)).
 	summable (\n. (\x. & x pow 2) n * prob bern {s | FST (R s) = n}) ==>
       	summable (\n. &n * prob bern {s | FST (R s) = n}) /\
	(R IN indep_fn) ==>
	(summable (\x. (& x - expec R) pow 2 * prob bern {s | FST (R s) = x}))`--),
	RW_TAC std_ss [] THEN
	KNOW_TAC `!a b. (a-b) pow 2 = a pow 2 - 2 * a * b + b pow 2` THEN1 (
		RW_TAC std_ss [POW_2, REAL_SUB_LDISTRIB, REAL_SUB_RDISTRIB] THEN
		REAL_ARITH_TAC) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `(\x. & x pow 2 - 2 * & x * expec R + expec R pow 2) =
        (\x. (\x. & x pow 2) x + (\x. ~2 * & x * expec R + expec R pow 2) x)` THEN1
		RW_TAC real_ss [real_sub, REAL_ADD_ASSOC] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	REWRITE_TAC [real_sub] THEN
	SUFF_TAC `summable (\n. (\x. ~2 * & x * expec R + expec R pow 2) 
			n * prob bern {s | FST (R s) = n})` THEN1 (
		RW_TAC std_ss [summable, sums] THEN
		KNOW_TAC `(\x.
              		(& x pow 2 + ~(2 * & x * expec R) + expec R pow 2) *
              		prob bern {s | FST (R s) = x}) = 
	      		(\x. (\x.  & x pow 2 * prob bern {s | FST (R s) = x}) x + 
	      		(\x.  (~(2 * & x * expec R) + 
			expec R pow 2) * prob bern {s | FST (R s) = x}) x)` THEN1 
	      		RW_TAC std_ss [GSYM REAL_ADD_RDISTRIB, REAL_ADD_ASSOC] THEN
		ASM_REWRITE_TAC [SUM_ADD] THEN
		POP_ASSUM K_TAC THEN   
		FULL_SIMP_TAC std_ss [summable, sums] THEN
		KNOW_TAC `(\n. sum (0,n) (\x. & x pow 2 * prob bern {s | FST (R s) = x}) +
         	sum (0,n) (\x. (~(2 * & x * expec R) + expec R pow 2) *
              		prob bern {s | FST (R s) = x})) = 
			(\n. (\n. sum (0,n) (\x. & x pow 2 * prob bern {s | FST (R s) = x})) n +
         	(\n. sum (0,n) (\x. (~(2 * & x * expec R) + expec R pow 2) *
              		prob bern {s | FST (R s) = x})) n)` THEN1
			RW_TAC std_ss [] THEN
		ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		EXISTS_TAC (--`s' + s:real`--) THEN
		MATCH_MP_TAC SEQ_ADD THEN
		RW_TAC std_ss [REAL_NEG_LMUL]) THEN   
	
	
		KNOW_TAC `!x. ~2 * & x * expec R + expec R pow 2 =
                	expec R pow 2 + (~2 * expec R) * (&x)` THEN1 (
                	GEN_TAC THEN
                	REAL_ARITH_TAC) THEN
        	ASM_REWRITE_TAC [] THEN
        	POP_ASSUM K_TAC THEN
		MP_TAC (Q.SPECL [`expec R pow 2`, `~2 * expec R`, `R`, `&`] EXPEC_FN_LINEAR) THEN
		RW_TAC std_ss [EXPEC_FN, suminf] THEN
		POP_ASSUM MP_TAC THEN
		SELECT_ELIM_TAC THEN
		RW_TAC std_ss [] THENL [
			EXISTS_TAC (--`(expec R pow 2 + ~2 * expec R * expec R)`--) THEN
			KNOW_TAC `(\n. (expec R pow 2 + ~2 * expec R * & n) *
		        prob bern {s | FST (R s) = n}) =
        		(\n. (\n. expec R pow 2 * prob bern {s | FST (R s) = n}) n +
          		      (\n. ~2 * expec R * & n * prob bern {s | FST (R s) = n}) n)` THEN1
				RW_TAC std_ss [REAL_ADD_RDISTRIB] THEN
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			MATCH_MP_TAC SER_ADD THEN
			CONJ_TAC THENL [
				KNOW_TAC `expec R pow 2 = expec R pow 2 * 1` THEN1
					RW_TAC real_ss [] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				REWRITE_TAC [GSYM REAL_MUL_ASSOC] THEN
				KNOW_TAC `(\n. expec R pow 2 * (1 * prob bern {s | FST (R s) = n})) =
				(\n. expec R pow 2 * (\n. prob bern {s | FST (R s) = n}) n)` THEN1
					RW_TAC real_ss [] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				MATCH_MP_TAC SER_CMUL THEN
				RW_TAC std_ss [PMF_SUMS_1],

				KNOW_TAC `(\n. ~2 * expec R * & n * prob bern {s | FST (R s) = n}) =
                		(\n. ~2 * expec R * 
				(\n. & n * prob bern {s | FST (R s) = n}) n)` THEN1
					RW_TAC std_ss [REAL_MUL_ASSOC] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				MATCH_MP_TAC SER_CMUL THEN
				RW_TAC std_ss [expec_def] THEN
				PROVE_TAC [SUMMABLE_SUM]],

			PROVE_TAC [SUM_SUMMABLE]]);

val VARIANCE_EXPEC = store_thm
 ("VARIANCE_EXPEC",
 (--`!R. summable (\n. (\x. & x pow 2) n * prob bern {s | FST (R s) = n}) /\
       	summable (\n. &n * prob bern {s | FST (R s) = n}) /\
	(R IN indep_fn) ==>
		(variance R = expec_fn (\x. &x pow 2) R - (expec R) pow 2)`--),
	REPEAT STRIP_TAC THEN
	RW_TAC std_ss [variance_def] THEN
	KNOW_TAC `!a b. (a-b) pow 2 = a pow 2 - 2 * a * b + b pow 2` THEN1 (
		RW_TAC std_ss [POW_2, REAL_SUB_LDISTRIB, REAL_SUB_RDISTRIB] THEN
		REAL_ARITH_TAC) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `(\x. & x pow 2 - 2 * & x * expec R + expec R pow 2) =
        (\x. (\x. & x pow 2) x + (\x. ~2 * & x * expec R + expec R pow 2) x)` THEN1
		RW_TAC real_ss [real_sub, REAL_ADD_ASSOC] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	REWRITE_TAC [real_sub] THEN
	SUFF_TAC `summable (\n. (\x. ~2 * & x * expec R + expec R pow 2) 
			n * prob bern {s | FST (R s) = n})` THEN1 (
		STRIP_TAC THEN
		KNOW_TAC `expec_fn (\x. (\x. & x pow 2) x + 
		(\x. ~2 * & x * expec R + expec R pow 2) x) R = 
		expec_fn (\x. & x pow 2) R + 
		expec_fn (\x. ~2 * & x * expec R + expec R pow 2) R` THEN1 (
			MATCH_MP_TAC EXPEC_FN_TWO_FN THEN
			RW_TAC std_ss []) THEN
		ASM_REWRITE_TAC [REAL_EQ_LADD] THEN
		POP_ASSUM K_TAC THEN
		KNOW_TAC `!x. ~2 * & x * expec R + expec R pow 2 =
        	expec R pow 2 + (~2 * expec R) * (&x)` THEN1 (
			GEN_TAC THEN
			REAL_ARITH_TAC) THEN
		ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		KNOW_TAC `expec_fn (\x. expec R pow 2 + ~2 * expec R * & x) R =
                expec R pow 2 + (~2 * expec R) * expec R` THEN1 (
			KNOW_TAC `~2 * expec R * expec R = ~2 * expec R * expec_fn & R` THEN1
				RW_TAC std_ss [EXPEC_EXPEC_FN, ETA_THM] THEN
			ASM_REWRITE_TAC [] THEN
			MATCH_MP_TAC EXPEC_FN_LINEAR THEN
			RW_TAC std_ss []) THEN
		ASM_REWRITE_TAC [] THEN
        	POP_ASSUM K_TAC THEN
		RW_TAC std_ss [POW_2] THEN
		REAL_ARITH_TAC) THEN
	
		KNOW_TAC `!x. ~2 * & x * expec R + expec R pow 2 =
                expec R pow 2 + (~2 * expec R) * (&x)` THEN1 (
                	GEN_TAC THEN
                	REAL_ARITH_TAC) THEN
        	ASM_REWRITE_TAC [] THEN
        	POP_ASSUM K_TAC THEN
		MP_TAC (Q.SPECL [`expec R pow 2`, `~2 * expec R`, `R`, `&`] EXPEC_FN_LINEAR) THEN
		RW_TAC std_ss [EXPEC_FN, suminf] THEN
		POP_ASSUM MP_TAC THEN
		SELECT_ELIM_TAC THEN
		RW_TAC std_ss [] THENL [
			EXISTS_TAC (--`(expec R pow 2 + ~2 * expec R * expec R)`--) THEN
			KNOW_TAC `(\n. (expec R pow 2 + ~2 * expec R * & n) *
		        prob bern {s | FST (R s) = n}) =
        		(\n. (\n. expec R pow 2 * prob bern {s | FST (R s) = n}) n +
          		      (\n. ~2 * expec R * & n * prob bern {s | FST (R s) = n}) n)` THEN1
				RW_TAC std_ss [REAL_ADD_RDISTRIB] THEN
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			MATCH_MP_TAC SER_ADD THEN
			CONJ_TAC THENL [
				KNOW_TAC `expec R pow 2 = expec R pow 2 * 1` THEN1
					RW_TAC real_ss [] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				REWRITE_TAC [GSYM REAL_MUL_ASSOC] THEN
				KNOW_TAC `(\n. expec R pow 2 * (1 * prob bern {s | FST (R s) = n})) =
				(\n. expec R pow 2 * (\n. prob bern {s | FST (R s) = n}) n)` THEN1
					RW_TAC real_ss [] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				MATCH_MP_TAC SER_CMUL THEN
				RW_TAC std_ss [PMF_SUMS_1],

				KNOW_TAC `(\n. ~2 * expec R * & n * prob bern {s | FST (R s) = n}) =
                		(\n. ~2 * expec R * 
				(\n. & n * prob bern {s | FST (R s) = n}) n)` THEN1
					RW_TAC std_ss [REAL_MUL_ASSOC] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				MATCH_MP_TAC SER_CMUL THEN
				RW_TAC std_ss [expec_def] THEN
				PROVE_TAC [SUMMABLE_SUM]],

			PROVE_TAC [SUM_SUMMABLE]]);
val VARIANCE_POSITIVE = store_thm
 ("VARIANCE_POSITIVE",
 (--`!(X: (num -> bool) -> num#(num -> bool)).
         X IN indep_fn /\
         summable (\n. & n * prob bern {s | FST (X s) = n}) /\
         summable (\n. (\x. & x pow 2) n * prob bern {s | FST (X s) = n})  ==>
	 (0 <= variance X)`--),
	REPEAT STRIP_TAC THEN
	MP_TAC (Q.SPEC `X` VARIANCE_SUMMABLE) THEN
	RW_TAC std_ss [] THEN
	FULL_SIMP_TAC std_ss [variance_def, EXPEC_FN, suminf, summable, sums] THEN
	SELECT_ELIM_TAC THEN
	RW_TAC std_ss [] THEN1
        	PROVE_TAC [] THEN

        	MATCH_MP_TAC LE_SEQ_IMP_LE_LIM THEN
		EXISTS_TAC (--`(\n.
             sum (0,n)
               (\x.
                  (& x - expec X) pow 2 *
                  prob bern {s | FST ((X: (num -> bool) -> num#(num -> bool)) s) = x}))`--) THEN
        	RW_TAC std_ss [] THEN
        	MATCH_MP_TAC SUM_POS THEN
        	RW_TAC std_ss [] THEN
        	MATCH_MP_TAC REAL_LE_MUL THEN
        	RW_TAC real_ss [REAL_LE_POW2] THEN
        	MATCH_MP_TAC PROB_POSITIVE THEN
        	RW_TAC std_ss [PROB_SPACE_BERN, INDEP_FN_SET_FST_EVENTS]);

val STD_DEV_POSITIVE = store_thm
 ("STD_DEV_POSITIVE",
 (--`!(X: (num -> bool) -> num#(num -> bool)).
         X IN indep_fn /\
         summable (\n. & n * prob bern {s | FST (X s) = n}) /\
         summable (\n. (\x. & x pow 2) n * prob bern {s | FST (X s) = n})  ==>
         (0 <= std_dev X)`--),
	RW_TAC std_ss [std_dev_def] THEN
	ONCE_REWRITE_TAC [GSYM SQRT_0] THEN
	MATCH_MP_TAC SQRT_MONO_LE THEN
	RW_TAC std_ss [VARIANCE_POSITIVE, REAL_LE_REFL]);




(***********************************************************);

val SUM_REL_TWO_RV_SECOND_MOMENT = store_thm
 ("SUM_REL_TWO_RV_SECOND_MOMENT",
 (--`!M n. sum (0,n) (\x. sum (0,SUC x) (\i. (& x pow 2) * M i (x - i))) =
        sum (0,n) (\x. sum (0,n - x) (\i. (& (x + i) pow 2) * M x i))`--),
	REPEAT GEN_TAC THEN
	Induct_on `n` THEN1
        	RW_TAC real_ss [sum] THEN

        	RW_TAC real_ss [sum] THEN
        	KNOW_TAC `!n. SUC n - n = 1` THEN1 (
                	GEN_TAC THEN
                	DECIDE_TAC) THEN
        	RW_TAC arith_ss [SUM_1, REAL_EQ_RADD, REAL_ADD_ASSOC] THEN
        	KNOW_TAC `sum (0,n) (\x. sum (0,n - x) (\i. & (x + i) pow 2 * M x i)) =
                sum (0,n) (\x. sum (0,SUC x) (\i. & x pow 2 * M i (x - i)))` THEN1
                	PROVE_TAC [EQ_SYM_EQ] THEN
        	FULL_SIMP_TAC std_ss [ADD_SYM, GSYM SUM_ADD] THEN
        	MATCH_MP_TAC SUM_EQ THEN
        	RW_TAC arith_ss [SUB, sum]);

val PROB_ADDITIVE_NOT_DISJOINT = store_thm
 ("PROB_ADDITIVE_NOT_DISJOINT",
 (--`!p s t u.
       prob_space p /\ s IN events p /\ t IN events p /\
       (u = s UNION t) ==>
       (prob p u <= prob p s + prob p t)`--),
	REPEAT STRIP_TAC THEN
	Cases_on `DISJOINT s t` THEN1 (
		MATCH_MP_TAC REAL_EQ_IMP_LE THEN
		RW_TAC std_ss [PROB_ADDITIVE]) THEN

		KNOW_TAC `u = s UNION (t DIFF s)` THEN1 (
			REWRITE_TAC [EXTENSION] THEN
			PSET_TAC [GSPECIFICATION, IN_UNION, IN_DIFF] THEN
			PROVE_TAC []) THEN
		ASM_REWRITE_TAC [] THEN
		KNOW_TAC `prob p (s UNION (t DIFF s)) = prob p s + prob p (t DIFF s)` THEN1 (
			MATCH_MP_TAC PROB_ADDITIVE THEN
			RW_TAC std_ss [EVENTS_DIFF, DISJOINT_DEF] THEN
			REWRITE_TAC [EXTENSION] THEN
			PSET_TAC [GSYM GSPEC_F, GSPECIFICATION, IN_INTER, IN_DIFF] THEN
			PROVE_TAC []) THEN
		ASM_REWRITE_TAC [REAL_LE_LADD] THEN
		MATCH_MP_TAC PROB_INCREASING THEN
		RW_TAC std_ss [DIFF_SUBSET, EVENTS_DIFF]);

val SUM_REL_TWO_RV_SEC_MOMENT = store_thm
 ("SUM_REL_TWO_RV_SEC_MOMENT",
 (--`!M n. sum (0,n) (\x. & x pow 2 * sum (0,SUC x) (\i. M i (x - i))) =
        sum (0,n) (\x. sum (0,n - x) (\i. (&x pow 2 + &x * &i) * (M x i + M i x)))`--),
	REPEAT GEN_TAC THEN
	Induct_on `n` THEN1
        	RW_TAC real_ss [sum] THEN
	ONCE_REWRITE_TAC [sum] THEN
        	RW_TAC real_ss [] THEN
        	KNOW_TAC `!n. SUC n - n = 1` THEN1 (
                	GEN_TAC THEN
                	DECIDE_TAC) THEN
        	RW_TAC arith_ss [SUM_1] THEN
		RW_TAC real_ss [] THEN
		KNOW_TAC `sum (0,n) (\x. sum (0,SUC n - x)
           	(\i. (& x pow 2 + & (x * i)) * (M x i + M i x))) = 
		sum (0,n) (\x. sum (0,n - x)
           	(\i. (& x pow 2 + & (x * i)) * (M x i + M i x)) + 
			(& x pow 2 + & (x * (n - x))) * (M x (n-x) + M (n-x) x))` THEN1 (
			MATCH_MP_TAC SUM_EQ THEN
			RW_TAC arith_ss [REAL_EQ_MUL_LCANCEL] THEN
			Cases_on `r = 0` THEN1
				RW_TAC real_ss [sum] THEN	

				RW_TAC real_ss [] THEN
				KNOW_TAC `SUC n - r = SUC (n - r)` THEN1
                                	RW_TAC arith_ss [] THEN
				ASM_REWRITE_TAC [] THEN
                        	RW_TAC arith_ss [sum]) THEN
		ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		KNOW_TAC `(\x. sum (0,n - x) (\i. (& x pow 2 + & (x * i)) * (M x i + M i x)) +
         	(& x pow 2 + & (x * (n - x))) * (M x (n - x) + M (n - x) x)) = 
		(\x. (\x. sum (0,n - x) (\i. 
			(& x pow 2 + & (x * i)) * (M x i + M i x))) x + 
			(\x. (& x pow 2 + & (x * (n - x))) * 
				(M x (n - x) + M (n - x) x)) x)` THEN1
			RW_TAC std_ss [] THEN
        	ASM_REWRITE_TAC [SUM_ADD] THEN
        	POP_ASSUM K_TAC THEN
        	RW_TAC arith_ss [GSYM REAL_ADD_ASSOC, REAL_EQ_LADD, sum] THEN
		KNOW_TAC `sum (0,n)
      		(\x. (& x pow 2 + & (x * (n - x))) * (M x (n - x) + M (n - x) x)) =
		sum (0,n) (\x. &(x * n) * (M x (n - x) + M (n - x) x))` THEN1 (
			MATCH_MP_TAC SUM_EQ THEN
			RW_TAC arith_ss [GSYM REAL_MUL, real_sub, POW_2, REAL_ADD_LDISTRIB] THEN
			KNOW_TAC `(& r * & r + & r * & (n - r)) * M r (n - r) = 
			& r * & n * M r (n - r)` THEN1 (
				RW_TAC std_ss [REAL_EQ_RMUL] THEN
				Cases_on `(M r (n - r) = 0)` THEN1
					ASM_REWRITE_TAC [] THEN

					DISJ2_TAC THEN
					KNOW_TAC `&(n - r) = &n - &r` THEN1
						RW_TAC std_ss [REAL_SUB, SUB_EQ_0, 
									GSYM NOT_LESS] THEN
					ASM_REWRITE_TAC [REAL_SUB_LDISTRIB] THEN
					REAL_ARITH_TAC) THEN
			ASM_REWRITE_TAC [REAL_EQ_LADD] THEN
			KNOW_TAC `(& r * & r + & r * & (n - r)) = & r * & n` THEN1 (
				KNOW_TAC `&(n - r) = &n - &r` THEN1
					RW_TAC std_ss [REAL_SUB, SUB_EQ_0, GSYM NOT_LESS] THEN
				ASM_REWRITE_TAC [REAL_SUB_LDISTRIB] THEN
				REAL_ARITH_TAC) THEN		
			ASM_REWRITE_TAC []) THEN	
		ASM_REWRITE_TAC [] THEN	
		KNOW_TAC `sum (0,n) (\x. & (x * n) * (M x (n - x) + M (n - x) x)) +
    				& n pow 2 * (M n 0 + M 0 n) = 
		sum (0, SUC n) (\x. & (x * n) * (M x (n - x) + M (n - x) x))` THEN1
			RW_TAC arith_ss [sum, POW_2, REAL_MUL] THEN
		ASM_REWRITE_TAC [] THEN
		KILL_ALL_TAC THEN
		KNOW_TAC `(\x. & (x * n) * (M x (n - x) + M (n - x) x)) = 
			(\x. &n * (\x. &x * (M x (n - x) + M (n - x) x)) x)` THEN1 (
			RW_TAC std_ss [GSYM REAL_MUL, REAL_MUL_ASSOC] THEN
			PROVE_TAC [REAL_MUL_SYM, REAL_MUL_ASSOC]) THEN
		ASM_REWRITE_TAC [SUM_CMUL, POW_2, GSYM REAL_MUL_ASSOC, REAL_EQ_LMUL] THEN
		Cases_on `(& n = 0)` THEN1
			RW_TAC std_ss [] THEN

			DISJ2_TAC THEN
			KNOW_TAC `(\x. & x * M x (n - x) + & x * M (n - x) x) =
                        (\x. (\x. & x * M x (n - x)) x +
                        (\x. & x * M (n - x) x) x)` THEN1
                		RW_TAC std_ss [] THEN
        		ASM_REWRITE_TAC [SUM_ADD, REAL_ADD_LDISTRIB] THEN
        		POP_ASSUM K_TAC THEN
			KNOW_TAC `sum (0, SUC n) 
			(\x. (\x. & x * M (n - x) x) ((\x. n - x) x)) =
                	sum (0, SUC n) (\x. & x * M (n - x) x)` THEN1 (
                		MATCH_MP_TAC SUM_PERMUTE_0 THEN
                		RW_TAC std_ss [EXISTS_UNIQUE_THM] THEN1 (
					EXISTS_TAC (--`n - y:num`--) THEN
					RW_TAC arith_ss []) THEN

					RW_TAC arith_ss []) THEN
			FULL_SIMP_TAC std_ss [EQ_SYM_EQ] THEN
			POP_ASSUM K_TAC THEN
			KNOW_TAC `sum (0,SUC n) (\x. & (n - x) * M (n - (n - x)) (n - x)) =
        		sum (0,SUC n) (\x. & (n - x) * M x (n - x)) ` THEN1 (
				MATCH_MP_TAC SUM_EQ THEN
				RW_TAC arith_ss []) THEN
			ASM_REWRITE_TAC [GSYM SUM_ADD, GSYM SUM_CMUL] THEN
			POP_ASSUM K_TAC THEN
			SUFF_TAC `sum (0,n) (\n'. & n * (\i. M i (n - i)) n') + 
				& n * M n 0 = 
			sum (0,SUC n) (\n'. & n * (\i. M i (n - i)) n')` THEN1 (
				RW_TAC std_ss [] THEN
				MATCH_MP_TAC SUM_EQ THEN
				RW_TAC arith_ss [] THEN
				RW_TAC arith_ss [GSYM REAL_ADD_RDISTRIB, REAL_ADD]) THEN

				RW_TAC arith_ss [sum]);

val SUMMABLE_SECOND_MOMENT = store_thm
 ("SUMMABLE_SECOND_MOMENT",
 (--`!(X: (num -> bool) -> num#(num -> bool)) (Y: (num -> bool) -> num#(num -> bool)).
         X IN indep_fn /\ Y IN indep_fn /\
         summable (\n. & n * prob bern {s | FST (X s) = n}) /\
         summable (\n. & n * prob bern {s | FST (Y s) = n}) /\
         summable (\n. (\x. & x pow 2) n * prob bern {s | FST (X s) = n}) /\
         summable (\n. (\x. & x pow 2) n * prob bern {s | FST (Y s) = n}) ==>
		(summable (\x. & x pow 2 *
              		prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}))`--),
	RW_TAC std_ss [SUM_RV_BIGUNION, summable] THEN
	KNOW_TAC `!x n. prob bern (BIGUNION (IMAGE
                (\i. {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = x - i)}) {i | i <= x})) =
                                sum (0,SUC x) (\i. prob bern {s | (FST (X s) = i) /\
                                                        (FST (Y (SND (X s))) = x - i)})` THEN1 (
        	GEN_TAC THEN
        	MATCH_MP_TAC PROB_ADDITIVE_ON_SUM_RV THEN
        	RW_TAC std_ss []) THEN
	FULL_SIMP_TAC std_ss [GSYM SER_CMUL] THEN
	POP_ASSUM K_TAC THEN
	RW_TAC std_ss [sums, GSYM convergent] THEN
	MATCH_MP_TAC SEQ_BCONV THEN
	CONJ_TAC THENL [
		MATCH_MP_TAC SEQ_BOUNDED_2 THEN
        	EXISTS_TAC (--`0:real`--) THEN
        	EXISTS_TAC (--`s'' + (s''':real) + 2 * s * s'`--) THEN
        	GEN_TAC THEN
        	CONJ_TAC THENL [
                	RW_TAC std_ss [] THEN
                	MATCH_MP_TAC SUM_POS THEN
                	RW_TAC std_ss [] THEN
                	MATCH_MP_TAC REAL_LE_MUL THEN
                	RW_TAC real_ss [GSYM REAL_ADD, REAL_LE_POW2] THEN
                	MATCH_MP_TAC SUM_POS THEN
                	RW_TAC std_ss [] THEN
                	MATCH_MP_TAC PROB_POSITIVE THEN
                	RW_TAC std_ss [PROB_SPACE_BERN, EVENT_EQ_INTER_BERN],

                	RW_TAC std_ss [] THEN
			KNOW_TAC `sum (0,n) (\x. & x pow 2 *
                		sum (0,SUC x) (\i. prob bern
                        	{s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = x - i)})) = 
				sum (0,n) (\x. & x pow 2 * sum (0,SUC x) (\i. 
				(\l m. prob bern 
				{s | (FST (X s) = l) /\ (FST (Y (SND (X s))) = m)}) i (x-i)))` THEN1
				RW_TAC std_ss [] THEN
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			RW_TAC std_ss [SUM_REL_TWO_RV_SEC_MOMENT] THEN
                	MATCH_MP_TAC REAL_LE_TRANS THEN
			EXISTS_TAC (--`sum (0,n) (\x. sum (0,n) (\i. (& x pow 2 + & x * & i) * 
			(prob bern
                   		{s | (FST ((X: (num -> bool) -> num#(num -> bool))s) = x) 
				/\ (FST ((Y: (num -> bool) -> num#(num -> bool))
					 (SND (X s))) = i)} +
                 	prob bern {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = x)})))`--) THEN
                	CONJ_TAC THENL [
				MATCH_MP_TAC SUM_LE THEN
				RW_TAC arith_ss [] THEN
				KNOW_TAC `!n. 0 <=  (\i.
         			(& r pow 2 + & r * & i) *
         			(prob bern {s | (FST (X s) = r) /\ (FST (Y (SND (X s))) = i)} +
          		 	prob bern {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = r)})) n` THEN1 (
					RW_TAC std_ss [] THEN
					MATCH_MP_TAC REAL_LE_MUL THEN
					KNOW_TAC `!a b. 0 <= prob bern 
					{s | (FST (X s) = a) /\ (FST (Y (SND (X s))) = b)}` THEN1 (
						REPEAT GEN_TAC THEN
						MATCH_MP_TAC PROB_POSITIVE THEN
						RW_TAC std_ss [PROB_SPACE_BERN, 
							EVENT_EQ_INTER_BERN]) THEN	
					RW_TAC real_ss [POW_POS, REAL_LE_ADD]) THEN
				POP_ASSUM MP_TAC THEN
				Q.SPEC_TAC (`(\i.
         			(& r pow 2 + & r * & i) *
         			(prob bern {s | (FST (X s) = r) /\ (FST (Y (SND (X s))) = i)} +
          		 	prob bern {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = r)}))`, `f`) THEN
				REPEAT STRIP_TAC THEN
				MP_TAC (Q.SPECL [`f`, `n-r`, `r`] SUM_DIFF) THEN
				ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
				RW_TAC arith_ss [REAL_EQ_SUB_RADD] THEN
				ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
				REWRITE_TAC [REAL_LE_ADDR] THEN
				RW_TAC std_ss [SUM_POS],

				KNOW_TAC `!a b.{s | (FST (X s) = a) /\ (FST (Y (SND (X s))) = b)} = 
				{s | (FST (X s) = a)} INTER {s | (FST (Y (SND (X s))) = b)}` THEN1 (
					REPEAT GEN_TAC THEN
					ONCE_REWRITE_TAC [EXTENSION] THEN
					PSET_TAC [GSPECIFICATION, IN_INTER]) THEN
				ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				KNOW_TAC `!a b. prob bern ({s | FST (X s) = a} INTER
                    		{s | FST (Y (SND (X s))) = b}) =
				prob bern {s | FST (X s) = a} * prob bern {s | FST (Y s) = b}` THEN1 (
					REPEAT GEN_TAC THEN
					KNOW_TAC `{s | FST (X  s) = a} = ((\y. y = a) o FST o X )` THEN1
							PSET_TAC [o_DEF] THEN
					KNOW_TAC `{s | FST (Y  (SND (X  s))) = b} = 	
						((\y. FST (Y  y) = b) o SND o X )` THEN1
						PSET_TAC [o_DEF] THEN		
					ONCE_ASM_REWRITE_TAC [] THEN
					KNOW_TAC `{s | FST (Y s) = b} = (\y. FST (Y y) = b)` THEN1 (
						REWRITE_TAC [EXTENSION] THEN
						PSET_TAC [GSPECIFICATION]) THEN
					ONCE_ASM_REWRITE_TAC [] THEN
					MATCH_MP_TAC INDEP_FN_PROB THEN
					KNOW_TAC `(\y. FST (Y y) = b) = ((\y. y = b) o FST o Y)` THEN1
						PSET_TAC [o_DEF] THEN
					ONCE_ASM_REWRITE_TAC [] THEN
					RW_TAC std_ss [INDEP_FN_FST_EVENTS]) THEN			
				ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				KNOW_TAC `sum (0,n) (\x. sum (0,n) (\i.
              			(& x pow 2 + & x * & i) *
              			(prob bern {s | FST (X s) = x} *
               			prob bern {s | FST (Y s) = i} +
               			prob bern {s | FST (X s) = i} *
               			prob bern {s | FST (Y s) = x}))) =
					(\n. sum (0,n) (\x. sum (0,n) (\i.
              				(& x pow 2 + & x * & i) *
              				(prob bern {s | FST (X s) = x} *
               				prob bern {s | FST (Y s) = i} +
               				prob bern {s | FST (X s) = i} *
               				prob  bern {s | FST (Y s) = x})))) n ` THEN1
					RW_TAC std_ss [] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				MATCH_MP_TAC SEQ_MONO_LE THEN
				CONJ_TAC THENL [
					RW_TAC std_ss [GSYM ADD1] THEN
					KNOW_TAC `!n x. 0 <= (\i. (& x pow 2 + & x * & i) *
              				(prob bern {s | FST (X s) = x} *
               				prob bern {s | FST (Y s) = i} +
               				prob bern {s | FST (X s) = i} *
               				prob bern {s | FST (Y s) = x})) n` THEN1 (
						RW_TAC std_ss [] THEN
						MATCH_MP_TAC REAL_LE_MUL THEN
						KNOW_TAC `!a. 0 <= prob bern {s | FST (X s) = a}` THEN1 (
							REPEAT STRIP_TAC THEN
							MATCH_MP_TAC PROB_POSITIVE THEN
							RW_TAC std_ss [PROB_SPACE_BERN] THEN 
							KNOW_TAC `{s | FST (X s) = a} = 
							((\y. y = a) o FST o X)` THEN1
								PSET_TAC [o_DEF] THEN
							ASM_REWRITE_TAC [] THEN
							MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
							RW_TAC std_ss []) THEN
						KNOW_TAC `!a. 0 <= prob bern {s | FST (Y s) = a}` THEN1 (
							REPEAT STRIP_TAC THEN
							MATCH_MP_TAC PROB_POSITIVE THEN
							RW_TAC std_ss [PROB_SPACE_BERN] THEN 
							KNOW_TAC `{s | FST (Y s) = a} = 
							((\y. y = a) o FST o Y)` THEN1
								PSET_TAC [o_DEF] THEN
							ASM_REWRITE_TAC [] THEN
							MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
							RW_TAC std_ss []) THEN
					RW_TAC real_ss [POW_POS, REAL_LE_ADD, REAL_LE_MUL]) THEN
				ONCE_REWRITE_TAC [sum] THEN
				MATCH_MP_TAC REAL_LE_TRANS THEN
				EXISTS_TAC (--`sum (0,n)
        			(\x.
           			sum (0,SUC n)
             			(\i.
                		(& x pow 2 + & x * & i) *
                		(prob bern {s | FST ((X: (num -> bool) -> num#(num -> bool)) s) = x} *
                 		prob bern {s | FST ((Y: (num -> bool) -> num#(num -> bool)) s) = i} +
                 		prob bern {s | FST (X s) = i} *
                 		prob bern {s | FST (Y s) = x})))`--) THEN
				CONJ_TAC THENL [
					MATCH_MP_TAC SUM_LE THEN
					RW_TAC arith_ss [] THEN
					ASM_REWRITE_TAC [sum, REAL_LE_ADDR],
				
					RW_TAC std_ss [REAL_LE_ADDR] THEN
					MATCH_MP_TAC SUM_POS THEN
					RW_TAC std_ss []],

				KNOW_TAC `!n x. (\i.(& x pow 2 + & x * & i) *
                 			(prob bern {s | FST (X s) = x} *
                  			prob bern {s | FST (Y s) = i} +
                  			prob bern {s | FST (X s) = i} *
                  			prob bern {s | FST (Y s) = x})) =
				(\i. (\i. (\i. & x pow 2 * 
					(prob bern {s | FST (X s) = x} *
                  			 prob bern {s | FST (Y s) = i})) i + 
					 (\i. & x pow 2 * 
					(prob bern {s | FST (X s) = i} *
                  			 prob bern {s | FST (Y s) = x})) i) i +
				      (\i. (\i. & x * & i *
					 (prob bern {s | FST (X s) = x} *
                  			 prob bern {s | FST (Y s) = i})) i + 
					   (\i. & x * & i *
					(prob bern {s | FST (X s) = i} *
                  			 prob bern {s | FST (Y s) = x})) i) i)` THEN1
					RW_TAC std_ss [REAL_ADD_LDISTRIB, REAL_ADD_RDISTRIB] THEN
				ASM_REWRITE_TAC [SUM_ADD] THEN
				KNOW_TAC `!n. (\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = x} *
                 		 prob bern {s | FST (Y s) = i})) +
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = i} *
                  		prob bern {s | FST (Y s) = x})) +
            			(sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = x} *
                  		 prob bern {s | FST (Y s) = i})) +
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = i} *
                   		prob bern {s | FST (Y s) = x})))) =
				(\x. (\x. (\x. sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = x} *
                 		 prob bern {s | FST (Y s) = i}))) x + 
				(\x. sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = i} *
                  		prob bern {s | FST (Y s) = x}))) x) x + 
				(\x. (\x. (sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = x} *
                  		 prob bern {s | FST (Y s) = i})))) x + 
				(\x. sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = i} *
                   		prob bern {s | FST (Y s) = x})))x)x)` THEN1
						RW_TAC std_ss [REAL_ADD_LDISTRIB, REAL_ADD_RDISTRIB] THEN
				ASM_REWRITE_TAC [SUM_ADD] THEN
				NTAC 2 (POP_ASSUM K_TAC) THEN
				KNOW_TAC `(\n. sum (0,n) (\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = x} *
                  		prob bern {s | FST (Y s) = i}))) +
       				sum (0,n)
         			(\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = i} *
                  		prob bern {s | FST (Y s) = x}))) +
       				(sum (0,n)
          			(\x.
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = x} *
                   		prob bern {s | FST (Y s) = i}))) +
        			sum (0,n)
          			(\x.
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = i} *
                   		prob bern {s | FST (Y s) = x}))))) = 
				(\n. (\n. (\n. sum (0,n) (\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = x} *
                  		prob bern {s | FST (Y s) = i})))) n + 
				(\n. sum (0,n)
         			(\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = i} *
                  		prob bern {s | FST (Y s) = x})))) n) n +
				(\n. (sum (0,n)
          			(\x.
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = x} *
                   		prob bern {s | FST (Y s) = i}))) +
        			sum (0,n)
          			(\x.
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = i} *
                   		prob bern {s | FST (Y s) = x}))))) n)` THEN1
						RW_TAC std_ss [] THEN
				ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				MATCH_MP_TAC SEQ_ADD THEN
				CONJ_TAC THENL [
					MATCH_MP_TAC SEQ_ADD THEN
					CONJ_TAC THENL [
						KNOW_TAC `(\n.
       							sum (0,n)
         						(\x.
            						sum (0,n)
              						(\i.
                 					& x pow 2 *
                 					(prob bern {s | FST (X s) = x} *
                  					prob bern {s | FST (Y s) = i})))) = 
							(\n. (\n. sum (0,n) (\x. & x pow 2 *
                 					prob bern {s | FST (X s) = x})) n *
							(\n. sum (0,n) (\i. 
							prob bern {s | FST (Y s) = i}))n )` THEN1 (
							RW_TAC std_ss [] THEN
							KNOW_TAC `!x. (\i.
                 					& x pow 2 *
                 					(prob bern {s | FST (X s) = x} *
                  					prob bern {s | FST (Y s) = i})) = 
							(\i. (& x pow 2 *
							prob bern {s | FST (X s) = x}) * (\i.
							prob bern {s | FST (Y s) = i}) i)` THEN1
								RW_TAC std_ss [REAL_MUL_ASSOC] THEN
							ASM_REWRITE_TAC [SUM_CMUL] THEN
							POP_ASSUM K_TAC THEN
							KNOW_TAC `!n. (\x.
            						& x pow 2 * prob bern {s | FST (X s) = x} *
            						sum (0,n) 
							(\i. prob bern {s | FST (Y s) = i})) = 
							(\x. sum (0,n) 
								(\i. prob bern {s | FST (Y s) = i}) *
								(\x. & x pow 2 * 
								prob bern {s | FST (X s) = x}) x)` THEN1 (
								RW_TAC std_ss [] THEN
								PROVE_TAC [REAL_MUL_SYM]) THEN
							ASM_REWRITE_TAC [SUM_CMUL] THEN
							POP_ASSUM K_TAC THEN	
							PROVE_TAC [REAL_MUL_SYM]) THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN		
						KNOW_TAC `s'' = s'' * 1` THEN1
							RW_TAC real_ss [] THEN
						ONCE_ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						MATCH_MP_TAC SEQ_MUL THEN
						FULL_SIMP_TAC std_ss [sums] THEN
						REWRITE_TAC [GSYM sums] THEN
						MATCH_MP_TAC PMF_SUMS_1 THEN
						RW_TAC std_ss [],
					
						KNOW_TAC `!x. (\i.
                 				& x pow 2 * (prob bern {s | FST (X s) = i} *
                  				prob bern {s | FST (Y s) = x})) = 
						(\i. & x pow 2 * prob bern {s | FST (Y s) = x} *
						(\i. prob bern {s | FST (X s) = i}) i)` THEN1 (
							RW_TAC std_ss [] THEN
							PROVE_TAC [REAL_MUL_SYM, REAL_MUL_ASSOC]) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						KNOW_TAC `!n. (\x. & x pow 2 * 
						prob bern {s | FST (Y s) = x} *
            					sum (0,n) (\i. prob bern {s | FST (X s) = i})) =
						(\x. sum (0,n) (\i. prob bern {s | FST (X s) = i}) *
							(\x. & x pow 2 * 
								prob bern {s | FST (Y s) = x}) x)` THEN1 (
							RW_TAC std_ss [] THEN
							PROVE_TAC [REAL_MUL_SYM]) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						KNOW_TAC `(\n. sum (0,n) 
						(\i. prob bern {s | FST (X s) = i}) *
       						sum (0,n) 
						(\x. & x pow 2 * prob bern {s | FST (Y s) = x})) = 
						(\n. (\n. sum (0,n) 
						(\i. prob bern {s | FST (X s) = i}))n  *
       						(\n. sum (0,n) 
						(\x. & x pow 2 * 
						prob bern {s | FST (Y s) = x})) n)` THEN1
							RW_TAC std_ss [] THEN
						ASM_REWRITE_TAC [] THEN
						NTAC 3 (POP_ASSUM K_TAC) THEN
						KNOW_TAC `s''' = 1 * s'''` THEN1
							RW_TAC real_ss [] THEN
						ONCE_ASM_REWRITE_TAC [] THEN
						MATCH_MP_TAC SEQ_MUL THEN
						FULL_SIMP_TAC std_ss [sums] THEN
						REWRITE_TAC [GSYM sums] THEN
						MATCH_MP_TAC PMF_SUMS_1 THEN
						RW_TAC std_ss []],
				
					REWRITE_TAC [GSYM REAL_DOUBLE, REAL_ADD_RDISTRIB] THEN
					KNOW_TAC `(\n. sum (0,n)
         				(\x.
            				sum (0,n)
              				(\i.
                 			& x * & i *
                 			(prob bern {s | FST (X s) = x} *
                  			prob bern {s | FST (Y s) = i}))) +
       					sum (0,n)
         				(\x.
            				sum (0,n)
              				(\i.
                 			& x * & i *
                 			(prob bern {s | FST (X s) = i} *
                  			prob bern {s | FST (Y s) = x})))) = 
					(\n. (\n. sum (0,n)
         				(\x.
            				sum (0,n)
              				(\i.
                 			& x * & i *
                 			(prob bern {s | FST (X s) = x} *
                  			prob bern {s | FST (Y s) = i})))) n +
       					(\n. sum (0,n)
         				(\x.
            				sum (0,n)
              				(\i.
                 			& x * & i *
                 			(prob bern {s | FST (X s) = i} *
                  			prob bern {s | FST (Y s) = x})))) n)` THEN1
							RW_TAC std_ss [] THEN
					ASM_REWRITE_TAC [] THEN
					POP_ASSUM K_TAC THEN
					MATCH_MP_TAC SEQ_ADD THEN
					CONJ_TAC THENL [
						KNOW_TAC `!x. (\i.
                 				& x * & i *
                 				(prob bern {s | FST (X s) = x} *
                  				prob bern {s | FST (Y s) = i})) = 
						(\i. & x * prob bern {s | FST (X s) = x} *
							(\i. & i *
							prob bern {s | FST (Y s) = i}) i)` THEN1 (
							RW_TAC std_ss [] THEN
							SUFF_TAC `!i. & x * & i *
       							(prob bern {s | FST (X s) = x} * 
							prob bern {s | FST (Y s) = i}) = 
							& x * prob bern {s | FST (X s) = x} *
							(& i * prob bern {s | FST (Y s) = i})` THEN1
								RW_TAC std_ss [] THEN
							GEN_TAC THEN
							REAL_ARITH_TAC) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `!n. (\x. & x * prob bern {s | FST (X s) = x} *
            					sum (0,n) (\i. & i * 
						prob bern {s | FST (Y s) = i})) = 
						(\x. sum (0,n) (\i. & i *
							prob bern {s | FST (Y s) = i}) * 
							(\x. & x * 
							prob bern {s | FST (X s) = x}) x)` THEN1 (
							RW_TAC std_ss [] THEN
							PROVE_TAC [REAL_MUL_SYM]) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `(\n. sum (0,n) 
						(\i. & i * prob bern {s | FST (Y s) = i}) *
       						sum (0,n) 
						(\x. & x * prob bern {s | FST (X s) = x})) = 
						(\n. (\n. sum (0,n) 
						(\i. & i * prob bern {s | FST (Y s) = i})) n *
       						(\n. sum (0,n) 
						(\x. & x * prob bern {s | FST (X s) = x})) n)` THEN1
							RW_TAC std_ss [] THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `s * s' = s' * s` THEN1
							PROVE_TAC [REAL_MUL_SYM] THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						MATCH_MP_TAC SEQ_MUL THEN
						FULL_SIMP_TAC std_ss [sums],

						KNOW_TAC `!x. (\i. & x * & i *
                 				(prob bern {s | FST (X s) = i} *
                  				prob bern {s | FST (Y s) = x})) = 
						(\i. & x * prob bern {s | FST (Y s) = x} *
							(\i. & i *
							prob bern {s | FST (X s) = i}) i)` THEN1 (
								RW_TAC std_ss [] THEN
								SUFF_TAC `!i. & x * & i *
       								(prob bern {s | FST (X s) = i} * 
								prob bern {s | FST (Y s) = x}) = 
								& x * prob bern {s | FST (Y s) = x} *
								(& i * 
								prob bern {s | FST (X s) = i})` THEN1
									RW_TAC std_ss [] THEN
							
									GEN_TAC THEN
									REAL_ARITH_TAC) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `!n. (\x. & x * prob bern {s | FST (Y s) = x} *
            					sum (0,n) (\i. & i * 
						prob bern {s | FST (X s) = i})) = 
						(\x. sum (0,n) (\i. & i *
							prob bern {s | FST (X s) = i}) * 
							(\x. & x * 
							prob bern {s | FST (Y s) = x}) x)` THEN1 (
							RW_TAC std_ss [] THEN
							PROVE_TAC [REAL_MUL_SYM]) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `(\n. sum (0,n) 
						(\i. & i * prob bern {s | FST (X s) = i}) *
       						sum (0,n) 
						(\x. & x * prob bern {s | FST (Y s) = x})) = 
						(\n. (\n. sum (0,n) 
						(\i. & i * prob bern {s | FST (X s) = i})) n *
       						(\n. sum (0,n) 
						(\x. & x * prob bern {s | FST (Y s) = x})) n)` THEN1
							RW_TAC std_ss [] THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						MATCH_MP_TAC SEQ_MUL THEN
						FULL_SIMP_TAC std_ss [sums]]]]]],
		REWRITE_TAC [MONO_SUC, real_ge] THEN
		DISJ1_TAC THEN
		REWRITE_TAC [GSYM SUM_CMUL] THEN
		GEN_TAC THEN
		KNOW_TAC `!n x. 0 <= (\n. & x pow 2 *
                 (\i. prob bern {x' |
                       (FST (X x') = i) /\ (FST (Y (SND (X x'))) = x - i)}) n) n` THEN1 (
			RW_TAC std_ss [] THEN
			MATCH_MP_TAC REAL_LE_MUL THEN
			KNOW_TAC `!a b. 0 <= prob bern 
			{s | (FST (X s) = a) /\ (FST (Y (SND (X s))) = b)}` THEN1 (
				REPEAT GEN_TAC THEN
				MATCH_MP_TAC PROB_POSITIVE THEN
				RW_TAC std_ss [PROB_SPACE_BERN, EVENT_EQ_INTER_BERN]) THEN	
			RW_TAC real_ss [POW_POS]) THEN
		RW_TAC arith_ss [sum, REAL_LE_ADDR] THEN
		MATCH_MP_TAC REAL_LE_ADD THEN
		CONJ_TAC THENL [
			MATCH_MP_TAC SUM_POS THEN
			FULL_SIMP_TAC std_ss [],
		
			MATCH_MP_TAC REAL_LE_MUL THEN
			RW_TAC real_ss [POW_POS] THEN	
			MATCH_MP_TAC PROB_POSITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN, EVENT_EQ_INTER_BERN]]]);


val VARIANCE_TWO_RV_SUMMABLE = store_thm
 ("VARIANCE_TWO_RV_SUMMABLE",
 (--`!(X: (num -> bool) -> num#(num -> bool)) (Y: (num -> bool) -> num#(num -> bool)). 
	 X IN indep_fn /\ Y IN indep_fn /\
	 summable (\n. & n * prob bern {s | FST (X s) = n}) /\
         summable (\n. & n * prob bern {s | FST (Y s) = n}) /\
	 summable (\n. (\x. & x pow 2) n * prob bern {s | FST (X s) = n}) /\
	 summable (\n. (\x. & x pow 2) n * prob bern {s | FST (Y s) = n}) ==>
		summable (\x.(& x - expec
            		 (\x. (FST (X x) + 
				FST (Y (SND (X x))),SND (Y (SND (X x)))))) pow 2 * 
				prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})`--),
	RW_TAC std_ss [summable] THEN
	Q.SPEC_TAC (`expec
            (\x. (FST (X x) + FST (Y (SND (X x))),SND (Y (SND (X x)))))`, `A`) THEN
	GEN_TAC THEN
	KNOW_TAC `!x A. (& x - A) pow 2 = &x pow 2 + A pow 2 - 2 * A * &x` THEN1 (
		RW_TAC std_ss [POW_2] THEN
		REAL_ARITH_TAC) THEN
	ASM_REWRITE_TAC [real_sub, GSYM REAL_ADD_ASSOC, REAL_ADD_RDISTRIB] THEN
	FULL_SIMP_TAC std_ss [REAL_ADD_ASSOC, sums] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `(\x.
              & x pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x} +
              A pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x} +
              ~(2 * A * & x) *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) =
	(\x. (\x. 
		& x pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) x + 
		(\x. A pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x} +
              ~(2 * A * & x) *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) x)` THEN1
		RW_TAC std_ss [REAL_ADD_ASSOC] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	REWRITE_TAC [SUM_ADD] THEN		
	KNOW_TAC `(\x.
              A pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x} +
              ~(2 * A * & x) *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) = 
	(\x. (\x.
              A pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) x +
		(\x. ~(2 * A * & x) *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) x)` THEN1
		RW_TAC std_ss [] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	REWRITE_TAC [SUM_ADD, REAL_ADD_ASSOC] THEN		
	KNOW_TAC `(\n.
         sum (0,n)
           (\x.
              & x pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) +
         sum (0,n)
           (\x.
              A pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) +
         sum (0,n)
           (\x.
              ~(2 * A * & x) *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) =
	(\n. (\n.
	sum (0,n)
           (\x.
              & x pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n +
		(\n. sum (0,n)
           (\x.
              A pow 2 *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n + 
		(\n. sum (0,n)
           (\x.
              ~(2 * A * & x) *
              prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n)` THEN1
		RW_TAC std_ss [] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	SUFF_TAC `?l. (\n.
            sum (0,n)
              (\x.
                 & x pow 2 *
                 prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) --> l` THENL [
		SUFF_TAC `?l'. (\n.
            sum (0,n)
              (\x.
                 A pow 2 *
                 prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) --> l'` THENL [
			SUFF_TAC `?l''. (\n.
            		sum (0,n)
              		(\x.
                 	~(2 * A * & x) *
                 	prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) --> l''` THENL [
				REPEAT STRIP_TAC THEN
				EXISTS_TAC (--`l + l' + (l'': real)`--) THEN
				ONCE_REWRITE_TAC [GSYM REAL_ADD_ASSOC] THEN
				KNOW_TAC `(\n.
       				(\n.
          			sum (0,n)
            				(\x.
               				& x pow 2 *
               				prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n +
       					((\n.
           				sum (0,n)
             				(\x.
                			A pow 2 *
                			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n +
        				(\n.
           				sum (0,n)
             				(\x.
                			~(2 * A * & x) *
                			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}))
          				n)) = 
				(\n.
       				(\n.
          			sum (0,n)
            				(\x.
               				& x pow 2 *
               				prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n +
				(\n. ((\n.
           				sum (0,n)
             				(\x.
                			A pow 2 *
                			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n +
        				(\n.
           				sum (0,n)
             				(\x.
                			~(2 * A * & x) *
                			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}))
          				n)) n)` THEN1
					RW_TAC std_ss [] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				MATCH_MP_TAC SEQ_ADD THEN
				CONJ_TAC THEN1
					RW_TAC std_ss [] THEN

					MATCH_MP_TAC SEQ_ADD THEN	
					RW_TAC std_ss [],

				REWRITE_TAC [GSYM REAL_MUL_ASSOC] THEN
				RW_TAC std_ss [REAL_NEG_LMUL] THEN
				KNOW_TAC `(\x.
              			~2 * (A * & x) *
              			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) = 
				(\x. (~2 * A) * (\x. & x  *
              			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) x)` THEN1
					RW_TAC std_ss [REAL_MUL_ASSOC] THEN
				ASM_REWRITE_TAC [SUM_CMUL] THEN
				MP_TAC (Q.SPECL [`X`, `Y`] SUM_TWO_RV_SUMMABLE) THEN
				RW_TAC std_ss [] THEN
				KNOW_TAC `summable (\x. & x * prob bern {s | FST (X s) = x}) /\
          			summable (\x. & x * prob bern {s | FST (Y s) = x})` THEN1 (
					RW_TAC std_ss [summable, sums] THENL [
						EXISTS_TAC (--`s:real`--) THEN
						ASM_REWRITE_TAC [],

						EXISTS_TAC (--`s':real`--) THEN
                                        	ASM_REWRITE_TAC []]) THEN
				FULL_SIMP_TAC std_ss [] THEN
				NTAC 2 (POP_ASSUM K_TAC) THEN
				FULL_SIMP_TAC std_ss [summable, sums] THEN
				KNOW_TAC `(\n. ~2 * A * sum (0,n)
           			(\x. & x * prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) = 
				(\n. (\n.~2 * A) n * (\n. sum (0,n)
           			(\x. & x * prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n)` THEN1
					RW_TAC std_ss [] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				EXISTS_TAC (--`(~2 * A) * (s'''':real)`--) THEN
				MATCH_MP_TAC SEQ_MUL THEN
				RW_TAC std_ss [SEQ_CONST]],
		
			EXISTS_TAC (--`A pow 2 * 1`--) THEN
			RW_TAC std_ss [SUM_CMUL] THEN
			KNOW_TAC `(\n.
       			A pow 2 *
       			sum (0,n)
         		(\x. prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) =
                	(\n. (\n. A pow 2) n * (\n. sum (0,n)
                        (\x. prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n)` THEN1
				RW_TAC std_ss [] THEN
			ONCE_ASM_REWRITE_TAC [] THEN
                	POP_ASSUM K_TAC THEN
			MATCH_MP_TAC SEQ_MUL THEN
			RW_TAC std_ss [SEQ_CONST, GSYM sums] THEN
			KNOW_TAC `!x'. FST (X x') + 
				FST (Y (SND (X x'))) = (\x'. FST (X x') + FST (Y (SND (X x')))) x'` THEN1
                        	RW_TAC std_ss [] THEN
                	ONCE_ASM_REWRITE_TAC [] THEN
			REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
			KNOW_TAC `(\x. prob bern
         		{x' | (\x'. FST (X x') + FST (Y (SND (X x')))) x' = x}) = 
                  	(prob bern o (\n. {s | ((\x'. FST (X x') + FST (Y (SND (X x')))) s) = n}))` THEN1
       				RW_TAC std_ss [o_DEF] THEN
    			ONCE_ASM_REWRITE_TAC [] THEN
			MATCH_MP_TAC PROB_COUNTABLY_ADDITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN, DISJOINT_DEF, INTER_DEF, SPECIFICATION, IN_FUNSET] THENL [
				RW_TAC std_ss [SUM_RV_BIGUNION] THEN
				ONCE_REWRITE_TAC [GSYM SPECIFICATION] THEN
				MATCH_MP_TAC EVENT_EQ_BIGUNION_BERN THEN
				ASM_REWRITE_TAC [],

				PSET_TAC [GSPECIFICATION] THEN
                    		DISJ2_TAC THEN
                    		CCONTR_TAC THEN
                    		PROVE_TAC [],
			
				RW_TAC std_ss [EXTENSION, IN_UNIV, IN_BIGUNION_IMAGE,
                                      GSPECIFICATION] THEN
				EXISTS_TAC (--`(x:(num -> bool))`--) THEN
       	             		PROVE_TAC []]],
		
			MP_TAC (Q.SPECL [`X`, `Y`] SUMMABLE_SECOND_MOMENT) THEN
			RW_TAC std_ss [] THEN
			KNOW_TAC `summable (\x. & x * prob bern {s | FST (X s) = x}) /\
          		summable (\x. & x * prob bern {s | FST (Y s) = x}) /\
			summable (\n. & n pow 2 * prob bern {s | FST (X s) = n}) /\
          		summable (\n. & n pow 2 * prob bern {s | FST (Y s) = n})` THEN1 (
				RW_TAC std_ss [summable, sums] THENL [
					EXISTS_TAC (--`s:real`--) THEN
					ASM_REWRITE_TAC [],

					EXISTS_TAC (--`s':real`--) THEN
                                	ASM_REWRITE_TAC [],
				
					EXISTS_TAC (--`s'':real`--) THEN
					ASM_REWRITE_TAC [],

					EXISTS_TAC (--`s''':real`--) THEN
                                	ASM_REWRITE_TAC []]) THEN
			FULL_SIMP_TAC std_ss [] THEN
			NTAC 4 (POP_ASSUM K_TAC) THEN
			FULL_SIMP_TAC std_ss [summable, sums] THEN
			EXISTS_TAC (--`s'''':real`--) THEN
			RW_TAC std_ss []]);


val TWO_RV_VARIANCE_HELPER = store_thm
 ("TWO_RV_VARIANCE_HELPER",
 (--`!(X: (num -> bool) -> num#(num -> bool)) (Y: (num -> bool) -> num#(num -> bool)) m. 
	 X IN indep_fn /\ Y IN indep_fn /\
	 summable (\n. & n * prob bern {s | FST (X s) = n}) /\
         summable (\n. & n * prob bern {s | FST (Y s) = n}) /\
	 summable (\n. (\x. & x pow 2) n * prob bern {s | FST (X s) = n}) /\
	 summable (\n. (\x. & x pow 2) n * prob bern {s | FST (Y s) = n}) /\
	 ((\n. sum (0,n) (\x.
            sum (0,n) (\i.
                 (& x pow 2 + & x * & i) * (prob bern
                    {s | (FST (X s) = x) /\ (FST (Y (SND (X s))) = i)} +
                  prob bern {s |
                     (FST (X s) = i) /\ (FST (Y (SND (X s))) = x)})))) --> m) ==>
		((\n. sum (0,n) (\x.
            & x pow 2 *
            prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) --> m)`--),
	REPEAT STRIP_TAC THEN
	MP_TAC (Q.SPECL [`X`, `Y`] SUMMABLE_SECOND_MOMENT) THEN
	RW_TAC std_ss [] THEN
	FULL_SIMP_TAC std_ss [SUM_RV_BIGUNION, summable] THEN
	KNOW_TAC `!x n. prob bern (BIGUNION (IMAGE
       		(\i. {s | (FST (X s) = i) /\ 
		(FST (Y (SND (X s))) = x - i)}) {i | i <= x})) =
        	sum (0,SUC x) (\i. prob bern {s | (FST (X s) = i) /\
        	(FST (Y (SND (X s))) = x - i)})` THEN1 (
        	GEN_TAC THEN
        	MATCH_MP_TAC PROB_ADDITIVE_ON_SUM_RV THEN
        	RW_TAC std_ss []) THEN
	FULL_SIMP_TAC std_ss [GSYM SER_CMUL, sums] THEN
	POP_ASSUM K_TAC THEN
	POP_ASSUM MP_TAC THEN
	KNOW_TAC `!n. sum (0,n) (\x. & x pow 2 *
        sum (0,SUC x) (\i. prob bern
        {x' | (FST (X x') = i) /\ (FST (Y (SND (X x'))) = x - i)})) = 
	sum (0,n) (\x. & x pow 2 * sum (0,SUC x) (\i. 
	(\l m. prob bern 
	{s | (FST (X s) = l) /\ (FST (Y (SND (X s))) = m)}) i (x-i)))` THEN1
		RW_TAC std_ss [] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	RW_TAC std_ss [SUM_REL_TWO_RV_SEC_MOMENT] THEN
	KNOW_TAC `(!m. {s | FST (X s) = m} IN events bern)` THEN1 (
		GEN_TAC THEN
		KNOW_TAC `{s | FST (X s) = m'} = ((\y. y = m') o FST o X)` THEN1 
			PSET_TAC [o_DEF] THEN
		RW_TAC std_ss [INDEP_FN_FST_EVENTS]) THEN
	KNOW_TAC `(!m. {s | FST (Y s) = m} IN events bern)` THEN1 (
		GEN_TAC THEN
		KNOW_TAC `{s | FST (Y s) = m'} = ((\y. y = m') o FST o Y)` THEN1
			PSET_TAC [o_DEF] THEN
		RW_TAC std_ss [INDEP_FN_FST_EVENTS]) THEN
	KNOW_TAC `s'''' <= m` THEN1 (
        	MATCH_MP_TAC SEQ_LE THEN
		EXISTS_TAC (--`(\n. sum (0,n) (\x. sum (0,n - x)
                    (\i. (& x pow 2 + & x * & i) *
                       (prob bern
                          {s | (FST ((X: (num -> bool) -> num#(num -> bool)) s) = x) /\ 
			(FST ((Y: (num -> bool) -> num#(num -> bool)) (SND (X s))) = i)} +
                        prob bern {s | (FST (X s) = i) /\
                           (FST (Y (SND (X s))) = x)}))))`--) THEN
		EXISTS_TAC (--`(\n. sum (0,n) (\x.
                  sum (0,n) (\i. (& x pow 2 + & x * & i) *
                       (prob bern {s | (FST ((X: (num -> bool) -> num#(num -> bool)) s) = x) /\ 
			(FST ((Y: (num -> bool) -> num#(num -> bool))(SND (X s))) = i)} +
                        prob bern {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = x)}))))`--) THEN
		RW_TAC std_ss [] THEN
		EXISTS_TAC (--`0:num`--) THEN
		RW_TAC arith_ss [GREATER_EQ] THEN
		MATCH_MP_TAC SUM_LE THEN
			RW_TAC arith_ss [] THEN
			KNOW_TAC `!n. 0 <=  (\i.
         		(& r pow 2 + & r * & i) *
         		(prob bern {s | (FST (X s) = r) /\ (FST (Y (SND (X s))) = i)} +
          		 prob bern {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = r)})) n` THEN1 (
				RW_TAC std_ss [] THEN
				MATCH_MP_TAC REAL_LE_MUL THEN
				KNOW_TAC `!a b. 0 <= prob bern 
				{s | (FST (X s) = a) /\ (FST (Y (SND (X s))) = b)}` THEN1 (
					REPEAT GEN_TAC THEN
					MATCH_MP_TAC PROB_POSITIVE THEN
					RW_TAC std_ss [PROB_SPACE_BERN, EVENT_EQ_INTER_BERN]) THEN	
				RW_TAC real_ss [POW_POS, REAL_LE_ADD]) THEN
			POP_ASSUM MP_TAC THEN
			Q.SPEC_TAC (`(\i.
         		(& r pow 2 + & r * & i) *
         		(prob bern {s | (FST (X s) = r) /\ (FST (Y (SND (X s))) = i)} +
          		 prob bern {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = r)}))`, `f`) THEN
			REPEAT STRIP_TAC THEN
			MP_TAC (Q.SPECL [`f`, `n-r`, `r`] SUM_DIFF) THEN
			ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
			RW_TAC arith_ss [REAL_EQ_SUB_RADD] THEN
			ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
			REWRITE_TAC [REAL_LE_ADDR] THEN
			RW_TAC std_ss [SUM_POS]) THEN

	SUFF_TAC `m <= s''''` THEN1 (
        	DISCH_TAC THEN
        	PROVE_TAC [REAL_LE_ANTISYM]) THEN

		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC SEQ_LE THEN
		EXISTS_TAC (--`(\n. sum (0,n) (\x.
                  sum (0,n) (\i. (& x pow 2 + & x * & i) *
                       (prob bern {s | (FST ((X: (num -> bool) -> num#(num -> bool)) s) = x) /\ 
			(FST ((Y: (num -> bool) -> num#(num -> bool))(SND (X s))) = i)} +
                        prob bern {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = x)}))))`--) THEN
		EXISTS_TAC (--`(\n. (\n. sum (0,n) (\x. sum (0,n - x)
                    (\i. (& x pow 2 + & x * & i) *
                       (prob bern
                          {s | (FST ((X: (num -> bool) -> num#(num -> bool)) s) = x) /\ 
			(FST ((Y: (num -> bool) -> num#(num -> bool)) (SND (X s))) = i)} +
                        prob bern {s | (FST (X s) = i) /\
                           (FST (Y (SND (X s))) = x)})))) (2 * n))`--) THEN
		RW_TAC std_ss [SEQ_DOUBLE] THEN
		EXISTS_TAC (--`0:num`--) THEN
        	RW_TAC arith_ss [] THEN
		KNOW_TAC `!f. sum (0, 2*n) f = sum(0,n) f + sum(n,n) f` THEN1
			RW_TAC std_ss [SUM_TWO, TIMES2] THEN
		ASM_REWRITE_TAC [] THEN
        	POP_ASSUM K_TAC THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`sum (0,n) (\x. sum (0,2 * n - x)
             (\i. (& x pow 2 + & x * & i) *
                (prob bern
                   {s | (FST ((X: (num -> bool) -> num#(num -> bool)) s) = x) /\ 
			(FST ((Y: (num -> bool) -> num#(num -> bool)) (SND (X s))) = i)} +
                 prob bern
                   {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = x)})))`--) THEN
		RW_TAC std_ss [REAL_LE_ADDR] THEN1 (
			MATCH_MP_TAC SUM_LE THEN
			RW_TAC arith_ss [] THEN
			KNOW_TAC `!n. 0 <=  (\i.
         		(& r pow 2 + & r * & i) *
         		(prob bern {s | (FST (X s) = r) /\ (FST (Y (SND (X s))) = i)} +
          		prob bern {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = r)})) n` THEN1 (
				RW_TAC std_ss [] THEN
				MATCH_MP_TAC REAL_LE_MUL THEN
				KNOW_TAC `!a b. 0 <= prob bern 
				{s | (FST (X s) = a) /\ (FST (Y (SND (X s))) = b)}` THEN1 (
					REPEAT GEN_TAC THEN
					MATCH_MP_TAC PROB_POSITIVE THEN
					RW_TAC std_ss [PROB_SPACE_BERN, EVENT_EQ_INTER_BERN]) THEN	
				RW_TAC real_ss [POW_POS, REAL_LE_ADD]) THEN
			POP_ASSUM MP_TAC THEN
			Q.SPEC_TAC (`(\i. (& r pow 2 + & r * & i) *
          		(prob bern {s | (FST (X s) = r) /\ (FST (Y (SND (X s))) = i)} +
          		 prob bern {s | (FST (X s) = i) /\ (FST (Y (SND (X s))) = r)}))`, `f`) THEN
			RW_TAC std_ss [] THEN
			KNOW_TAC `sum (0,2 * n - r) f = sum (0,n) f + sum(n,n-r) f` THEN1 (
				RW_TAC std_ss [SUM_TWO, TIMES2] THEN
				RW_TAC arith_ss []) THEN
			ASM_REWRITE_TAC [REAL_LE_ADDR] THEN
			MATCH_MP_TAC SUM_POS THEN
			RW_TAC std_ss []) THEN
        	
			MATCH_MP_TAC SUM_POS THEN
			RW_TAC std_ss [] THEN
			MATCH_MP_TAC SUM_POS THEN
			RW_TAC std_ss [] THEN
			MATCH_MP_TAC REAL_LE_MUL THEN
			KNOW_TAC `!a b. 0 <= prob bern 
			{s | (FST (X s) = a) /\ (FST (Y (SND (X s))) = b)}` THEN1 (
				REPEAT GEN_TAC THEN
				MATCH_MP_TAC PROB_POSITIVE THEN
				RW_TAC std_ss [PROB_SPACE_BERN, EVENT_EQ_INTER_BERN]) THEN	
			RW_TAC real_ss [POW_POS, REAL_LE_ADD]);

val VARIANCE_SUM_TWO_RV = store_thm
 ("VARIANCE_SUM_TWO_RV",
 (--`!(X: (num -> bool) -> num#(num -> bool)) (Y: (num -> bool) -> num#(num -> bool)). 
	 X IN indep_fn /\ Y IN indep_fn /\
	 summable (\n. & n * prob bern {s | FST (X s) = n}) /\
         summable (\n. & n * prob bern {s | FST (Y s) = n}) /\
	 summable (\n. (\x. & x pow 2) n * prob bern {s | FST (X s) = n}) /\
	 summable (\n. (\x. & x pow 2) n * prob bern {s | FST (Y s) = n})  ==>
                (variance  (\x. (FST (X x) + FST (Y (SND (X x))),SND (Y (SND (X x))))) = 
			variance X + variance Y)`--),
	RW_TAC std_ss [BIND_DEF, o_DEF, UNCURRY_DEF, UNIT_DEF, LAMBDA_PAIR,
			summable, variance_def, suminf, sums, EXPEC_FN] THEN
	KNOW_TAC `(!m. {s | FST (X s) = m} IN events bern)` THEN1 (
		GEN_TAC THEN
		KNOW_TAC `{s | FST (X s) = m} = ((\y. y = m) o FST o X)` THEN1
			PSET_TAC [o_DEF] THEN
		RW_TAC std_ss [INDEP_FN_FST_EVENTS]) THEN
	KNOW_TAC `(!m. {s | FST (Y s) = m} IN events bern)` THEN1 (
		GEN_TAC THEN
		KNOW_TAC `{s | FST (Y s) = m} = ((\y. y = m) o FST o Y)` THEN1
			PSET_TAC [o_DEF] THEN
		RW_TAC std_ss [INDEP_FN_FST_EVENTS]) THEN
	SELECT_ELIM_TAC THEN
	CONJ_TAC THEN1 (
		FULL_SIMP_TAC std_ss [GSYM summable, GSYM sums] THEN
		MATCH_MP_TAC VARIANCE_TWO_RV_SUMMABLE THEN
		RW_TAC std_ss [] THENL [
                	MATCH_MP_TAC SUM_SUMMABLE THEN
                	PROVE_TAC [],

                	MATCH_MP_TAC SUM_SUMMABLE THEN
                	PROVE_TAC [],

                	MATCH_MP_TAC SUM_SUMMABLE THEN
                	PROVE_TAC [],

                	MATCH_MP_TAC SUM_SUMMABLE THEN
                	PROVE_TAC []]) THEN
		
		RW_TAC std_ss [] THEN
		SELECT_ELIM_TAC THEN
		CONJ_TAC THEN1 (
			RW_TAC std_ss [GSYM sums, GSYM summable] THEN
			MP_TAC (Q.SPEC `(X: (num -> bool) -> num#(num -> bool))` VARIANCE_SUMMABLE) THEN
			RW_TAC std_ss [] THEN
			KNOW_TAC `summable (\n. & n pow 2 * prob bern {s | FST (X s) = n}) /\
          			summable (\n. & n * prob bern {s | FST (X s) = n})` THEN1 (
				RW_TAC std_ss [sums, summable] THENL [
					EXISTS_TAC (--`s'':real`--) THEN
					PROVE_TAC [],
				
					EXISTS_TAC (--`s:real`--) THEN
					PROVE_TAC []]) THEN
			FULL_SIMP_TAC std_ss []) THEN
	
		RW_TAC std_ss [] THEN
		SELECT_ELIM_TAC THEN
		CONJ_TAC THEN1 (
			RW_TAC std_ss [GSYM sums, GSYM summable] THEN
			MP_TAC (Q.SPEC `(Y: (num -> bool) -> num#(num -> bool))` VARIANCE_SUMMABLE) THEN
			RW_TAC std_ss [] THEN
			KNOW_TAC `summable (\n. & n pow 2 * prob bern {s | FST (Y s) = n}) /\
          			summable (\n. & n * prob bern {s | FST (Y s) = n})` THEN1 (
				RW_TAC std_ss [sums, summable] THENL [
					EXISTS_TAC (--`s''':real`--) THEN
					PROVE_TAC [],
				
					EXISTS_TAC (--`s':real`--) THEN
					PROVE_TAC []]) THEN
			FULL_SIMP_TAC std_ss []) THEN
	
		RW_TAC std_ss [] THEN
		KNOW_TAC `expec (\x. (FST (X x) + FST (Y (SND (X x))),
                         SND (Y (SND (X x))))) = expec X + expec Y` THEN1 (
			MATCH_MP_TAC EXPEC_SUM_TWO_RV THEN
			RW_TAC std_ss [sums, summable] THENL [
				EXISTS_TAC (--`s:real`--) THEN
				PROVE_TAC [],
				
				EXISTS_TAC (--`s':real`--) THEN
				PROVE_TAC []]) THEN
		FULL_SIMP_TAC std_ss [] THEN
		KNOW_TAC `!x A. (& x - A) pow 2 = &x pow 2 + A pow 2 - 2 * A * &x` THEN1 (
			RW_TAC std_ss [POW_2] THEN
			REAL_ARITH_TAC) THEN
		FULL_SIMP_TAC std_ss [real_sub, GSYM REAL_ADD_ASSOC, REAL_ADD_RDISTRIB] THEN
		POP_ASSUM K_TAC THEN
		KNOW_TAC `expec X = s` THEN1 (
			RW_TAC std_ss [expec_def] THEN
			ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
			MATCH_MP_TAC SUM_UNIQ THEN
			RW_TAC std_ss [sums]) THEN
		KNOW_TAC `expec Y = s'` THEN1 (
			RW_TAC std_ss [expec_def] THEN
			ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
			MATCH_MP_TAC SUM_UNIQ THEN
			RW_TAC std_ss [sums]) THEN
		FULL_SIMP_TAC std_ss [] THEN
		NTAC 2 (POP_ASSUM K_TAC) THEN
		KNOW_TAC `x' = s'' + (s pow 2 + ~(2 * s) * s)` THEN1 (
			MATCH_MP_TAC SEQ_UNIQ THEN
			EXISTS_TAC (--`(\n. sum (0,n) (\x.
                  	& x pow 2 * prob bern {s | FST ((X: (num -> bool) -> num#(num -> bool)) s) = x} +
                  	(s pow 2 * prob bern {s | FST (X s) = x} +
                   	~(2 * s * & x) * prob bern {s | FST (X s) = x})))`--) THEN
			RW_TAC std_ss [] THEN
			KNOW_TAC `(\x. & x pow 2 * prob bern {s | FST (X s) = x} +
            		(s pow 2 * prob bern {s | FST (X s) = x} +
             		~(2 * s * & x) * prob bern {s | FST (X s) = x})) = 
			(\x. (\x. & x pow 2 * prob bern {s | FST (X s) = x}) x +
            		(\x. ((\x. s pow 2 * prob bern {s | FST (X s) = x}) x +
             		(\x. ~(2 * s * & x) * prob bern {s | FST (X s) = x}) x)) x)` THEN1
				RW_TAC std_ss [] THEN
			ASM_REWRITE_TAC [SUM_ADD] THEN
			POP_ASSUM K_TAC THEN
			KNOW_TAC `(\n. sum (0,n) (\x. & x pow 2 * prob bern {s | FST (X s) = x}) +
       			(sum (0,n) (\x. s pow 2 * prob bern {s | FST (X s) = x}) +
        		sum (0,n) (\x. ~(2 * s * & x) * prob bern {s | FST (X s) = x}))) = 
			(\n. (\n. sum (0,n) (\x. & x pow 2 * prob bern {s | FST (X s) = x})) n +
       			(\n. ((\n. sum (0,n) (\x. s pow 2 * prob bern {s | FST (X s) = x})) n +
        		(\n. sum (0,n) (\x. ~(2 * s * & x) * prob bern {s | FST (X s) = x})) n)) n)` THEN1
				RW_TAC std_ss [] THEN
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			MATCH_MP_TAC SEQ_ADD THEN
			CONJ_TAC THEN1
				RW_TAC std_ss [] THEN
			
				MATCH_MP_TAC SEQ_ADD THEN
				CONJ_TAC THEN1 (
					REWRITE_TAC [GSYM sums, SER_CMUL] THEN
					KNOW_TAC `(\x. s pow 2 * prob bern {s | FST (X s) = x}) sums (s pow 2) = 
				(\x. s pow 2 * (\x. prob bern {s | FST (X s) = x}) x) sums (s pow 2 * 1)` THEN1
						RW_TAC real_ss [] THEN
					ASM_REWRITE_TAC [] THEN
					MATCH_MP_TAC SER_CMUL THEN
					RW_TAC std_ss [PMF_SUMS_1]) THEN
				
					KNOW_TAC `(\x. ~(2 * s * & x) * prob bern {s | FST (X s) = x}) = 
					(\x. ~(2 * s) * (\x. & x * prob bern {s | FST (X s) = x}) x)` THEN1
						RW_TAC std_ss [REAL_NEG_LMUL, REAL_MUL_ASSOC] THEN
					ASM_REWRITE_TAC [GSYM sums] THEN	
					MATCH_MP_TAC SER_CMUL THEN
					RW_TAC std_ss [sums]) THEN
			
		KNOW_TAC `x'' = s''' + (s' pow 2 + ~(2 * s') * s')` THEN1 (
			MATCH_MP_TAC SEQ_UNIQ THEN
			EXISTS_TAC (--`(\n. sum (0,n) (\x.
                  	& x pow 2 * prob bern {s | FST ((Y: (num -> bool) -> num#(num -> bool)) s) = x} +
                  	(s' pow 2 * prob bern {s | FST (Y s) = x} +
                   	~(2 * s' * & x) * prob bern {s | FST (Y s) = x})))`--) THEN
			RW_TAC std_ss [] THEN
			KNOW_TAC `(\x. & x pow 2 * prob bern {s | FST (Y s) = x} +
            		(s' pow 2 * prob bern {s | FST (Y s) = x} +
             		~(2 * s' * & x) * prob bern {s | FST (Y s) = x})) = 
			(\x. (\x. & x pow 2 * prob bern {s | FST (Y s) = x}) x +
            		(\x. ((\x. s' pow 2 * prob bern {s | FST (Y s) = x}) x +
             		(\x. ~(2 * s' * & x) * prob bern {s | FST (Y s) = x}) x)) x)` THEN1
				RW_TAC std_ss [] THEN
			ASM_REWRITE_TAC [SUM_ADD] THEN
			POP_ASSUM K_TAC THEN
			KNOW_TAC `(\n. sum (0,n) (\x. & x pow 2 * prob bern {s | FST (Y s) = x}) +
       			(sum (0,n) (\x. s' pow 2 * prob bern {s | FST (Y s) = x}) +
        		sum (0,n) (\x. ~(2 * s' * & x) * prob bern {s | FST (Y s) = x}))) = 
			(\n. (\n. sum (0,n) (\x. & x pow 2 * prob bern {s | FST (Y s) = x})) n +
       			(\n. ((\n. sum (0,n) (\x. s' pow 2 * prob bern {s | FST (Y s) = x})) n +
        		(\n. sum (0,n) (\x. ~(2 * s' * & x) * prob bern {s | FST (Y s) = x})) n)) n)` THEN1
				RW_TAC std_ss [] THEN
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			MATCH_MP_TAC SEQ_ADD THEN
			CONJ_TAC THEN1
				RW_TAC std_ss [] THEN
			
				MATCH_MP_TAC SEQ_ADD THEN
				CONJ_TAC THEN1 (
					REWRITE_TAC [GSYM sums, SER_CMUL] THEN
					KNOW_TAC `(\x. s' pow 2 * prob bern {s | FST (Y s) = x}) sums
				(s' pow 2) = 
				(\x. s' pow 2 * (\x. prob bern {s | FST (Y s) = x}) x) sums (s' pow 2 * 1)` THEN1
						RW_TAC real_ss [] THEN
					ASM_REWRITE_TAC [] THEN
					MATCH_MP_TAC SER_CMUL THEN
					RW_TAC std_ss [PMF_SUMS_1]) THEN
				
					KNOW_TAC `(\x. ~(2 * s' * & x) * prob bern {s | FST (Y s) = x}) = 
					(\x. ~(2 * s') * (\x. & x * prob bern {s | FST (Y s) = x}) x)` THEN1
						RW_TAC std_ss [REAL_NEG_LMUL, REAL_MUL_ASSOC] THEN
					ASM_REWRITE_TAC [GSYM sums] THEN	
					MATCH_MP_TAC SER_CMUL THEN
					RW_TAC std_ss [sums]) THEN	
				
			ASM_REWRITE_TAC [GSYM REAL_NEG_LMUL, GSYM real_sub, POW_2] THEN
			KNOW_TAC `!a b. b + (a - 2 * a) = b - a` THEN1 (
				REPEAT GEN_TAC THEN
				REAL_ARITH_TAC) THEN
			ASM_REWRITE_TAC [GSYM REAL_MUL_ASSOC, GSYM POW_2] THEN
		
			KNOW_TAC `x = (s'' + s''' + 2 * s * s') + 
			((s + s') pow 2 + ~(2 * (s + s')) * (s + s'))` THEN1 (
				MATCH_MP_TAC SEQ_UNIQ THEN
				EXISTS_TAC (--`(\n. sum (0,n) (\x.
                  		& x pow 2 *
                  		prob bern {x' | FST ((X: (num -> bool) -> num#(num -> bool)) x')
					 + FST ((Y: (num -> bool) -> num#(num -> bool)) 
					 	(SND (X x'))) = x} +
                  		((s + s') pow 2 *
                   		prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x} +
                   		~(2 * (s + s') * & x) *
                   		prob bern
                     		{x' | FST (X x') + FST (Y (SND (X x'))) = x})))`--) THEN
				RW_TAC std_ss [] THEN
				NTAC 2 (POP_ASSUM MP_TAC) THEN
				NTAC 3 (POP_ASSUM K_TAC) THEN	
				REPEAT STRIP_TAC THEN
				KNOW_TAC `(\x. & x pow 2 *
            			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x} +
            			((s + s') pow 2 *
             			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x} +
             			~(2 * (s + s') * & x) *
             			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) = 
				(\x. (\x. & x pow 2 *
            			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) x +
            			(\x. ( (\x. (s + s') pow 2 *
             			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) x +
             			(\x. ~(2 * (s + s') * & x) *
             			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) x)) x)` THEN1
					RW_TAC std_ss [] THEN
				ASM_REWRITE_TAC [SUM_ADD] THEN
				POP_ASSUM K_TAC THEN 
				KNOW_TAC `(\n. sum (0,n) (\x.
            			& x pow 2 *
            			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) +
       				(sum (0,n)
          			(\x.
             			(s + s') pow 2 *
             			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) +
        			sum (0,n)
          			(\x.
             			~(2 * (s + s') * & x) *
             			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}))) = 
				(\n. (\n. sum (0,n) (\x.
            			& x pow 2 *
            			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n +
       				(\n. ((\n. sum (0,n)
          			(\x.
             			(s + s') pow 2 *
             			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n +
        			(\n. sum (0,n)
          			(\x.
             			~(2 * (s + s') * & x) *
             			prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x})) n)) n)` THEN1
					RW_TAC std_ss [] THEN
				ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				MATCH_MP_TAC SEQ_ADD THEN
				ONCE_REWRITE_TAC [CONJ_SYM] THEN
				CONJ_TAC THEN1 (
					MATCH_MP_TAC SEQ_ADD THEN
					CONJ_TAC THEN1 (
						REWRITE_TAC [GSYM sums, SER_CMUL] THEN
						KNOW_TAC `(\x. (s + s') pow 2 *
       						prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) sums
    						((s + s') pow 2) = 
						(\x. (s + s') pow 2 *
       						(\x. prob bern {x' | FST (X x') + FST (Y (SND (X x'))) =
						x}) x) sums
    						((s + s') pow 2 * 1)` THEN1
							RW_TAC real_ss [] THEN
						ASM_REWRITE_TAC [] THEN
						MATCH_MP_TAC SER_CMUL THEN
						KNOW_TAC `!x. {x' | FST (X x') + FST (Y (SND (X x'))) = x} = 
						{x' | (\x'. FST (X x') + FST (Y (SND (X x')))) x' =
						x}` THEN1
							RW_TAC std_ss [] THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						REWRITE_TAC [GSYM PROB_BERN_BASIC] THEN
						KNOW_TAC `(\x. prob bern
         					{x' | (\x'. FST (X x') + FST (Y (SND (X x')))) x' = x}) = 
                  				(prob bern o 
						(\n. {s | ((\x'. FST (X x') + 
						FST (Y (SND (X x')))) s) = n}))` THEN1
       							RW_TAC std_ss [o_DEF] THEN
    						ONCE_ASM_REWRITE_TAC [] THEN
						MATCH_MP_TAC PROB_COUNTABLY_ADDITIVE THEN
						RW_TAC std_ss [PROB_SPACE_BERN, 
						DISJOINT_DEF, INTER_DEF, SPECIFICATION, IN_FUNSET] THENL [
							RW_TAC std_ss [SUM_RV_BIGUNION] THEN
							ONCE_REWRITE_TAC [GSYM SPECIFICATION] THEN
							MATCH_MP_TAC EVENT_EQ_BIGUNION_BERN THEN
							ASM_REWRITE_TAC [],

							PSET_TAC [GSPECIFICATION] THEN
                    					DISJ2_TAC THEN
                    					CCONTR_TAC THEN
                    					PROVE_TAC [],
			
							RW_TAC std_ss [EXTENSION, IN_UNIV, IN_BIGUNION_IMAGE,
                                      			GSPECIFICATION] THEN
							EXISTS_TAC (--`(x:(num -> bool))`--) THEN
       	             					PROVE_TAC []]) THEN
					
					KNOW_TAC `(\x. ~(2 * (s + s') * & x) *
            				prob bern {x' | FST (X x') + FST (Y (SND (X x'))) = x}) = 
						(\x. ~(2 * (s + s')) * (\x. & x * prob bern 
						{x' | FST (X x') + FST (Y (SND (X x'))) = x}) x)` THEN1
						RW_TAC std_ss [REAL_NEG_LMUL, REAL_MUL_ASSOC] THEN
					ASM_REWRITE_TAC [GSYM sums] THEN	
					MATCH_MP_TAC SER_CMUL THEN
					FULL_SIMP_TAC std_ss [expec_def, suminf, sums] THEN
					NTAC 2 (POP_ASSUM K_TAC) THEN
					POP_ASSUM MP_TAC THEN
					SELECT_ELIM_TAC THEN
					RW_TAC std_ss [] THENL [
						REWRITE_TAC [GSYM sums, GSYM summable] THEN
						MATCH_MP_TAC SUM_TWO_RV_SUMMABLE THEN
						RW_TAC std_ss [summable, sums] THENL [
							EXISTS_TAC (--`s:real`--) THEN
							PROVE_TAC [],
					
							EXISTS_TAC (--`s':real`--) THEN
							PROVE_TAC []],
					
						PROVE_TAC []]) THEN
		
			MATCH_MP_TAC TWO_RV_VARIANCE_HELPER THEN
			RW_TAC std_ss [summable, sums] THENL [
				EXISTS_TAC (--`s:real`--) THEN
				PROVE_TAC [],

				EXISTS_TAC (--`s':real`--) THEN
				PROVE_TAC [],
			
				EXISTS_TAC (--`s'':real`--) THEN
				PROVE_TAC [],

				EXISTS_TAC (--`s''':real`--) THEN
				PROVE_TAC [],

				KNOW_TAC `!a b.{s | (FST (X s) = a) /\ (FST (Y (SND (X s))) = b)} = 
				{s | (FST (X s) = a)} INTER {s | (FST (Y (SND (X s))) = b)}` THEN1 (
					REPEAT GEN_TAC THEN
					ONCE_REWRITE_TAC [EXTENSION] THEN
					PSET_TAC [GSPECIFICATION, IN_INTER]) THEN
				ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				KNOW_TAC `!a b. prob bern ({s | FST (X s) = a} INTER
                    		{s | FST (Y (SND (X s))) = b}) =
				prob bern {s | FST (X s) = a} * prob bern {s | FST (Y s) = b}` THEN1 (
					REPEAT GEN_TAC THEN
					KNOW_TAC `{s | FST (X  s) = a} = ((\y. y = a) o FST o X )` THEN1
							PSET_TAC [o_DEF] THEN
					KNOW_TAC `{s | FST (Y  (SND (X  s))) = b} = 	
						((\y. FST (Y  y) = b) o SND o X )` THEN1
						PSET_TAC [o_DEF] THEN		
					ONCE_ASM_REWRITE_TAC [] THEN
					KNOW_TAC `{s | FST (Y s) = b} = (\y. FST (Y y) = b)` THEN1 (
						REWRITE_TAC [EXTENSION] THEN
						PSET_TAC [GSPECIFICATION]) THEN
					ONCE_ASM_REWRITE_TAC [] THEN
					MATCH_MP_TAC INDEP_FN_PROB THEN
					KNOW_TAC `(\y. FST (Y y) = b) = ((\y. y = b) o FST o Y)` THEN1
						PSET_TAC [o_DEF] THEN
					ONCE_ASM_REWRITE_TAC [] THEN
					RW_TAC std_ss [INDEP_FN_FST_EVENTS]) THEN			
				ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				KNOW_TAC `!n x. (\i.(& x pow 2 + & x * & i) *
                 			(prob bern {s | FST (X s) = x} *
                  			prob bern {s | FST (Y s) = i} +
                  			prob bern {s | FST (X s) = i} *
                  			prob bern {s | FST (Y s) = x})) =
				(\i. (\i. (\i. & x pow 2 * 
					(prob bern {s | FST (X s) = x} *
                  			 prob bern {s | FST (Y s) = i})) i + 
					 (\i. & x pow 2 * 
					(prob bern {s | FST (X s) = i} *
                  			 prob bern {s | FST (Y s) = x})) i) i +
				      (\i. (\i. & x * & i *
					 (prob bern {s | FST (X s) = x} *
                  			 prob bern {s | FST (Y s) = i})) i + 
					   (\i. & x * & i *
					(prob bern {s | FST (X s) = i} *
                  			 prob bern {s | FST (Y s) = x})) i) i)` THEN1
					RW_TAC std_ss [REAL_ADD_LDISTRIB, REAL_ADD_RDISTRIB] THEN
				ASM_REWRITE_TAC [SUM_ADD] THEN
				POP_ASSUM K_TAC THEN
				KNOW_TAC `!n. (\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = x} *
                 		 prob bern {s | FST (Y s) = i})) +
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = i} *
                  		prob bern {s | FST (Y s) = x})) +
            			(sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = x} *
                  		 prob bern {s | FST (Y s) = i})) +
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = i} *
                   		prob bern {s | FST (Y s) = x})))) =
				(\x. (\x. (\x. sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = x} *
                 		 prob bern {s | FST (Y s) = i}))) x + 
				(\x. sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = i} *
                  		prob bern {s | FST (Y s) = x}))) x) x + 
				(\x. (\x. (sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = x} *
                  		 prob bern {s | FST (Y s) = i})))) x + 
				(\x. sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = i} *
                   		prob bern {s | FST (Y s) = x})))x)x)` THEN1
						RW_TAC std_ss [REAL_ADD_LDISTRIB, REAL_ADD_RDISTRIB] THEN
				ASM_REWRITE_TAC [SUM_ADD] THEN
				POP_ASSUM K_TAC THEN
				KNOW_TAC `(\n. sum (0,n) (\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = x} *
                  		prob bern {s | FST (Y s) = i}))) +
       				sum (0,n)
         			(\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = i} *
                  		prob bern {s | FST (Y s) = x}))) +
       				(sum (0,n)
          			(\x.
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = x} *
                   		prob bern {s | FST (Y s) = i}))) +
        			sum (0,n)
          			(\x.
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = i} *
                   		prob bern {s | FST (Y s) = x}))))) = 
				(\n. (\n. (\n. sum (0,n) (\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = x} *
                  		prob bern {s | FST (Y s) = i})))) n + 
				(\n. sum (0,n)
         			(\x.
            			sum (0,n)
              			(\i.
                 		& x pow 2 *
                 		(prob bern {s | FST (X s) = i} *
                  		prob bern {s | FST (Y s) = x})))) n) n +
				(\n. (sum (0,n)
          			(\x.
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = x} *
                   		prob bern {s | FST (Y s) = i}))) +
        			sum (0,n)
          			(\x.
             			sum (0,n)
               			(\i.
                  		& x * & i *
                  		(prob bern {s | FST (X s) = i} *
                   		prob bern {s | FST (Y s) = x}))))) n)` THEN1
						RW_TAC std_ss [] THEN
				ASM_REWRITE_TAC [] THEN
				POP_ASSUM K_TAC THEN
				MATCH_MP_TAC SEQ_ADD THEN
				CONJ_TAC THEN1 (
					MATCH_MP_TAC SEQ_ADD THEN
					CONJ_TAC THEN1 (
						KNOW_TAC `(\n.
       							sum (0,n)
         						(\x.
            						sum (0,n)
              						(\i.
                 					& x pow 2 *
                 					(prob bern {s | FST (X s) = x} *
                  					prob bern {s | FST (Y s) = i})))) = 
						(\n. (\n. sum (0,n) (\x. & x pow 2 *
                 					prob bern {s | FST (X s) = x})) n *
							(\n. sum (0,n) (\i. 
								prob bern {s | FST (Y s) = i}))n )` THEN1 (
							RW_TAC std_ss [] THEN
							KNOW_TAC `!x. (\i.
                 					& x pow 2 *
                 					(prob bern {s | FST (X s) = x} *
                  					prob bern {s | FST (Y s) = i})) = 
							(\i. (& x pow 2 *
							prob bern {s | FST (X s) = x}) * (\i.
							prob bern {s | FST (Y s) = i}) i)` THEN1
								RW_TAC std_ss [REAL_MUL_ASSOC] THEN
							ASM_REWRITE_TAC [SUM_CMUL] THEN
							POP_ASSUM K_TAC THEN
							KNOW_TAC `!n. (\x.
            						& x pow 2 * prob bern {s | FST (X s) = x} *
            						sum (0,n) 
							(\i. prob bern {s | FST (Y s) = i})) = 
							(\x. sum (0,n) 
								(\i. prob bern {s | FST (Y s) = i}) *
								(\x. & x pow 2 * 
								prob bern {s | FST (X s) = x}) x)` THEN1 (
								RW_TAC std_ss [] THEN
								PROVE_TAC [REAL_MUL_SYM]) THEN
							ASM_REWRITE_TAC [SUM_CMUL] THEN
							POP_ASSUM K_TAC THEN	
							PROVE_TAC [REAL_MUL_SYM]) THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN		
						KNOW_TAC `s'' = s'' * 1` THEN1
							RW_TAC real_ss [] THEN
						ONCE_ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						MATCH_MP_TAC SEQ_MUL THEN
						FULL_SIMP_TAC std_ss [sums] THEN
						REWRITE_TAC [GSYM sums] THEN
						MATCH_MP_TAC PMF_SUMS_1 THEN
						ASM_REWRITE_TAC []) THEN
					
						KNOW_TAC `!x. (\i.
                 				& x pow 2 * (prob bern {s | FST (X s) = i} *
                  				prob bern {s | FST (Y s) = x})) = 
						(\i. & x pow 2 * prob bern {s | FST (Y s) = x} *
						(\i. prob bern {s | FST (X s) = i}) i)` THEN1 (
							RW_TAC std_ss [] THEN
							PROVE_TAC [REAL_MUL_SYM, REAL_MUL_ASSOC]) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						KNOW_TAC `!n. (\x. & x pow 2 * 
						prob bern {s | FST (Y s) = x} *
            					sum (0,n) (\i. prob bern {s | FST (X s) = i})) =
						(\x. sum (0,n) (\i. prob bern {s | FST (X s) = i}) *
							(\x. & x pow 2 * 
								prob bern {s | FST (Y s) = x}) x)` THEN1 (
							RW_TAC std_ss [] THEN
							PROVE_TAC [REAL_MUL_SYM]) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						KNOW_TAC `(\n. sum (0,n) 
						(\i. prob bern {s | FST (X s) = i}) *
       						sum (0,n) 
						(\x. & x pow 2 * prob bern {s | FST (Y s) = x})) = 
						(\n. (\n. sum (0,n) 
						(\i. prob bern {s | FST (X s) = i}))n  *
       						(\n. sum (0,n) 
						(\x. & x pow 2 * 
						prob bern {s | FST (Y s) = x})) n)` THEN1 
							RW_TAC std_ss [] THEN
						ASM_REWRITE_TAC [] THEN
						NTAC 3 (POP_ASSUM K_TAC) THEN
						KNOW_TAC `s''' = 1 * s'''` THEN1
							RW_TAC real_ss [] THEN
						ONCE_ASM_REWRITE_TAC [] THEN
						MATCH_MP_TAC SEQ_MUL THEN
						FULL_SIMP_TAC std_ss [sums] THEN
						REWRITE_TAC [GSYM sums] THEN
						MATCH_MP_TAC PMF_SUMS_1 THEN
						ASM_REWRITE_TAC []) THEN
				
					REWRITE_TAC [GSYM REAL_DOUBLE, REAL_ADD_RDISTRIB] THEN
					KNOW_TAC `(\n. sum (0,n)
         				(\x.
            				sum (0,n)
              				(\i.
                 			& x * & i *
                 			(prob bern {s | FST (X s) = x} *
                  			prob bern {s | FST (Y s) = i}))) +
       					sum (0,n)
         				(\x.
            				sum (0,n)
              				(\i.
                 			& x * & i *
                 			(prob bern {s | FST (X s) = i} *
                  			prob bern {s | FST (Y s) = x})))) = 
					(\n. (\n. sum (0,n)
         				(\x.
            				sum (0,n)
              				(\i.
                 			& x * & i *
                 			(prob bern {s | FST (X s) = x} *
                  			prob bern {s | FST (Y s) = i})))) n +
       					(\n. sum (0,n)
         				(\x.
            				sum (0,n)
              				(\i.
                 			& x * & i *
                 			(prob bern {s | FST (X s) = i} *
                  			prob bern {s | FST (Y s) = x})))) n)` THEN1
							RW_TAC std_ss [] THEN
					ASM_REWRITE_TAC [] THEN
					POP_ASSUM K_TAC THEN
					MATCH_MP_TAC SEQ_ADD THEN
					CONJ_TAC THEN1 (
						KNOW_TAC `!x. (\i.
                 				& x * & i *
                 				(prob bern {s | FST (X s) = x} *
                  				prob bern {s | FST (Y s) = i})) = 
						(\i. & x * prob bern {s | FST (X s) = x} *
							(\i. & i *
							prob bern {s | FST (Y s) = i}) i)` THEN1 (
							RW_TAC std_ss [] THEN
							SUFF_TAC `!i. & x * & i *
       							(prob bern {s | FST (X s) = x} * 
							prob bern {s | FST (Y s) = i}) = 
							& x * prob bern {s | FST (X s) = x} *
							(& i * prob bern {s | FST (Y s) = i})` THEN1
								RW_TAC std_ss [] THEN
							GEN_TAC THEN
							REAL_ARITH_TAC) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `!n. (\x. & x * prob bern {s | FST (X s) = x} *
            					sum (0,n) (\i. & i * 
						prob bern {s | FST (Y s) = i})) = 
						(\x. sum (0,n) (\i. & i *
							prob bern {s | FST (Y s) = i}) * 
							(\x. & x * 
							prob bern {s | FST (X s) = x}) x)` THEN1 (
							RW_TAC std_ss [] THEN
							PROVE_TAC [REAL_MUL_SYM]) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						POP_ASSUM K_TAC THEN 
						KNOW_TAC `(\n. sum (0,n) 
						(\i. & i * prob bern {s | FST (Y s) = i}) *
       						sum (0,n) 
						(\x. & x * prob bern {s | FST (X s) = x})) = 
						(\n. (\n. sum (0,n) 
						(\i. & i * prob bern {s | FST (Y s) = i})) n *
       						(\n. sum (0,n) 
						(\x. & x * prob bern {s | FST (X s) = x})) n)` THEN1
							RW_TAC std_ss [] THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `s * s' = s' * s` THEN1
							PROVE_TAC [REAL_MUL_SYM] THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						MATCH_MP_TAC SEQ_MUL THEN
						FULL_SIMP_TAC std_ss [sums]) THEN

						KNOW_TAC `!x. (\i. & x * & i *
                 				(prob bern {s | FST (X s) = i} *
                  				prob bern {s | FST (Y s) = x})) = 
						(\i. & x * prob bern {s | FST (Y s) = x} *
							(\i. & i *
							prob bern {s | FST (X s) = i}) i)` THEN1 (
								RW_TAC std_ss [] THEN
								SUFF_TAC `!i. & x * & i *
       								(prob bern {s | FST (X s) = i} * 
								prob bern {s | FST (Y s) = x}) = 
								& x * prob bern {s | FST (Y s) = x} *
								(& i * 
								prob bern {s | FST (X s) = i})` THEN1
									RW_TAC std_ss [] THEN
							
									GEN_TAC THEN
									REAL_ARITH_TAC) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `!n. (\x. & x * prob bern {s | FST (Y s) = x} *
            					sum (0,n) (\i. & i * 
						prob bern {s | FST (X s) = i})) = 
						(\x. sum (0,n) (\i. & i *
							prob bern {s | FST (X s) = i}) * 
							(\x. & x * 
							prob bern {s | FST (Y s) = x}) x)` THEN1 (
							RW_TAC std_ss [] THEN
							PROVE_TAC [REAL_MUL_SYM]) THEN
						ASM_REWRITE_TAC [SUM_CMUL] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `(\n. sum (0,n) 
						(\i. & i * prob bern {s | FST (X s) = i}) *
       						sum (0,n) 
						(\x. & x * prob bern {s | FST (Y s) = x})) = 
						(\n. (\n. sum (0,n) 
						(\i. & i * prob bern {s | FST (X s) = i})) n *
       						(\n. sum (0,n) 
						(\x. & x * prob bern {s | FST (Y s) = x})) n)` THEN1
							RW_TAC std_ss [] THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						MATCH_MP_TAC SEQ_MUL THEN
						FULL_SIMP_TAC std_ss [sums]]) THEN

			ASM_REWRITE_TAC [POW_2] THEN
			REAL_ARITH_TAC);


(*=====================================================*)
val SECOND_MOMENT_SUM_N_RV_SUMMABLE = store_thm
 ("SECOND_MOMENT_SUM_N_RV_SUMMABLE",
 (--`!L. (!h. MEM h L ==> h IN indep_fn) /\
        (!a. MEM a L ==> (summable (\x. & x pow 2 * prob bern {s | FST (a s) = x}) /\
                         summable (\x. & x * prob bern {s | FST (a s) = x}))) ==>
                	(summable (\x. & x pow 2 * prob bern {s | FST ((sum_rv_lst L) s) = x}))`--),
        REPEAT STRIP_TAC THEN
        Induct_on `L` THENL [
                ONCE_REWRITE_TAC [MEM] THEN
                KNOW_TAC `!n. prob bern {s | FST (sum_rv_lst [] s) = n} =
                                (if (0 = n) then 1 else 0)` THEN1 (
                        RW_TAC std_ss [sum_rv_lst_def] THEN1
                                RW_TAC std_ss [GSPEC_T, PROB_BERN_BASIC] THEN
                                RW_TAC std_ss [GSPEC_F, PROB_BERN_BASIC]) THEN
                FULL_SIMP_TAC std_ss [] THEN
                POP_ASSUM K_TAC THEN
                RW_TAC std_ss [summable, sums] THEN
                KNOW_TAC `!n. sum (0,n) (\n. & n pow 2 * (if 0 = n then 1 else 0)) = 0` THEN1 (
                                Induct THEN1
                                        RW_TAC arith_ss [sum] THEN

                                        RW_TAC real_ss [sum]) THEN
                ASM_REWRITE_TAC [] THEN
                EXISTS_TAC (--`0:real`--) THEN
                RW_TAC std_ss [SEQ_CONST],
		
		RW_TAC arith_ss [MEM, sum_rv_lst_def] THEN
                MATCH_MP_TAC SUMMABLE_SECOND_MOMENT THEN
                FULL_SIMP_TAC std_ss [AND_IMP_INTRO] THEN
                CONJ_TAC THENL [
                        MATCH_MP_TAC INDEP_FN_SUM_RV_LIST THEN
                        GEN_TAC THEN
                        PROVE_TAC [],

                        MATCH_MP_TAC SUM_N_RV_SUMMABLE THEN
                        RW_TAC std_ss []]]);

val VARIANCE_SUM_N_RV = store_thm
 ("VARIANCE_SUM_N_RV",
 (--`!L.  (!h. MEM h L ==> h IN indep_fn) /\
        (!a. MEM a L ==> (summable (\x. & x pow 2 * prob bern {s | FST (a s) = x}) /\
                        summable (\x. & x * prob bern {s | FST (a s) = x}))) ==>
         (variance (sum_rv_lst L) =
                sum (0, LENGTH L) (\x. variance (EL (LENGTH L - (x+1)) L)))`--),
        REPEAT STRIP_TAC THEN
        Induct_on `L` THEN1 (
                ONCE_REWRITE_TAC [LENGTH] THEN
                ONCE_REWRITE_TAC [sum] THEN
                ONCE_REWRITE_TAC [variance_def] THEN
                ONCE_REWRITE_TAC [EXPEC_FN] THEN
                ONCE_REWRITE_TAC [MEM] THEN
                REPEAT STRIP_TAC THEN
                KNOW_TAC `summable (\x. (& x - expec (sum_rv_lst [])) pow 2 *
                prob bern {s | FST ((sum_rv_lst []) s) = x})` THEN1 (
                        MP_TAC (Q.SPEC `(sum_rv_lst [])` VARIANCE_SUMMABLE) THEN
                        KNOW_TAC `summable 
				(\x. & x * prob bern {s | FST (sum_rv_lst [] s) = x})` THEN1 (
                                MATCH_MP_TAC SUM_N_RV_SUMMABLE THEN
                                RW_TAC std_ss [MEM]) THEN
                        KNOW_TAC `summable
                        (\x. & x pow 2 * prob bern {s | FST (sum_rv_lst [] s) = x})` THEN1 (
                                MATCH_MP_TAC SECOND_MOMENT_SUM_N_RV_SUMMABLE THEN
                                RW_TAC std_ss [MEM]) THEN
                        KNOW_TAC `(sum_rv_lst [] IN indep_fn)` THEN1 (
                                MATCH_MP_TAC INDEP_FN_SUM_RV_LIST THEN
                                RW_TAC std_ss [MEM]) THEN
                	RW_TAC std_ss []) THEN
                KNOW_TAC `!n. prob bern {s | FST (sum_rv_lst [] s) = n} =
                                (if (0 = n) then 1 else 0)` THEN1 (
                        RW_TAC std_ss [sum_rv_lst_def] THEN1
                                RW_TAC std_ss [GSPEC_T, PROB_BERN_BASIC] THEN
                                RW_TAC std_ss [GSPEC_F, PROB_BERN_BASIC]) THEN
                FULL_SIMP_TAC std_ss [] THEN
                POP_ASSUM K_TAC THEN
                RW_TAC std_ss [summable, suminf] THEN
                SELECT_ELIM_TAC THEN
                CONJ_TAC THEN1
                        PROVE_TAC [summable] THEN

                        RW_TAC std_ss [] THEN
                        FULL_SIMP_TAC std_ss [sums] THEN
                        MATCH_MP_TAC SEQ_UNIQ THEN
                        EXISTS_TAC (--`(\n. sum (0,n) (\n.
                        	(& n - expec (sum_rv_lst [])) pow 2 *
                        	(if 0 = (n:num) then (1:real) else (0:real))))`--) THEN
                        ASM_REWRITE_TAC [] THEN
                        KNOW_TAC `!n. sum (0,n) (\n.
                        (& n - expec (sum_rv_lst [])) pow 2 *
                        (if 0 = n then 1 else 0)) = 0` THEN1 (
                                Induct THEN1
                                        RW_TAC arith_ss [sum] THEN

                                        RW_TAC real_ss [sum, expec_def,
                                      		REAL_NEG_MUL2, REAL_SUB_LZERO, POW_2] THEN
                                        REWRITE_TAC [REAL_ENTIRE] THEN
                                        ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
                                        MATCH_MP_TAC SUM_UNIQ THEN
                                        RW_TAC std_ss [sums] THEN
                                        KNOW_TAC `!n. prob bern {s | FST (sum_rv_lst [] s) = n} =
                                        (if (0 = n) then 1 else 0)` THEN1 (
                                                RW_TAC std_ss [sum_rv_lst_def] THEN1
                                                 	RW_TAC std_ss [GSPEC_T, 
								PROB_BERN_BASIC] THEN
                                                        RW_TAC std_ss [GSPEC_F, 
								PROB_BERN_BASIC]) THEN
                                        ASM_REWRITE_TAC [] THEN
                                        SUFF_TAC `!n.
                                        sum (0,n) (\n. & n * (if 0 = n then 1 else 0)) = 0` THEN1
                                                RW_TAC std_ss [SEQ_CONST] THEN

                                                GEN_TAC THEN
						KILL_ALL_TAC THEN
						Induct_on `n` THEN1
							RW_TAC real_ss [sum] THEN

							RW_TAC real_ss [sum]) THEN
                        ASM_REWRITE_TAC [SEQ_CONST]) THEN

                RW_TAC arith_ss [LENGTH, MEM, sum, sum_rv_lst_def] THEN
                FULL_SIMP_TAC std_ss [AND_IMP_INTRO] THEN
                KNOW_TAC `variance (sum_rv_lst (h::L)) =
                variance (\s. (sum_rv_lst (h::L)) s)` THEN1 (
                        MATCH_MP_TAC RAND_THM THEN
                        PROVE_TAC [ETA_THM]) THEN
                ASM_REWRITE_TAC [] THEN
                RW_TAC arith_ss [sum_rv_lst_def, ADD1, EL, HD] THEN
                KNOW_TAC `variance (\s. (FST (h s) + FST (sum_rv_lst L (SND (h s))),
                                SND (sum_rv_lst L (SND (h s))))) =
                		variance (sum_rv_lst L) + variance h` THEN1 (
                        ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
                        MATCH_MP_TAC VARIANCE_SUM_TWO_RV THEN
                        CONJ_TAC THEN1
                                PROVE_TAC [MEM] THEN
                                CONJ_TAC THEN1 (
                                        MATCH_MP_TAC INDEP_FN_SUM_RV_LIST THEN
                                        PROVE_TAC [MEM]) THEN
                                        CONJ_TAC THEN1 (
                                                POP_ASSUM K_TAC THEN
                                                POP_ASSUM (MP_TAC o Q.SPEC `h`) THEN
                                                RW_TAC std_ss []) THEN

                                                CONJ_TAC THEN1 (
                                                        MATCH_MP_TAC SUM_N_RV_SUMMABLE THEN
                                                        CONJ_TAC THEN1 (
                                                                GEN_TAC THEN
                                                                NTAC 2 (POP_ASSUM K_TAC) THEN
                                                                POP_ASSUM 
								  (MP_TAC o Q.SPEC `h'`) THEN
                                                                RW_TAC std_ss []) THEN

                                                                GEN_TAC THEN
                                                                POP_ASSUM K_TAC THEN
                                                                POP_ASSUM 
								   (MP_TAC o Q.SPEC `a`) THEN
                                                                RW_TAC std_ss []) THEN
                                                        CONJ_TAC THEN1 (
                                                                POP_ASSUM K_TAC THEN
                                                                POP_ASSUM (MP_TAC o 
									Q.SPEC `h`) THEN
                                                                RW_TAC std_ss []) THEN

                                                                RW_TAC std_ss [] THEN
                                                                MATCH_MP_TAC
                                                             SECOND_MOMENT_SUM_N_RV_SUMMABLE THEN
                                                                CONJ_TAC THEN1
                                                                        PROVE_TAC [MEM] THEN

                                                                        GEN_TAC THEN
                                                                        POP_ASSUM K_TAC THEN
                                                                        POP_ASSUM
                                                                        (MP_TAC o 
										Q.SPEC `a`) THEN
                                                                        RW_TAC std_ss []) THEN
                ASM_REWRITE_TAC [REAL_EQ_RADD] THEN
                POP_ASSUM K_TAC THEN
                MATCH_MP_TAC SUM_EQ THEN
                RW_TAC arith_ss [] THEN
                MATCH_MP_TAC RAND_THM THEN
                KNOW_TAC `(LENGTH L - r) =
                	SUC ((LENGTH L - (r + 1)))` THEN1
                        DECIDE_TAC THEN
                ASM_REWRITE_TAC [EL, TL]);


(***********************************************************);

val NUM_SQUARE_NUM_POWN_ZERO = store_thm
 ("NUM_SQUARE_NUM_POWN_ZERO",
 (--`!x. 0 <= x /\ x < 1 ==> ((\n. &n pow 2 * (x pow n)) --> 0)`--),
	RW_TAC std_ss [] THEN
	NTAC 2 (POP_ASSUM MP_TAC) THEN
	RW_TAC std_ss [REAL_LE_LT] THENL [
		MATCH_MP_TAC SER_ZERO THEN
		MATCH_MP_TAC SER_RATIO THEN
		KNOW_TAC `!n. abs (&n pow 2 * x pow n) = (&n pow 2 * x pow n)` THEN1
			RW_TAC real_ss [ABS_REFL, POW_POS, REAL_LE_MUL, REAL_LT_IMP_LE] THEN
		ASM_REWRITE_TAC [] THEN
		MP_TAC (Q.SPECL [`x`, `1`] REAL_MEAN) THEN
		RW_TAC std_ss [] THEN
		EXISTS_TAC (--`z:real`--) THEN
		RW_TAC std_ss [pow, REAL_MUL_ASSOC, REAL_POW_LT, REAL_LE_RMUL] THEN
		RW_TAC std_ss [ADD1, GSYM REAL_ADD, REAL_RDISTRIB] THEN
		ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
		KNOW_TAC `!n. (1 + & n) pow 2 = 1 + 2 * &n + & n pow 2` THEN1 (
			RW_TAC std_ss [POW_2] THEN
			REAL_ARITH_TAC) THEN
		RW_TAC std_ss [REAL_ADD_RDISTRIB, GSYM REAL_ADD,
				GSYM REAL_LE_SUB_LADD] THEN
		KNOW_TAC `!n. z * & n pow 2 - & n pow 2 * x - 2 * & n * x = 
			((z - x) * &n - 2 * x) * &n` THEN1 (
			GEN_TAC THEN
			FULL_SIMP_TAC std_ss [REAL_SUB_LDISTRIB,
				REAL_SUB_RDISTRIB, POW_2] THEN
			PROVE_TAC [REAL_MUL_ASSOC, REAL_MUL_SYM]) THEN
		ASM_REWRITE_TAC [] THEN
		KNOW_TAC `1 * x = x * 1` THEN1
			PROVE_TAC [REAL_MUL_SYM] THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		EXISTS_TAC (--`(ceiling (3*x / (z - x)) : num)+1`--) THEN
		RW_TAC std_ss [GREATER_EQ] THEN
		MATCH_MP_TAC REAL_LE_MUL2 THEN
		KNOW_TAC `0 < z - x` THEN1
			RW_TAC std_ss [REAL_SUB_LT] THEN
		RW_TAC real_ss [REAL_LT_IMP_LE, REAL_LE_SUB_LADD, 
			REAL_ADD_ASSOC, GSYM REAL_DOUBLE] THEN
		ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
		KNOW_TAC `x + x + x = 3 * x` THEN1
			REAL_ARITH_TAC THEN
		ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		KNOW_TAC `(3 * x <= & n * (z - x)) = 
			((3 * x)/(z - x) <= &n)` THEN1 
			PROVE_TAC [REAL_LE_LDIV_EQ] THEN
		ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`&((ceiling (3 * x / (z - x))):num)`--) THEN
		RW_TAC arith_ss [LB_CEILING, REAL_LE],
		
		ONCE_REWRITE_TAC [SEQ_SUC] THEN
		RW_TAC real_ss [POW_0, SEQ_CONST]]);

val SUM_SUCN_POW2_POWN = store_thm
 ("SUM_SUCN_POW2_POWN",
 (--`!q n. sum (0,n) (\x. (& (SUC x) pow 2) * q pow x) = 
		sum (0,n) (\x. (2 * &x + 1) * ((sum (0,n) (\i. q pow i)) - 
						(sum (0,x) (\i. q pow i))))`--),
	GEN_TAC THEN
	Induct THEN1
		RW_TAC real_ss [sum] THEN

		REWRITE_TAC [sum] THEN
		KNOW_TAC `(\x. (2 * & x + 1) *
       			(sum (0,n) (\i. q pow i) + (\i. q pow i) (0 + n) -
        		sum (0,x) (\i. q pow i))) (0 + n) = (2 * &n + 1) * q pow n` THEN1  
			RW_TAC real_ss [] THEN
		ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN	
		KNOW_TAC `sum (0,n) (\x.(2 * & x + 1) *
         		(sum (0,n) (\i. q pow i) + (\i. q pow i) (0 + n) -
          		sum (0,x) (\i. q pow i))) = 
			sum (0,n) (\x.(2 * & x + 1) *
           			(sum (0,n) (\i. q pow i) - sum (0,x) (\i. q pow i))) + 
				 sum (0,n) (\x. & (2 * x + 1) * q pow n)` THEN1 (
			RW_TAC real_ss [] THEN
			KNOW_TAC `(\x. & (2 * x + 1) *
         			(sum (0,n) (\i. q pow i) + q pow n - sum (0,x) (\i. q pow i))) =
				(\x. (\x. & (2 * x + 1) *
         			(sum (0,n) (\i. q pow i) - sum (0,x) (\i. q pow i))) x +
				(\x. & (2 * x + 1) * q pow n) x)` THEN1 (
				RW_TAC std_ss [GSYM REAL_ADD_LDISTRIB, real_sub] THEN
				PROVE_TAC [REAL_ADD_ASSOC, REAL_ADD_SYM]) THEN
			ASM_REWRITE_TAC [SUM_ADD]) THEN
		ASM_REWRITE_TAC [] THEN
		ONCE_REWRITE_TAC [GSYM REAL_ADD_ASSOC] THEN
		RW_TAC arith_ss [REAL_EQ_LADD] THEN
		KILL_ALL_TAC THEN
		ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
		KNOW_TAC `(\x. q pow n * & (2 * x + 1)) = 
			(\x. q pow n * (\x. & (2 * x + 1)) x)` THEN1
			RW_TAC std_ss [] THEN
		ASM_REWRITE_TAC [SUM_CMUL, GSYM REAL_ADD_LDISTRIB, REAL_EQ_LMUL] THEN
		POP_ASSUM K_TAC THEN
		DISJ2_TAC THEN		
		Induct_on `n` THEN1
			RW_TAC real_ss [sum] THEN	
			
			RW_TAC real_ss [sum] THEN
			KNOW_TAC `& (SUC (SUC n)) pow 2 = & (SUC n) pow 2 + 1 + 2 * & (n + 1)` THEN1 (
				KILL_ALL_TAC THEN
				RW_TAC real_ss [POW_2, ADD1, LEFT_ADD_DISTRIB, RIGHT_ADD_DISTRIB]) THEN
			ASM_REWRITE_TAC [] THEN
			KILL_ALL_TAC THEN
			RW_TAC std_ss [GSYM REAL_ADD, GSYM REAL_MUL, ADD1,
				REAL_EQ_LADD, GSYM REAL_ADD_ASSOC] THEN		
			REAL_ARITH_TAC);			
		


val SUCN_POW2_POWN_SUMS = store_thm
 ("SUCN_POW2_POWN_SUMS",
 (--`!q. 0 <= q /\ q < 1 ==>
         (\x. & (SUC x) pow 2 * q pow x) sums ((1+q)/(1-q)pow 3)`--),
	RW_TAC real_ss [SUM_SUCN_POW2_POWN, sums, GP_FINITE, REAL_LT_IMP_NE,
		GSYM SUM_SUB, real_div, GSYM REAL_SUB_RDISTRIB, REAL_SUB_ASSOC, GSYM REAL_SUB_ASSOC2] THEN
	KNOW_TAC `!n. (\x. & (2 * x + 1) * ((q pow n - q pow x) * (inv (q - 1)))) = 
	 (\x. (inv (q - 1)) * (\x. (\x. & (2 * x + 1) * (q pow n)) x -
	 			(\x. & (2 * x + 1) * (q pow x)) x) x)` THEN1 (
		RW_TAC std_ss [GSYM REAL_SUB_LDISTRIB, REAL_MUL_ASSOC] THEN
		PROVE_TAC [REAL_MUL_SYM, REAL_MUL_ASSOC]) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	ONCE_REWRITE_TAC [SUM_CMUL] THEN
	REWRITE_TAC [SUM_SUB] THEN
	KNOW_TAC `(\n. inv (q - 1) *
       	(sum (0,n) (\x. & (2 * x + 1) * q pow n) -
        sum (0,n) (\x. & (2 * x + 1) * q pow x))) = 
	(\n. (\n. inv (q - 1)) n * (\n. 
       	(\n. sum (0,n) (\x. & (2 * x + 1) * q pow n)) n -
        (\n. sum (0,n) (\x. & (2 * x + 1) * q pow x)) n) n)` THEN1
		RW_TAC std_ss [] THEN
	KNOW_TAC `((1 + q) * inv ((1 - q) pow 3)) = 	
	inv (q - 1) * (0 - ((1 + q) * inv ((1 - q) pow 2)))` THEN1 (	 
		RW_TAC real_ss [REAL_SUB_LZERO] THEN
		KNOW_TAC `inv (q - 1) = ~inv (1 - q)` THEN1 (
			ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
			KNOW_TAC `(q - 1) = ~(1 - q)` THEN1
				RW_TAC std_ss [REAL_NEG_SUB] THEN
			ASM_REWRITE_TAC [] THEN	
			MATCH_MP_TAC REAL_NEG_INV THEN
			REWRITE_TAC [REAL_SUB_0] THEN
			RW_TAC real_ss [REAL_NE_LT_GT]) THEN
		ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		ONCE_REWRITE_TAC [REAL_NEG_LMUL] THEN
		RW_TAC real_ss [REAL_MUL_ASSOC] THEN
		KNOW_TAC `3 = SUC 2` THEN1
			DECIDE_TAC THEN
		ASM_REWRITE_TAC [pow] THEN
		KNOW_TAC `~((1 - q)=0)` THEN1 (
			REWRITE_TAC [REAL_SUB_0] THEN
			RW_TAC real_ss [REAL_NE_LT_GT]) THEN
		KNOW_TAC `~((1 - q) pow 2 = 0)` THEN1 (
			MATCH_MP_TAC REAL_POS_NZ THEN
			MATCH_MP_TAC REAL_POW_LT THEN
			RW_TAC std_ss [REAL_SUB_LT]) THEN
		RW_TAC std_ss [REAL_INV_MUL] THEN
		REAL_ARITH_TAC) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	NTAC 2 (POP_ASSUM K_TAC) THEN
	MATCH_MP_TAC SEQ_MUL THEN
	CONJ_TAC THEN1
		RW_TAC std_ss [SEQ_CONST] THEN
	
		MATCH_MP_TAC SEQ_SUB THEN
		CONJ_TAC THEN1 (
			KNOW_TAC `!n. (\x. & (2 * x + 1) * q pow n) = 
			(\x. q pow n * (\x. 
				(\x. 2 * (\x. &x) x) x + 
				(\x. &1) x) x)` THEN1 (
				RW_TAC real_ss [] THEN
				PROVE_TAC [REAL_MUL_SYM]) THEN
			ONCE_ASM_REWRITE_TAC [] THEN
			ONCE_REWRITE_TAC [SUM_CMUL] THEN	
			ONCE_REWRITE_TAC [SUM_ADD] THEN
			ONCE_REWRITE_TAC [SUM_CMUL] THEN
			KNOW_TAC `!n. sum (0,n) (\x. 1) = &n` THEN1 (
				Induct THEN1
					RW_TAC std_ss [sum] THEN

					RW_TAC std_ss [sum, ADD1, REAL_ADD]) THEN
			ASM_REWRITE_TAC [REAL_LDISTRIB] THEN
			POP_ASSUM K_TAC THEN
			RW_TAC std_ss [ETA_THM, ALL_NUM_SER] THEN
			KNOW_TAC `!n. (2 * (& n * (& n - 1) / 2)) = 
			&n pow 2 - &n` THEN1 (
				RW_TAC real_ss [real_div] THEN
				ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
				RW_TAC real_ss [REAL_MUL_LINV, POW_2, GSYM REAL_MUL_ASSOC,
				REAL_SUB_LDISTRIB]) THEN
			RW_TAC real_ss [REAL_SUB_LDISTRIB] THEN
			ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
			MATCH_MP_TAC NUM_SQUARE_NUM_POWN_ZERO THEN
			ASM_REWRITE_TAC []) THEN
		
			KNOW_TAC `!n. (\x. & (2 * x + 1) * q pow x) = 
			(\x. (\x. 2 * (\x. &x * q pow x) x) x + 
			(\x. q pow x) x)` THEN1 (
				RW_TAC std_ss [REAL_LDISTRIB, REAL_MUL_ASSOC, REAL_MUL_LID,
				REAL_RDISTRIB, GSYM REAL_MUL, GSYM REAL_ADD]) THEN
			ASM_REWRITE_TAC [SUM_ADD, SUM_CMUL] THEN
			POP_ASSUM K_TAC THEN
			KNOW_TAC `((1 + q) * inv ((1 - q) pow 2)) = 
			(2 * (q / (1-q) pow 2)) + inv (1-q)` THEN1 (
				RW_TAC std_ss [real_div] THEN
				KNOW_TAC `0 < inv ((1 - q) pow 2)` THEN1 (
					MATCH_MP_TAC REAL_INV_POS THEN
					MATCH_MP_TAC REAL_POW_LT THEN
					RW_TAC std_ss [REAL_SUB_LT]) THEN
				RW_TAC std_ss [GSYM REAL_EQ_RDIV_EQ, real_div,
				REAL_RDISTRIB, REAL_INV_INV, REAL_MUL_ASSOC] THEN
				ONCE_REWRITE_TAC [GSYM REAL_MUL_ASSOC] THEN
				RW_TAC std_ss [REAL_SUB_LT,
				REAL_MUL_LINV, REAL_POS_NZ, REAL_INV_POS, REAL_POW_LT] THEN
				RW_TAC real_ss [POW_2, REAL_MUL_LINV, REAL_POS_NZ,
				REAL_INV_POS, REAL_MUL_ASSOC, REAL_SUB_LT] THEN
				REAL_ARITH_TAC) THEN
			ONCE_ASM_REWRITE_TAC [] THEN
			KNOW_TAC `(\n. 2 * sum (0,n) (\x. & x * q pow x) + 
			sum (0,n) (\x. q pow x)) = 
			(\n. (\n. 2 * sum (0,n) (\x. & x * q pow x)) n  + 
			(\n. sum (0,n) (\x. q pow x)) n)` THEN1
				RW_TAC std_ss [] THEN
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			MATCH_MP_TAC SEQ_ADD THEN
			CONJ_TAC THEN1 (
				KNOW_TAC `(\n. 2 * sum (0,n) (\x. & x * q pow x)) = 
				(\n. (\n. 2) n * (\n. sum (0,n) (\x. & x * q pow x)) n)` THEN1
					RW_TAC std_ss [] THEN
				ONCE_ASM_REWRITE_TAC [] THEN
				MATCH_MP_TAC SEQ_MUL THEN
				RW_TAC std_ss [SEQ_CONST, GSYM sums, real_div] THEN
				KNOW_TAC `!x. & x * q pow x = 
				q * (\x. & x * q pow (x-1)) x` THEN1 (
					Induct THEN1
						RW_TAC real_ss [] THEN
					
						RW_TAC real_ss [pow] THEN
						REAL_ARITH_TAC) THEN
				ASM_REWRITE_TAC [] THEN
				MATCH_MP_TAC SER_CMUL THEN
				REWRITE_TAC [sums] THEN
				ONCE_REWRITE_TAC [SEQ_SUC] THEN
				RW_TAC std_ss [] THEN
				KNOW_TAC `!n. sum (0,SUC n) (\x. & x * q pow (x - 1)) = 
				sum (0,n) (\x. & (SUC x) * q pow x)` THEN1 (
					Induct THEN1
						RW_TAC real_ss [SUM_1, sum] THEN
					
						RW_TAC real_ss [sum]) THEN
				ASM_REWRITE_TAC [GSYM sums, REAL_INV_1OVER] THEN
				MATCH_MP_TAC SUCN_POWN_SUMS THEN		
				ASM_REWRITE_TAC []) THEN
			
				REWRITE_TAC [GSYM sums] THEN
				MATCH_MP_TAC GP THEN
				KNOW_TAC `abs q = q` THEN1
					RW_TAC std_ss [ABS_REFL] THEN
				PROVE_TAC []);


val SECOND_MOMENT_GEOMETRIC_SUMS = store_thm
 ("SECOND_MOMENT_GEOMETRIC_SUMS",
 (--`!p. 0 < p /\ p <= 1  ==>
	(\x. & x pow 2 * prob bern 
		{s | FST (prob_geometric_p p s) = x}) sums (2/(p pow 2) - 1/p)`--),
	RW_TAC std_ss [sums] THEN
	KNOW_TAC `!n. sum (0,n)
        (\x. & x pow 2 * prob bern {s | FST (prob_geometric_p p s) = x}) =
        sum (0,n-1) (\x. &(SUC x) pow 2 * 
		prob bern {s | FST (prob_geometric_p p s) = (SUC x)})` THEN1 (
        	GEN_TAC THEN
        	ONCE_REWRITE_TAC [ADD1] THEN
        	KNOW_TAC `(\x. & (x + 1) pow 2 *
                prob bern {s | FST (prob_geometric_p p s) = x + 1}) =
                (\x. (\x. & x pow 2 * prob bern {s | FST (prob_geometric_p p s) = x}) (x + 1))` THEN1
                	RW_TAC std_ss [] THEN
        	ASM_REWRITE_TAC [SUM_OFFSET] THEN
        	RW_TAC real_ss [SUM_1] THEN
        	Induct_on `n` THEN1 
                	RW_TAC real_ss [sum, SUM_1] THEN

                	KNOW_TAC `SUC n - 1 + 1 = SUC n` THEN1
                        	DECIDE_TAC THEN
                	RW_TAC std_ss []) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `!s. ((\n. sum (0,n - 1) (\x. & (SUC x) pow 2 *
               prob bern {s | FST (prob_geometric_p p s) = SUC x})) --> s) =
                ((\n. (\n. sum (0,n - 1) (\x. & (SUC x) pow 2 *
               prob bern {s | FST (prob_geometric_p p s) = SUC x})) (SUC n)) --> s)` THEN1
        	RW_TAC std_ss [GSYM SEQ_SUC] THEN
	RW_TAC arith_ss [GSYM sums, PROB_BERN_GEOMETRIC_P] THEN
	POP_ASSUM K_TAC THEN
	ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
	KNOW_TAC `!x. p * (1 - p) pow x * & (SUC x) pow 2 =
	p * & (SUC x) pow 2 * (1 - p) pow x` THEN1 (
		GEN_TAC THEN
		REAL_ARITH_TAC) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `(\x. p * & (SUC x) pow 2 * (1 - p) pow x) =
	(\x. p * (\x.& (SUC x) pow 2 * (1 - p) pow x) x)` THEN1
		RW_TAC std_ss [REAL_MUL_ASSOC] THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	SUFF_TAC `(\x. &(SUC x) pow 2 * (1 - p) pow x) sums
			(2/((1-(1-p))pow 3) - 1/((1-(1-p))pow 2))` THEN1 (
        	KNOW_TAC `(1-(1-p)) = p` THEN1
                	REAL_ARITH_TAC THEN
        	ASM_REWRITE_TAC [] THEN
        	STRIP_TAC THEN
        	KNOW_TAC `(\x. p * (\x. & (SUC x) pow 2 * (1 - p) pow x) x) sums
                (p * (2 / p pow 3 - 1 / p pow 2))` THEN1 (
                	MATCH_MP_TAC SER_CMUL THEN
			RW_TAC std_ss []) THEN
		KNOW_TAC `(p * (2 / p pow 3 - 1 / p pow 2)) = 
        	(2 / p pow 2 - 1 / p)` THEN1 (
			RW_TAC real_ss [real_div, POW_2, GSYM REAL_POW_INV, REAL_SUB_LDISTRIB,
			REAL_MUL_RINV, REAL_POS_NZ, REAL_EQ_SUB_RADD,
                        REAL_MUL_ASSOC, REAL_MUL_RINV, REAL_POS_NZ] THEN
			KNOW_TAC `3 = (SUC (SUC (SUC 0)))` THEN1
				DECIDE_TAC THEN
			ASM_REWRITE_TAC [pow] THEN
			ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
			RW_TAC real_ss [REAL_MUL_ASSOC] THEN
			ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
			RW_TAC real_ss [GSYM REAL_MUL_ASSOC, REAL_MUL_LINV, REAL_POS_NZ] THEN
			REAL_ARITH_TAC) THEN
		PROVE_TAC []) THEN
	
		KNOW_TAC `0 <= 1 - p /\ 1 - p < 1` THEN1
			RW_TAC std_ss [REAL_SUB_LE, REAL_LT_SUB_RADD, REAL_LT_ADDR] THEN
		NTAC 2 (POP_ASSUM MP_TAC) THEN	
		Q.SPEC_TAC (`1-p`, `q`) THEN
		RW_TAC std_ss [] THEN
		KNOW_TAC `(2 / (1 - q) pow 3 - 1 / (1 - q) pow 2) =
		((1 + q) / (1 - q) pow 3)` THEN1 (
			RW_TAC std_ss [REAL_EQ_RDIV_EQ, REAL_POW_LT, REAL_SUB_LT,
			REAL_SUB_RDISTRIB, REAL_DIV_RMUL, REAL_POS_NZ] THEN
			KNOW_TAC `3 = SUC 2` THEN1
				DECIDE_TAC THEN
			ASM_REWRITE_TAC [pow] THEN
			ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
			RW_TAC real_ss [REAL_MUL_RINV, real_div, GSYM REAL_MUL_ASSOC,
			REAL_POW_LT, REAL_SUB_LT, REAL_POS_NZ] THEN
			REAL_ARITH_TAC) THEN
		ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC SUCN_POW2_POWN_SUMS THEN
		RW_TAC std_ss []);

val SECOND_MOMENT_GEOMETRIC = store_thm
 ("SECOND_MOMENT_GEOMETRIC",
 (--`!p. 0 < p /\ p <= 1 ==>
	(expec_fn (\x. &x pow 2) (\s. prob_geometric_p p s) = 2/(p pow 2) - 1/p)`--),
	RW_TAC std_ss [EXPEC_FN, suminf, sums] THEN
	SELECT_ELIM_TAC THEN
	CONJ_TAC THEN1 (
		EXISTS_TAC (--`2 / p pow 2 - 1 / p`--) THEN
		RW_TAC std_ss [GSYM sums, SECOND_MOMENT_GEOMETRIC_SUMS]) THEN
	
		MP_TAC (Q.SPEC `p` SECOND_MOMENT_GEOMETRIC_SUMS) THEN
		RW_TAC std_ss [sums] THEN
		MATCH_MP_TAC SEQ_UNIQ THEN
		EXISTS_TAC (--`(\n.
             sum (0,n)
               (\x.
                  & x pow 2 *
                  prob bern {s | FST (prob_geometric_p p s) = x}))`--) THEN
		RW_TAC std_ss []);


val VARIANCE_GEOMETRIC = store_thm
 ("VARIANCE_GEOMETRIC",
 (--`!p. 0 < p /\ p <= 1 ==>
	(variance (\s. prob_geometric_p p s) = (1 - p)/p pow 2)`--),
	REPEAT STRIP_TAC THEN
	KNOW_TAC `variance (\s. prob_geometric_p p s) = 
	expec_fn (\x. & x pow 2)  (\s. prob_geometric_p p s)- 
		(expec (\s. prob_geometric_p p s)) pow 2` THEN1 (
		MATCH_MP_TAC VARIANCE_EXPEC THEN
		RW_TAC std_ss [EXPEC_GEOMETRIC_SUMMABLE] THENL [
				MATCH_MP_TAC SUM_SUMMABLE THEN
				EXISTS_TAC (--`(2 / p pow 2 - 1 / p)`--) THEN
				MATCH_MP_TAC SECOND_MOMENT_GEOMETRIC_SUMS THEN
				ASM_REWRITE_TAC [],
			
				KNOW_TAC `(\s. prob_geometric_p p s) = 
				prob_geometric_p p` THEN1 (
					Q.SPEC_TAC (`prob_geometric_p p`, `M`) THEN
					RW_TAC std_ss [ETA_THM]) THEN
				ASM_REWRITE_TAC [] THEN
				MATCH_MP_TAC INDEP_FN_PROB_GEOMETRIC_P THEN
				ASM_REWRITE_TAC []]) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	RW_TAC std_ss [SECOND_MOMENT_GEOMETRIC, EXPEC_GEOMETRIC, 
	REAL_EQ_RDIV_EQ, REAL_POW_LT, REAL_SUB_RDISTRIB, REAL_DIV_RMUL, REAL_POS_NZ] THEN
	RW_TAC real_ss [real_div, POW_2, REAL_POW_INV, REAL_MUL_LINV, REAL_POS_NZ,
	REAL_POW_LT, REAL_MUL_ASSOC, REAL_INV_MUL] THEN
	ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
	RW_TAC real_ss [GSYM REAL_MUL_ASSOC, REAL_MUL_LINV, REAL_MUL_RINV,
					REAL_POS_NZ, REAL_POW_LT] THEN
	REAL_ARITH_TAC);


val MARKOV_INEQUALITY = store_thm 
 ("MARKOV_INEQUALITY",
 (--`!R a. (R IN indep_fn) /\ (0 < a) /\ 
	summable (\n. & n * prob bern {s | FST (R s) = n}) ==>
		(prob bern {s | & (FST (R s)) >= a} <= expec R / a)`--),
	RW_TAC std_ss [expec_def, suminf, sums] THEN
	SELECT_ELIM_TAC THEN
	RW_TAC std_ss [GSYM sums, GSYM summable] THEN
	FULL_SIMP_TAC std_ss [sums] THEN
	KNOW_TAC `{s | & (FST (R s)) >= a} = {s | FST (R s) >= ceiling a}` THEN1 (
		RW_TAC std_ss [real_ge, GREATER_EQ, EXTENSION] THEN
		PSET_TAC [GSPECIFICATION] THEN
		EQ_TAC THENL [
			RW_TAC std_ss [GSYM REAL_LE] THEN
			CCONTR_TAC THEN
			FULL_SIMP_TAC std_ss [REAL_NOT_LE, REAL_LT, LESS_EQ, ADD1] THEN
			FULL_SIMP_TAC std_ss [GSYM REAL_LE, GSYM REAL_ADD, GSYM REAL_LE_SUB_LADD] THEN
			KNOW_TAC `a <= & (ceiling a) - 1` THEN1 (
				MATCH_MP_TAC REAL_LE_TRANS THEN
				EXISTS_TAC (--`& (FST ((R: (num -> bool) -> num#(num -> bool)) x')):real`--) THEN
				RW_TAC std_ss []) THEN
			POP_ASSUM MP_TAC THEN
			RW_TAC std_ss [REAL_NOT_LE, REAL_LT_SUB_RADD] THEN
			MATCH_MP_TAC UB_CEILING THEN
			RW_TAC std_ss [REAL_LT_IMP_LE],

			RW_TAC std_ss [GSYM REAL_LE] THEN
			MATCH_MP_TAC REAL_LE_TRANS THEN
			EXISTS_TAC (--`& (ceiling a)`--) THEN
			RW_TAC std_ss [LB_CEILING]]) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`x / &(ceiling a)`--) THEN
	CONJ_TAC THEN1 (
	KNOW_TAC `0 < ceiling a` THEN1 (
		RW_TAC std_ss [GSYM REAL_LT] THEN
		MATCH_MP_TAC REAL_LTE_TRANS THEN
		EXISTS_TAC (--`a:real`--) THEN
		RW_TAC std_ss [LB_CEILING]) THEN
	NTAC 3 (POP_ASSUM MP_TAC) THEN
	POP_ASSUM K_TAC THEN
	Q.SPEC_TAC (`ceiling a`, `a`) THEN
	RW_TAC std_ss [] THEN
	KNOW_TAC `(\n. sum (0,a+n) (\n. & n * prob bern {s | FST (R s) = n})) --> x` THEN1 (
		Induct_on `a` THEN1
			RW_TAC arith_ss [] THEN

			Cases_on `a` THENL [
				RW_TAC arith_ss [GSYM ADD1] THEN
				KNOW_TAC `(\n. sum (0,SUC n) 
				(\n. & n * prob bern {s | FST (R s) = n})) =
				(\n. (\n. sum (0,n) (\n. & n * prob bern {s | FST (R s) = n})) 
						(SUC n))` THEN1
					RW_TAC std_ss [] THEN
				ASM_REWRITE_TAC [] THEN
				ONCE_REWRITE_TAC [GSYM SEQ_SUC] THEN		
				ASM_REWRITE_TAC [],

				RW_TAC std_ss [] THEN
				FULL_SIMP_TAC arith_ss [] THEN
				POP_ASSUM K_TAC THEN
				POP_ASSUM MP_TAC THEN
				Q.SPEC_TAC (`SUC n`, `a`) THEN
				RW_TAC std_ss [] THEN	
				KNOW_TAC `(\n. sum (0,n + SUC a) 
				(\n. & n * prob bern {s | FST (R s) = n})) = 
				(\n. (\n. sum (0,n + a) 
					(\n. & n * prob bern {s | FST (R s) = n})) (SUC n))` THEN1
					RW_TAC arith_ss [ADD1] THEN
                        	ASM_REWRITE_TAC [] THEN
                        	ONCE_REWRITE_TAC [GSYM SEQ_SUC] THEN
                        	ASM_REWRITE_TAC []]) THEN
	FULL_SIMP_TAC std_ss [GSYM SUM_TWO] THEN
	KNOW_TAC `(\n. (\n.
             sum (0,a) (\n. & n * prob bern {s | FST (R s) = n}) +
             sum (a,n) (\n. & n * prob bern {s | FST (R s) = n})) n - 
		(\n. sum (0,a) (\n. & n * prob bern {s | FST (R s) = n})) n) --> 
				(x - sum (0,a) (\n. & n * prob bern {s | FST (R s) = n}))` THEN1 (
		MATCH_MP_TAC SEQ_SUB THEN
		RW_TAC std_ss [SEQ_CONST]) THEN
	KNOW_TAC `(\n. (\n.
             sum (0,a) (\n. prob bern {s | FST (R s) = n}) +
             sum (a,n) (\n. prob bern {s | FST (R s) = n})) n - 
		(\n. sum (0,a) (\n. prob bern {s | FST (R s) = n})) n) --> 
				(1 - sum (0,a) (\n. prob bern {s | FST (R s) = n}))` THEN1 (
		MATCH_MP_TAC SEQ_SUB THEN
		RW_TAC std_ss [SEQ_CONST, SUM_TWO] THEN
		NTAC 5 (POP_ASSUM K_TAC) THEN
		Induct_on `a` THEN1 (
			RW_TAC arith_ss [GSYM sums] THEN
			MATCH_MP_TAC PMF_SUMS_1 THEN
			ASM_REWRITE_TAC []) THEN
			
			KNOW_TAC `(\n. sum (0,SUC a + n) (\n. prob bern {s | FST (R s) = n})) = 
			(\n. (\n. sum (0,a + n) (\n. prob bern {s | FST (R s) = n})) (SUC n))` THEN1
				RW_TAC arith_ss [ADD1] THEN
			ASM_REWRITE_TAC [] THEN
			ONCE_REWRITE_TAC [GSYM SEQ_SUC] THEN	
			ASM_REWRITE_TAC []) THEN
	KNOW_TAC `!a b. (a + b) - a = b` THEN1 (
		REPEAT GEN_TAC THEN
		REAL_ARITH_TAC) THEN
	FULL_SIMP_TAC std_ss [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `(\n. sum (a,n) (\n. (& n/ (&a)) * prob bern {s | FST (R s) = n})) -->
          (x/(&a) - sum (0,a) (\n. & n/(&a) * prob bern {s | FST (R s) = n}))` THEN1 (
		RW_TAC std_ss [real_div] THEN
		KNOW_TAC `(\n. & n * inv (& a) * prob bern {s | FST (R s) = n}) = 
		(\n. inv (& a) * (\n. & n * prob bern {s | FST (R s) = n}) n)` THEN1 (
			RW_TAC std_ss [] THEN
			PROVE_TAC [REAL_MUL_ASSOC, REAL_MUL_SYM]) THEN
		ASM_REWRITE_TAC [SUM_CMUL] THEN
		KNOW_TAC `!a b c. a * b - b * c = b * (a - c)` THEN1 (
			REPEAT GEN_TAC THEN
			REAL_ARITH_TAC) THEN
		ASM_REWRITE_TAC [] THEN
		KNOW_TAC `(\n. inv (& a) * 
		sum (a,n) (\n. & n * prob bern {s | FST (R s) = n})) = 
		(\n. (\n. inv (& a)) n * 
		(\n. sum (a,n) (\n. & n * prob bern {s | FST (R s) = n})) n)` THEN1
			RW_TAC std_ss [] THEN
		ONCE_ASM_REWRITE_TAC [] THEN
		MATCH_MP_TAC SEQ_MUL THEN
		RW_TAC std_ss [SEQ_CONST]) THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`(1 - sum (0,a) 
	(\n. prob bern {s | FST ( (R: (num -> bool) -> num#(num -> bool))s) = n}))`--) THEN


	CONJ_TAC THEN1 (
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`1 - prob bern {s | 
		FST ((R: (num -> bool) -> num#(num -> bool)) s) < a}`--) THEN
		CONJ_TAC THEN1 (
			MATCH_MP_TAC REAL_EQ_IMP_LE THEN
			KNOW_TAC `{s | FST (R s) >= a} = COMPL {s | FST (R s) < a}` THEN1 (
				REWRITE_TAC [EXTENSION] THEN
				PSET_TAC [GSPECIFICATION, IN_COMPL, GREATER_EQ, NOT_LESS]) THEN
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			RW_TAC std_ss [GSYM PROB_BERN_UNIV] THEN
			REWRITE_TAC [prob_def] THEN
			SUFF_TAC `measure bern UNIV = measure bern {s | FST (R s) < a}
                	+ measure bern (COMPL {s | FST (R s) < a})` THEN1
        			REAL_ARITH_TAC THEN
			MATCH_MP_TAC ADDITIVE THEN
			RW_TAC std_ss [] THENL [
        			MATCH_MP_TAC COUNTABLY_ADDITIVE_ADDITIVE THEN
        			CONJ_TAC THEN1 (
                			RW_TAC std_ss [GSYM events_def] THEN
                			MATCH_MP_TAC EVENTS_ALGEBRA THEN
                			RW_TAC std_ss [PROB_SPACE_BERN]) THEN

                			CONJ_TAC THEN1 (
                        			MATCH_MP_TAC PROB_SPACE_POSITIVE THEN
                        			RW_TAC std_ss [PROB_SPACE_BERN]) THEN

                        			MATCH_MP_TAC PROB_SPACE_COUNTABLY_ADDITIVE THEN
                        			RW_TAC std_ss [PROB_SPACE_BERN],


        			ONCE_REWRITE_TAC [GSYM events_def] THEN
        			KNOW_TAC  `{s | FST (R s) < a} =
                        		((\y. y < a) o FST o R)` THEN1 
                			PSET_TAC [o_DEF] THEN
        			ASM_REWRITE_TAC [] THEN
        			MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
        			RW_TAC std_ss [], 
	
        			KNOW_TAC `COMPL {s | FST (R s) < a} = ((\y. y >= a) o FST o R)` THEN1
					PSET_TAC [o_DEF, GREATER_EQ, NOT_LESS] THEN
	       			ASM_REWRITE_TAC [] THEN
				ONCE_REWRITE_TAC [GSYM events_def] THEN
				MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
        			RW_TAC std_ss [], 


        			RW_TAC std_ss [DISJOINT_DEF] THEN
        			REWRITE_TAC [EXTENSION] THEN
        			PSET_TAC [GSPECIFICATION, IN_COMPL, IN_INTER],

        			REWRITE_TAC [EXTENSION] THEN
        			PSET_TAC [GSPECIFICATION, IN_COMPL, IN_UNION]]) THEN

			RW_TAC std_ss [real_sub, REAL_LE_LADD, REAL_LE_NEG] THEN
			MATCH_MP_TAC REAL_EQ_IMP_LE THEN
			MATCH_MP_TAC SUM_PMF_CDF THEN
			RW_TAC std_ss []) THEN

		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`(x / & a -
           sum (0,a) (\n. & n / & a * prob bern {s | FST 
			((R: (num -> bool) -> num#(num -> bool))s) = n}))`--) THEN
		CONJ_TAC THEN1 (
			MATCH_MP_TAC SEQ_LE THEN
			EXISTS_TAC (--`(\n. sum (a,n) (\n. prob bern {s | FST 
			((R: (num -> bool) -> num#(num -> bool)) s) = n}))`--) THEN
			EXISTS_TAC (--`(\n.
             		sum (a,n) (\n. & n / & a * prob bern {s | FST 
			((R: (num -> bool) -> num#(num -> bool)) s) = n}))`--) THEN
			RW_TAC std_ss [] THEN
			EXISTS_TAC (--`0:num`--) THEN
			RW_TAC arith_ss [] THEN
			MATCH_MP_TAC SUM_LE THEN
			RW_TAC arith_ss [] THEN
			KNOW_TAC `(prob bern {s | FST (R s) = r} <=
    			& r / & a * prob bern {s | FST (R s) = r}) = 
			(1 * prob bern {s | FST (R s) = r} <=
    			& r / & a * prob bern {s | FST (R s) = r})` THEN1
				RW_TAC real_ss [] THEN
			ONCE_ASM_REWRITE_TAC [] THEN
			MATCH_MP_TAC REAL_LE_MUL2 THEN
			RW_TAC real_ss [REAL_LE_RDIV_EQ] THEN
			MATCH_MP_TAC PROB_POSITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN] THEN
			KNOW_TAC  `{s | FST (R s) = r} =
                        ((\y. y = r) o FST o R)` THEN1
                			PSET_TAC [o_DEF] THEN
        		ASM_REWRITE_TAC [] THEN
        		MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
        		RW_TAC std_ss []) THEN	
		
			RW_TAC std_ss [REAL_LE_SUB_RADD, REAL_LE_ADDR] THEN
			MATCH_MP_TAC SUM_POS THEN
			RW_TAC std_ss [real_div, GSYM REAL_MUL_ASSOC] THEN
			MATCH_MP_TAC REAL_LE_MUL THEN
			RW_TAC real_ss [] THEN
			MATCH_MP_TAC REAL_LE_MUL THEN
			RW_TAC real_ss [REAL_LE_INV] THEN
			MATCH_MP_TAC PROB_POSITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN, INDEP_FN_SET_FST_EVENTS]) THEN

	KNOW_TAC `0 <= x` THEN1 (
		MATCH_MP_TAC LE_SEQ_IMP_LE_LIM THEN
		EXISTS_TAC (--`(\n. sum (0,n) (\n. & n * prob bern {s | FST (
		(R: (num -> bool) -> num#(num -> bool)) s) = n}))`--) THEN
		RW_TAC std_ss [] THEN
		MATCH_MP_TAC SUM_POS THEN
		RW_TAC std_ss [] THEN
		MATCH_MP_TAC REAL_LE_MUL THEN
		RW_TAC real_ss [PROB_POSITIVE, PROB_SPACE_BERN, INDEP_FN_SET_FST_EVENTS]) THEN
	RW_TAC std_ss [REAL_LE_RDIV_EQ] THEN
	RW_TAC std_ss [real_div, GSYM REAL_MUL_ASSOC] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`x * 1:real`--) THEN
	CONJ_TAC THEN1 (
		MATCH_MP_TAC REAL_LE_LMUL_IMP THEN
		RW_TAC std_ss [] THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`inv (& (ceiling a)) * &(ceiling a)`--) THEN
		KNOW_TAC `0 < (&(ceiling a))` THEN1 (
			MATCH_MP_TAC REAL_LTE_TRANS THEN
			EXISTS_TAC (--`a:real`--) THEN
			RW_TAC std_ss [LB_CEILING]) THEN
		CONJ_TAC THEN1 (
			MATCH_MP_TAC REAL_LE_LMUL_IMP THEN
			RW_TAC std_ss [REAL_LT_INV_EQ, LB_CEILING, REAL_LT_IMP_LE]) THEN

			RW_TAC std_ss [REAL_MUL_LINV, REAL_POS_NZ, REAL_LE_REFL]) THEN
	
		RW_TAC real_ss [REAL_LE_REFL]);

val CHEBYCHEV_HELPER = store_thm
 ("CHEBYCHEV_HELPER",
 (--`!(X: (num -> bool) -> num#(num -> bool)) a. (0 < a) /\ 
         X IN indep_fn /\
	 summable (\n. & n * prob bern {s | FST (X s) = n}) /\
         summable (\n. (\x. & x pow 2) n * prob bern {s | FST (X s) = n}) ==> 
		(prob bern {s | abs (&(FST (X s)) - expec X) >= a * std_dev X} <= 
		prob bern {s | &(FST (X s)) >= expec X + a * std_dev X} +
		prob bern {s | &(FST (X s)) <= expec X - a * std_dev X})`--),
	RW_TAC std_ss [] THEN
	MP_TAC (Q.SPEC `(X: (num -> bool) -> num#(num -> bool))` STD_DEV_POSITIVE) THEN
	RW_TAC std_ss [] THEN
	POP_ASSUM MP_TAC THEN
	RW_TAC std_ss [REAL_LE_LT] THEN1 (
		RW_TAC std_ss [GSYM REAL_LE_LT] THEN
		KNOW_TAC `prob bern {s | &(FST (X s)) >= expec X + a * std_dev X} +
                prob bern {s | &(FST (X s)) <= expec X - a * std_dev X} = 
		prob bern ({s | &(FST (X s)) >= expec X + a * std_dev X} UNION 
			{s | &(FST (X s)) <= expec X - a * std_dev X})` THEN1 (
			ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
			MATCH_MP_TAC PROB_ADDITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN, DISJOINT_DEF, INTER_DEF, GSPECIFICATION,
			GSYM GSPEC_F] THENL [
				KNOW_TAC `{s | & (FST (X s)) >= expec X + a * std_dev X} = 
				((\y. &y >= expec X + a * std_dev X) o FST o X)` THEN1
					PSET_TAC [o_DEF] THEN
				RW_TAC std_ss [INDEP_FN_FST_EVENTS],

				KNOW_TAC `{s | & (FST (X s)) <= expec X - a * std_dev X} =
				((\y. &y <= expec X - a * std_dev X) o FST o X)` THEN1
                        		PSET_TAC [o_DEF] THEN
                		RW_TAC std_ss [INDEP_FN_FST_EVENTS],

				REWRITE_TAC [EXTENSION] THEN
				PSET_TAC [GSPECIFICATION] THEN
				DISJ2_TAC THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC bool_ss [] THEN
				SUFF_TAC `& (FST (X x')) < expec X + a * std_dev X` THEN1
					RW_TAC std_ss [REAL_NOT_LT, GSYM real_ge] THEN
			
					MATCH_MP_TAC REAL_LET_TRANS THEN
					EXISTS_TAC 
					(--`expec (X: (num -> bool) -> num#(num -> bool)) - 
						a * std_dev X`--) THEN
					RW_TAC std_ss [REAL_LT_SUB_RADD, 
					GSYM REAL_ADD_ASSOC, REAL_LT_ADDR, REAL_DOUBLE] THEN
					MATCH_MP_TAC REAL_LT_MUL THEN
					RW_TAC real_ss [] THEN
					MATCH_MP_TAC REAL_LT_MUL THEN
					RW_TAC real_ss []]) THEN
	
		ONCE_ASM_REWRITE_TAC [] THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC PROB_INCREASING THEN
		RW_TAC std_ss [PROB_SPACE_BERN] THENL [
			KNOW_TAC `{s | abs (& (FST (X s)) - expec X) >= a * std_dev X} = 
			((\y. abs (& y - expec X) >= a * std_dev X) o FST o X)` THEN1
				PSET_TAC [o_DEF] THEN
			RW_TAC std_ss [INDEP_FN_FST_EVENTS],
	
			MATCH_MP_TAC EVENTS_UNION THEN
			RW_TAC std_ss [PROB_SPACE_BERN] THENL [
				KNOW_TAC `{s | & (FST (X s)) >= expec X + a * std_dev X} = 
				((\y. &y >= expec X + a * std_dev X) o FST o X)` THEN1
                        		PSET_TAC [o_DEF] THEN
                		RW_TAC std_ss [INDEP_FN_FST_EVENTS],

				KNOW_TAC `{s | & (FST (X s)) <= expec X - a * std_dev X} = 
                                ((\y. &y <= expec X - a * std_dev X) o FST o X)` THEN1
                                	PSET_TAC [o_DEF] THEN
                        	RW_TAC std_ss [INDEP_FN_FST_EVENTS]],

			RW_TAC std_ss [SUBSET_DEF, GSPECIFICATION, IN_UNION] THEN
			Cases_on `expec X < & (FST (X x))` THEN1 (
				KNOW_TAC `abs (& (FST (X x)) - expec X) = 
				& (FST (X x)) - expec X` THEN1 
					RW_TAC std_ss [ABS_REFL, REAL_LT_IMP_LE,
					 REAL_SUB_LE] THEN
				FULL_SIMP_TAC std_ss [REAL_LE_SUB_LADD, real_ge, REAL_ADD_SYM]) THEN

				KNOW_TAC `abs (& (FST (X x)) - expec X) =
				expec X - & (FST (X x))` THEN1 (
					ONCE_REWRITE_TAC [GSYM REAL_NEG_SUB] THEN
					RW_TAC std_ss [ABS_NEG, REAL_SUB_LE, GSYM REAL_NOT_LT,
					ABS_REFL, REAL_NEG_SUB]) THEN			
				FULL_SIMP_TAC std_ss [REAL_LE_SUB_LADD, real_ge, REAL_ADD_SYM]]) THEN



		RW_TAC std_ss [GSYM REAL_LE_LT] THEN
		POP_ASSUM MP_TAC THEN
		ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
		RW_TAC real_ss [ABS_POS, real_ge] THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`prob bern {s | expec X <= & (FST (X s))} +
		prob bern {s | & (FST ((X: (num -> bool) -> num#(num -> bool)) s)) 
			< expec X}`--) THEN
		RW_TAC std_ss [REAL_LE_LADD] THENL [
			MATCH_MP_TAC REAL_EQ_IMP_LE THEN
			MATCH_MP_TAC PROB_ADDITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN, DISJOINT_DEF, INTER_DEF, GSPECIFICATION,
                        GSYM GSPEC_F, REAL_LTE_ANTSYM] THENL [
				KNOW_TAC `{s | expec X <= & (FST (X s))} =
                        	((\y. expec X <= &y) o FST o X)` THEN1
					PSET_TAC [o_DEF] THEN
				RW_TAC std_ss [INDEP_FN_FST_EVENTS],

				KNOW_TAC `{s | & (FST (X s)) < expec X} =
                                ((\y. &y < expec X) o FST o X)` THEN1
                                	PSET_TAC [o_DEF] THEN
                        	RW_TAC std_ss [INDEP_FN_FST_EVENTS],

				REWRITE_TAC [EXTENSION] THEN
				PSET_TAC [GSPECIFICATION, IN_UNION, REAL_LET_TOTAL]],
			
			MATCH_MP_TAC PROB_INCREASING THEN
			RW_TAC std_ss [PROB_SPACE_BERN, SUBSET_DEF, 
			REAL_LT_IMP_LE, GSPECIFICATION, IN_UNION] THENL [
				KNOW_TAC `{s | & (FST (X s)) < expec X} =
				((\y. &y < expec X) o FST o X)` THEN1
					PSET_TAC [o_DEF] THEN
				RW_TAC std_ss [INDEP_FN_FST_EVENTS],

				KNOW_TAC `{s | & (FST (X s)) <= expec X} =
                                ((\y. &y <= expec X) o FST o X)` THEN1
                                	PSET_TAC [o_DEF] THEN
                        	RW_TAC std_ss [INDEP_FN_FST_EVENTS]]]);


val CHEBYSHEVS_INEQUALITY = store_thm 
 ("CHEBYSHEVS_INEQUALITY",
 (--`!(X: (num -> bool) -> num#(num -> bool)) a .
         X IN indep_fn /\ (0 < a) /\ (0 < variance X) /\
         summable (\n. & n * prob bern {s | FST (X s) = n}) /\
         summable (\n. (\x. & x pow 2) n * prob bern {s | FST (X s) = n})  ==>
	 (prob bern {s | abs (&(FST (X s)) - expec X) >= a * std_dev X} <= 
		1/(a pow 2))`--),
	RW_TAC std_ss [] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`prob bern {s | & (FST ((X: (num -> bool) -> num#(num -> bool)) s)) >= 
				expec X + a * std_dev X} +
         		prob bern {s | & (FST (X s)) <= expec X - a * std_dev X}`--) THEN
	RW_TAC std_ss [CHEBYCHEV_HELPER] THEN
	MATCH_MP_TAC REAL_LE_TRANS THEN
	EXISTS_TAC (--`prob bern {s | (FST ((X: (num -> bool) -> num#(num -> bool)) s)) >=
                                ceiling (expec X + a * std_dev X)} +
         		prob bern ({s |  ((FST (X s)) < ceiling (expec X - a * std_dev X))} UNION
		   {s |	 (&(FST (X s)) = (expec X - a * std_dev X))})`--) THEN
	RW_TAC std_ss [GSYM REAL_ADD_ASSOC] THEN1 (
		MATCH_MP_TAC REAL_LE_ADD2 THEN
		CONJ_TAC THEN1 (
			MATCH_MP_TAC PROB_INCREASING THEN
			RW_TAC std_ss [PROB_SPACE_BERN, SUBSET_DEF, GSPECIFICATION, IN_UNION] THENL [
				KNOW_TAC `{s | & (FST (X s)) >= expec X + a * std_dev X} =
				((\y. &y >=  expec X + a * std_dev X) o FST o X)` THEN1
					PSET_TAC [o_DEF] THEN
				RW_TAC std_ss [INDEP_FN_FST_EVENTS],

				KNOW_TAC `{s | FST (X s) >= ceiling (expec X + a * std_dev X)} = 
				((\y. y >= ceiling (expec X + a * std_dev X)) o FST o X)` THEN1
                        		PSET_TAC [o_DEF] THEN
				RW_TAC std_ss [INDEP_FN_FST_EVENTS],
	
				FULL_SIMP_TAC std_ss [real_ge, GREATER_EQ] THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC std_ss [NOT_LEQ, ADD1, 
				GSYM REAL_ADD, GSYM REAL_LE, GSYM REAL_LE_SUB_LADD] THEN
				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [GSYM REAL_LE_SUB_LADD, REAL_NOT_LE] THEN
				MATCH_MP_TAC REAL_LTE_TRANS THEN
				EXISTS_TAC (--`expec X + a * std_dev  
				(X: (num -> bool) -> num#(num -> bool))`--) THEN
				RW_TAC std_ss [REAL_LT_SUB_RADD] THENL [
					MATCH_MP_TAC UB_CEILING THEN
					MATCH_MP_TAC REAL_LE_ADD THEN
					RW_TAC std_ss [EXPEC_POSITIVE] THEN
					MATCH_MP_TAC REAL_LE_MUL THEN
					RW_TAC std_ss [STD_DEV_POSITIVE, REAL_LT_IMP_LE],

					RW_TAC std_ss [GSYM REAL_LE_SUB_LADD]]]) THEN

			MATCH_MP_TAC PROB_INCREASING THEN
			RW_TAC std_ss [PROB_SPACE_BERN, SUBSET_DEF, GSPECIFICATION, IN_UNION] THENL [
				KNOW_TAC `{s | & (FST (X s)) <= expec X - a * std_dev X} = 
				((\y. &y <= expec X - a * std_dev X) o FST o X)` THEN1
                        		PSET_TAC [o_DEF] THEN
                		RW_TAC std_ss [INDEP_FN_FST_EVENTS],
			
				MATCH_MP_TAC EVENTS_UNION THEN
				RW_TAC std_ss [PROB_SPACE_BERN] THENL [
                			KNOW_TAC `{s | FST (X s) < ceiling (expec X - a * std_dev X )} =
                        		((\y. y < ceiling (expec X - a * std_dev X)) o FST o X)` THEN1
                        			PSET_TAC [o_DEF] THEN
                			RW_TAC std_ss [INDEP_FN_FST_EVENTS],

					KNOW_TAC `{s | & (FST (X s)) = expec X - a * std_dev X}  =
                        		((\y. &y = (expec X - a * std_dev X)) o FST o X)` THEN1
                        			PSET_TAC [o_DEF] THEN
                			RW_TAC std_ss [INDEP_FN_FST_EVENTS]],

				POP_ASSUM MP_TAC THEN
				RW_TAC std_ss [REAL_LE_LT] THENL [
					DISJ1_TAC THEN
					REWRITE_TAC [GSYM REAL_LT] THEN
					MATCH_MP_TAC REAL_LTE_TRANS THEN
					EXISTS_TAC (--`expec X - a * std_dev
                        		(X: (num -> bool) -> num#(num -> bool))`--) THEN
					RW_TAC std_ss [LB_CEILING],

					PROVE_TAC []]]) THEN

		KNOW_TAC `prob bern
      		({s | FST (X s) < ceiling (expec X - a * std_dev X)} UNION
       			{s | & (FST (X s)) = expec X - a * std_dev X}) = 
		prob bern {s | FST (X s) < ceiling (expec X - a * std_dev X)} + 
		prob bern {s | & (FST (X s)) = expec X - a * std_dev X}` THEN1 (
			MATCH_MP_TAC PROB_ADDITIVE THEN
			RW_TAC std_ss [PROB_SPACE_BERN, DISJOINT_DEF, INTER_DEF, GSPECIFICATION,
                        GSYM GSPEC_F] THENL [
				KNOW_TAC `{s | FST (X s) < ceiling (expec X - a * std_dev X )} =
                        	((\y. y < ceiling (expec X - a * std_dev X)) o FST o X)` THEN1
                        		PSET_TAC [o_DEF] THEN
                		RW_TAC std_ss [INDEP_FN_FST_EVENTS],

				KNOW_TAC `{s | & (FST (X s)) = expec X - a * std_dev X}  =
                        	((\y. &y = (expec X - a * std_dev X)) o FST o X)` THEN1
                        		PSET_TAC [o_DEF] THEN
                		RW_TAC std_ss [INDEP_FN_FST_EVENTS],

				REWRITE_TAC [EXTENSION] THEN
				PSET_TAC [GSPECIFICATION] THEN
				DISJ2_TAC THEN
				CCONTR_TAC THEN
				FULL_SIMP_TAC bool_ss [] THEN
				KNOW_TAC `ceiling (expec X - a * std_dev X) = ceiling (& (FST (X x')))`
					THEN1
					PROVE_TAC [] THEN
				FULL_SIMP_TAC arith_ss [CEILING_NUM]]) THEN
	
		ASM_REWRITE_TAC [GSYM REAL_ADD_ASSOC] THEN
		POP_ASSUM K_TAC THEN
						
		KNOW_TAC `prob bern {s | FST (X s) >= ceiling (expec X + a * std_dev X)} +
    			(prob bern {s | FST (X s) < ceiling (expec X - a * std_dev X)} +
     			prob bern {s | & (FST (X s)) = expec X - a * std_dev X}) <= 
    			1 / (a pow 2) =
        		variance X * a pow 2 *
        		(prob bern {s | FST (X s) >= ceiling (expec X + a * std_dev X)} +
    			(prob bern {s | FST (X s) < ceiling (expec X - a * std_dev X)} +
     			prob bern {s | & (FST (X s)) = expec X - a * std_dev X})) <= variance X` THEN1 (
			ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
			RW_TAC real_ss [GSYM REAL_LE_RDIV_EQ, REAL_POW_LT,
				REAL_MUL_ASSOC, real_div] THEN
			SUFF_TAC `variance X * inv (a pow 2) * inv (variance X) = inv (a pow 2)` THEN1 (
				RW_TAC std_ss [] THEN
				FULL_SIMP_TAC real_ss [REAL_MUL_SYM]) THEN

				ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
				RW_TAC real_ss [REAL_MUL_ASSOC, REAL_MUL_LINV, REAL_POS_NZ]) THEN
		ASM_REWRITE_TAC [REAL_ADD_LDISTRIB] THEN
		POP_ASSUM K_TAC THEN
		MATCH_MP_TAC REAL_LE_TRANS THEN
		EXISTS_TAC (--`variance X * a pow 2 *
      			prob bern {s | FST ((X: (num -> bool) -> num#(num -> bool)) s) >= 
			ceiling (expec X + a * std_dev X)} +
      			(sum (0,ceiling (expec X + a * std_dev X)) (\n. (&n - expec X) pow 2 * 
			prob bern {s |  FST (X s) = n}))`--) THEN


		RW_TAC std_ss [REAL_LE_LADD] THEN1 (
			MATCH_MP_TAC REAL_LE_TRANS THEN	
			EXISTS_TAC (--` (sum (0,ceiling (expec  (X: (num -> bool) -> num#(num -> bool)) - 
				a * std_dev X)) (\n. (&n - expec X) pow 2 * 
				prob bern {s |  FST (X s) = n})) + 
				(sum (ceiling (expec X - a * std_dev X), 
				ceiling (expec X + a * std_dev X) - ceiling (expec X - a * std_dev X)) 
				(\n. (&n - expec X) pow 2 * prob bern {s | FST (X s) = n}))`--) THEN
			CONJ_TAC THEN1 (
				MATCH_MP_TAC REAL_LE_ADD2 THEN
				CONJ_TAC THENL [
					KNOW_TAC `{s | FST (X s) < ceiling (expec X - a * std_dev X)} = 
						BIGUNION (IMAGE (\n. {s | (FST (X s) = n)}) 
						{n | n < ceiling (expec X - a * std_dev X)})` THEN1 (
						REWRITE_TAC [EXTENSION] THEN
						PSET_TAC [GSPECIFICATION, IN_BIGUNION_IMAGE]) THEN
					ASM_REWRITE_TAC [] THEN
					POP_ASSUM K_TAC THEN
					KNOW_TAC `prob bern (BIGUNION
         				(IMAGE (\n. {s | FST (X s) = n})
            				{n | n < ceiling (expec X - a * std_dev X)})) = 
					sum (0, ceiling (expec X - a * std_dev X)) 
					(prob bern o (\n. {s | FST (X s) = n}))` THEN1 (
						ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
						MATCH_MP_TAC PROB_FINITELY_ADDITIVE THEN
						RW_TAC std_ss [PROB_SPACE_BERN, 
						DISJOINT_DEF, INTER_DEF, SPECIFICATION, IN_FUNSET] THENL [
                    					ONCE_REWRITE_TAC [GSYM SPECIFICATION] THEN
                    					RW_TAC std_ss [INDEP_FN_SET_FST_EVENTS],

                    					REWRITE_TAC [EXTENSION] THEN
                    					PSET_TAC [GSPECIFICATION] THEN
                    					RW_TAC arith_ss [],


                    					RW_TAC arith_ss [EXTENSION, IN_UNIV, IN_BIGUNION_IMAGE,
                                      			GSPECIFICATION, IN_COUNT]]) THEN 
                    			ASM_REWRITE_TAC [GSYM SUM_CMUL] THEN
					POP_ASSUM K_TAC THEN
					MATCH_MP_TAC SUM_LE THEN
					RW_TAC arith_ss [] THEN
					KNOW_TAC `0 <= prob bern {s | FST (X s) = r}` THEN1 (
						MATCH_MP_TAC PROB_POSITIVE THEN
						RW_TAC std_ss [PROB_SPACE_BERN, INDEP_FN_SET_FST_EVENTS]) THEN
					POP_ASSUM MP_TAC THEN
					RW_TAC std_ss [REAL_LE_LT] THENL [
						RW_TAC std_ss [GSYM REAL_LE_LT, REAL_LE_RMUL] THEN
						KNOW_TAC `0 < (expec X - a * std_dev X)` THEN1 (
							CCONTR_TAC THEN
							SUFF_TAC `ceiling (expec X - a * std_dev X) = 0` THEN1 (
								STRIP_TAC THEN
								DECIDE_TAC) THEN
						
								MATCH_MP_TAC CEILING_NEG THEN
								FULL_SIMP_TAC std_ss [REAL_NOT_LT]) THEN
						KNOW_TAC `&r < (expec X - a * std_dev X)` THEN1 (
							MATCH_MP_TAC REAL_LET_TRANS THEN
							EXISTS_TAC (--`& (ceiling (expec 
							(X: (num -> bool) -> num#(num -> bool))
							 - a * std_dev X) - 1)`--) THEN
							RW_TAC arith_ss [REAL_LE] THEN
							KNOW_TAC `0 < ceiling (expec X - a * std_dev X)` THEN1 (
								REWRITE_TAC [GSYM REAL_LT] THEN
								MATCH_MP_TAC REAL_LTE_TRANS THEN
								EXISTS_TAC (--`expec 
								(X: (num -> bool) -> num#(num -> bool)) - 
								a * std_dev X`--) THEN
								RW_TAC std_ss [LB_CEILING]) THEN
							KNOW_TAC `1 <= ceiling (expec X - a * std_dev X)` THEN1
								DECIDE_TAC THEN
							KNOW_TAC `& (ceiling (expec X - a * std_dev X) - 1) = 
							& (ceiling (expec X - a * std_dev X)) - &1` THEN1 (
								RW_TAC std_ss [REAL_SUB] THEN
								ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
								RW_TAC arith_ss [REAL_INJ, REAL_NEG_EQ0]) THEN
							ASM_REWRITE_TAC [REAL_LT_SUB_RADD] THEN
							MATCH_MP_TAC  UB_CEILING THEN
							RW_TAC std_ss [REAL_LT_IMP_LE]) THEN
					
						KNOW_TAC `variance X * a pow 2 = ((std_dev X) * a) pow 2`
							THEN1 (
							RW_TAC std_ss [std_dev_def, POW_MUL,
							REAL_EQ_RMUL, REAL_POS_NZ,
							REAL_POW_LT] THEN
							ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
							MATCH_MP_TAC SQRT_POW_2 THEN
							RW_TAC std_ss [REAL_LT_IMP_LE]) THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						KNOW_TAC `(& r - expec X) pow 2 = (~ &r + expec X) pow 2`
							THEN1 (
							KNOW_TAC `(~& r + expec X) = 
							~(& r - expec X)` THEN1 (
								RW_TAC std_ss [REAL_NEG_SUB, real_sub] THEN
								PROVE_TAC [REAL_ADD_SYM]) THEN
							ASM_REWRITE_TAC [POW_2, REAL_NEG_MUL2]) THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN	
						MATCH_MP_TAC POW_LE THEN
						RW_TAC std_ss [REAL_LE_MUL, STD_DEV_POSITIVE, 
							REAL_LT_IMP_LE] THEN
						ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
						RW_TAC std_ss [GSYM real_sub, REAL_LE_SUB_LADD] THEN
						ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
						RW_TAC std_ss [GSYM REAL_LE_SUB_LADD] THEN
						PROVE_TAC [REAL_MUL_SYM, REAL_LT_IMP_LE], 
					
					
						RW_TAC std_ss [GSYM REAL_LE_LT] THEN
						KNOW_TAC `prob bern {s | FST (X s) = r} = 0` THEN1
							PROVE_TAC [] THEN
						FULL_SIMP_TAC real_ss [REAL_LE_REFL]],

						
					Cases_on `?N. (expec (X: (num -> bool) -> num#(num -> bool)) - 
					a * std_dev X = &N)` THEN1 (
						FULL_SIMP_TAC std_ss [CEILING_NUM, REAL_INJ] THEN
						MATCH_MP_TAC REAL_LE_TRANS THEN
						EXISTS_TAC (--` sum (N, 1) 
        					(\n. (& n - 
						expec (X: (num -> bool) -> num#(num -> bool))) 
						pow 2 * prob bern {s | FST (X s) = n})`--) THEN
						CONJ_TAC THEN1 (
							RW_TAC std_ss [SUM_1] THEN
							KNOW_TAC `0 <= prob bern {s | FST (X s) = N}` THEN1 (
								MATCH_MP_TAC PROB_POSITIVE THEN
								RW_TAC std_ss [PROB_SPACE_BERN, 
								INDEP_FN_SET_FST_EVENTS]) THEN
							POP_ASSUM MP_TAC THEN
							RW_TAC real_ss [REAL_LE_LT] THEN1 (
								RW_TAC std_ss [GSYM REAL_LE_LT, REAL_LE_RMUL] THEN
								POP_ASSUM K_TAC THEN
								KNOW_TAC `&N = expec X - a * std_dev X` THEN1
									PROVE_TAC [] THEN
								ONCE_ASM_REWRITE_TAC [] THEN
								POP_ASSUM K_TAC THEN
								KNOW_TAC `(expec X - a * std_dev X - expec X) = 
								~ (a * std_dev X)` THEN1 (
									REWRITE_TAC [real_sub] THEN
									REAL_ARITH_TAC) THEN
								ONCE_ASM_REWRITE_TAC [] THEN
								KNOW_TAC `variance X * a pow 2 = 
								((std_dev X) * a) pow 2` THEN1 (
									RW_TAC std_ss [std_dev_def, POW_MUL,
									REAL_EQ_RMUL, REAL_POS_NZ,
									REAL_POW_LT] THEN
									ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
									MATCH_MP_TAC SQRT_POW_2 THEN
									RW_TAC std_ss [REAL_LT_IMP_LE]) THEN	
								ASM_REWRITE_TAC [POW_2, REAL_NEG_MUL2] THEN
								PROVE_TAC [REAL_MUL_SYM, REAL_LE_REFL]) THEN

								RW_TAC std_ss [GSYM REAL_LE_LT] THEN
								KNOW_TAC `prob bern {s | FST (X s) = N} = 0`THEN1
									PROVE_TAC [] THEN
								FULL_SIMP_TAC real_ss [REAL_LE_REFL]) THEN 

							KNOW_TAC `expec X - a * std_dev X < 
							(expec X + a * std_dev X)` THEN1 (
								RW_TAC std_ss [REAL_LT_SUB_RADD, REAL_DOUBLE,
								GSYM REAL_ADD_ASSOC, REAL_LT_ADDR] THEN
								MATCH_MP_TAC REAL_LT_MUL THEN
								RW_TAC real_ss [] THEN
								MATCH_MP_TAC REAL_LT_MUL THEN
								ASM_REWRITE_TAC [std_dev_def] THEN
								MATCH_MP_TAC SQRT_POS_LT THEN
								ASM_REWRITE_TAC []) THEN
							KNOW_TAC `1 <= ceiling (expec X + a * std_dev X) -
									N` THEN1 (
								RW_TAC arith_ss [SUB_LEFT_LESS_EQ,
								GSYM LESS_EQ, GSYM ADD1, GSYM REAL_LT] THEN
								MATCH_MP_TAC REAL_LTE_TRANS THEN
								EXISTS_TAC (--`expec 
								(X: (num -> bool) -> 
								num#(num -> bool)) + a * std_dev X`--) THEN
								FULL_SIMP_TAC std_ss [LB_CEILING] THEN
								MATCH_MP_TAC REAL_LET_TRANS THEN
								EXISTS_TAC (--`expec 
								(X: (num -> bool) -> 
								num#(num -> bool)) - a * std_dev X`--) THEN
								RW_TAC std_ss [REAL_EQ_IMP_LE]) THEN
						
							KNOW_TAC `ceiling (expec X + a * std_dev X) - N = 
							1 + (ceiling (expec X + a * std_dev X) - N - 1) ` THEN1
      								RW_TAC arith_ss [] THEN
							ONCE_ASM_REWRITE_TAC [] THEN
							NTAC 4 (POP_ASSUM K_TAC) THEN
							RW_TAC std_ss [GSYM SUM_TWO_GENERAL, REAL_LE_ADDR] THEN
							MATCH_MP_TAC SUM_POS THEN
							RW_TAC std_ss [] THEN
							MATCH_MP_TAC REAL_LE_MUL THEN
							RW_TAC std_ss [REAL_LE_POW2] THEN
							MATCH_MP_TAC PROB_POSITIVE THEN
							RW_TAC std_ss [PROB_SPACE_BERN, 
							INDEP_FN_SET_FST_EVENTS]) THEN

						FULL_SIMP_TAC real_ss [PROB_BERN_BASIC, GSPEC_F] THEN
						MATCH_MP_TAC SUM_POS THEN
						RW_TAC std_ss [] THEN
						MATCH_MP_TAC REAL_LE_MUL THEN
						RW_TAC std_ss [REAL_LE_POW2] THEN
						MATCH_MP_TAC PROB_POSITIVE THEN
						RW_TAC std_ss [PROB_SPACE_BERN, 
						INDEP_FN_SET_FST_EVENTS]]) THEN

					RW_TAC std_ss [SUM_TWO] THEN
					SUFF_TAC `ceiling (expec X - a * std_dev X) +
       					(ceiling (expec X + a * std_dev X) -
        				ceiling (expec X - a * std_dev X)) = 
					ceiling (expec X + a * std_dev X)` THEN1
						RW_TAC std_ss [REAL_EQ_IMP_LE] THEN
					
						SUFF_TAC `ceiling (expec X - a * std_dev X) +
    						(ceiling (expec X + a * std_dev X) -
     						ceiling (expec X - a * std_dev X)) = 
						ceiling (expec X - a * std_dev X) +
    						ceiling (expec X + a * std_dev X) -
     						ceiling (expec X - a * std_dev X)` THEN1
							RW_TAC arith_ss [] THEN
						
							MATCH_MP_TAC EQ_SYM THEN
							MATCH_MP_TAC LESS_EQ_ADD_SUB THEN
							MATCH_MP_TAC CEIL_MONO2 THEN
							MATCH_MP_TAC REAL_LT_IMP_LE THEN
							RW_TAC std_ss [REAL_LT_SUB_RADD, REAL_DOUBLE,
								GSYM REAL_ADD_ASSOC, REAL_LT_ADDR] THEN
							MATCH_MP_TAC REAL_LT_MUL THEN
							RW_TAC real_ss [] THEN
							MATCH_MP_TAC REAL_LT_MUL THEN
							ASM_REWRITE_TAC [std_dev_def] THEN
							MATCH_MP_TAC SQRT_POS_LT THEN
							ASM_REWRITE_TAC []) THEN
											
			KNOW_TAC `variance X * a pow 2 = ((std_dev X) * a) pow 2` THEN1 (
				RW_TAC std_ss [std_dev_def, POW_MUL,
				REAL_EQ_RMUL, REAL_POS_NZ,
				REAL_POW_LT] THEN
				ONCE_REWRITE_TAC [EQ_SYM_EQ] THEN
				MATCH_MP_TAC SQRT_POW_2 THEN
				RW_TAC std_ss [REAL_LT_IMP_LE]) THEN
			ASM_REWRITE_TAC [] THEN
			POP_ASSUM K_TAC THEN
			RW_TAC std_ss [variance_def, EXPEC_FN, suminf] THEN
			SELECT_ELIM_TAC THEN
			RW_TAC std_ss [GSYM summable, VARIANCE_SUMMABLE] THEN
			FULL_SIMP_TAC std_ss [sums, GSYM REAL_LE_SUB_LADD] THEN
			KNOW_TAC `(\n. sum (0,ceiling (expec X + a * std_dev X)+n)
			(\n. (& n - expec X) pow 2 * prob bern {s | FST (X s) = n})) --> x` THEN1 (
				Q.SPEC_TAC (`ceiling (expec X + a * std_dev X)`, `a`) THEN
				Induct THEN1
					RW_TAC arith_ss [] THEN

					Cases_on `a'` THENL [
						RW_TAC arith_ss [GSYM ADD1] THEN
						KNOW_TAC `(\n. sum (0,SUC n)
         					(\n. (& n - expec X) pow 2 * prob bern {s | FST (X s) = n})) =
						(\n. (\n. sum (0,n) (\n. (& n - expec X) pow 2 * prob bern {s | FST (X s) = n})) 
						(SUC n))` THEN1
							RW_TAC std_ss [] THEN
						ASM_REWRITE_TAC [] THEN
						ONCE_REWRITE_TAC [GSYM SEQ_SUC] THEN		
						ASM_REWRITE_TAC [],

						FULL_SIMP_TAC arith_ss [] THEN
						POP_ASSUM MP_TAC THEN
						Q.SPEC_TAC (`SUC n`, `a`) THEN
						GEN_TAC THEN
						KNOW_TAC `(\n'. sum (0,n' + SUC a')
         					(\n. (& n - expec X) pow 2 * prob bern {s | FST (X s) = n})) = 
						(\n'. (\n'. sum (0,n' + a') 
						(\n. (& n - expec X) pow 2 * prob bern {s | FST (X s) = n}))
						(SUC n'))` THEN1
							RW_TAC arith_ss [ADD1] THEN
                        			ASM_REWRITE_TAC [] THEN
                        			ONCE_REWRITE_TAC [GSYM SEQ_SUC] THEN
                        			ASM_REWRITE_TAC []]) THEN
				FULL_SIMP_TAC std_ss [GSYM SUM_TWO] THEN
				KNOW_TAC `(\n. (\n.
             			sum (0,ceiling (expec X + a * std_dev X)) (\n. (& n - expec X) pow 2 * prob bern {s | FST (X
				s) = n}) +
             			sum (ceiling (expec X + a * std_dev X),n) (\n. (& n - expec X) pow 2 * prob bern
				{s | FST (X s) = n})) n - 
				(\n. sum (0,ceiling (expec X + a * std_dev X)) (\n. (& n - expec X) pow 2 * prob
				bern {s | FST (X s) = n})) n) --> 
					(x - sum (0,ceiling (expec X + a * std_dev X)) (\n. (& n - expec X) pow 2 * prob
					bern {s | FST (X s) = n}))` THEN1 (
					MATCH_MP_TAC SEQ_SUB THEN
					RW_TAC std_ss [SEQ_CONST]) THEN		
				KNOW_TAC `!a b. (a + b) - a = b` THEN1 (
					REPEAT GEN_TAC THEN
					REAL_ARITH_TAC) THEN
				FULL_SIMP_TAC std_ss [] THEN
				POP_ASSUM K_TAC THEN		
				KNOW_TAC `(\n. sum (ceiling (expec X + a * std_dev X),n) (\n. ((& n - expec X) pow 2)/ ((std_dev X
					* a) pow 2) * prob bern {s | FST (X s) = n})) -->
          				(x/((std_dev X * a) pow 2) - 
					sum (0,ceiling (expec X + a * std_dev X)) 
					(\n. ((& n - expec X) pow 2)/((std_dev X * a) pow 2) * prob bern {s | FST (X s) = n}))` 
						THEN1 (
					RW_TAC std_ss [real_div] THEN
					KNOW_TAC `(\n. (& n - expec X) pow 2 * inv ((std_dev X * a) pow 2) * 
						prob bern {s | FST (X s) = n}) = 
						(\n. inv ((std_dev X * a) pow 2) * (\n. (& n - expec X) pow 2 * 
						prob bern {s | FST (X s) = n}) n)` THEN1 (
						RW_TAC std_ss [] THEN
						PROVE_TAC [REAL_MUL_ASSOC, REAL_MUL_SYM]) THEN
					ASM_REWRITE_TAC [SUM_CMUL] THEN
					POP_ASSUM K_TAC THEN
					KNOW_TAC `!a b c. a * b - b * c = b * (a - c)` THEN1 (
						REPEAT GEN_TAC THEN
						REAL_ARITH_TAC) THEN
					ASM_REWRITE_TAC [] THEN
					POP_ASSUM K_TAC THEN
					KNOW_TAC `(\n. inv ((std_dev X * a) pow 2) * 
					sum (ceiling (expec X + a * std_dev X),n) 
					(\n. (& n - expec X) pow 2 * prob bern {s | FST (X s) = n})) = 
					(\n. (\n. inv ((std_dev X * a) pow 2)) n * 
					(\n. sum (ceiling (expec X + a * std_dev X),n) 
					(\n. (& n - expec X) pow 2 * prob bern {s | FST (X s) = n})) n)`
						THEN1
						RW_TAC std_ss [] THEN
					ONCE_ASM_REWRITE_TAC [] THEN
					MATCH_MP_TAC SEQ_MUL THEN
					RW_TAC std_ss [SEQ_CONST]) THEN
				ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
				RW_TAC std_ss [GSYM REAL_LE_RDIV_EQ, REAL_POW_LT, REAL_LT_MUL,
					std_dev_def, SQRT_POS_LT] THEN
				KNOW_TAC `(x - sum (0,ceiling (expec X + sqrt (variance X) * a))
       				(\n. prob bern {s | FST (X s) = n} * (& n - expec X) pow 2)) /
    				(sqrt (variance X) * a) pow 2 = 
				(x / (std_dev X * a) pow 2 -
           			sum (0,ceiling (expec X + a * std_dev X))
             			(\n. (& n - expec X) pow 2 / (std_dev X * a) pow 2 *
                		prob bern {s | FST (X s) = n}))` THEN1 (
					RW_TAC std_ss [real_div, REAL_SUB_RDISTRIB, GSYM std_dev_def,
					real_sub, REAL_EQ_LADD, REAL_EQ_NEG] THEN
					ONCE_REWRITE_TAC [REAL_MUL_SYM] THEN
					RW_TAC std_ss [REAL_MUL_ASSOC, GSYM SUM_CMUL] THEN
					MATCH_MP_TAC SUM_EQ THEN
					RW_TAC arith_ss [] THEN
					REAL_ARITH_TAC) THEN


				ASM_REWRITE_TAC [GSYM std_dev_def] THEN
				POP_ASSUM K_TAC THEN
				MATCH_MP_TAC REAL_LE_TRANS THEN
				EXISTS_TAC (--`(1 - sum (0,ceiling (expec X + a * std_dev X)) 
				(\n. prob bern {s | FST ( (X: (num -> bool) -> num#(num -> bool))s) = n}))`--) THEN
				CONJ_TAC THENL [
					MATCH_MP_TAC REAL_LE_TRANS THEN
					EXISTS_TAC (--`1 - prob bern {s | 
					FST ((X: (num -> bool) -> num#(num -> bool)) s) < ceiling (expec X + a * std_dev X)}`--) THEN
					CONJ_TAC THEN1 (
						MATCH_MP_TAC REAL_EQ_IMP_LE THEN
						Q.SPEC_TAC (`ceiling (expec X + a * std_dev X)`, `y`) THEN
						GEN_TAC THEN
						KNOW_TAC `{s | FST (X s) >= y} = COMPL {s | FST (X s) < y}` THEN1 (
							REWRITE_TAC [EXTENSION] THEN
							PSET_TAC [GSPECIFICATION, IN_COMPL, GREATER_EQ, NOT_LESS]) THEN
						ASM_REWRITE_TAC [] THEN
						POP_ASSUM K_TAC THEN
						RW_TAC std_ss [GSYM PROB_BERN_UNIV] THEN
						REWRITE_TAC [prob_def] THEN
						SUFF_TAC `measure bern UNIV = measure bern {s | FST (X s) < y}
                				+ measure bern (COMPL {s | FST (X s) < y})` THEN1
        						REAL_ARITH_TAC THEN
						MATCH_MP_TAC ADDITIVE THEN
						RW_TAC std_ss [] THENL [
(* 5 goals*)
        						MATCH_MP_TAC COUNTABLY_ADDITIVE_ADDITIVE THEN
        						CONJ_TAC THEN1 (
                						RW_TAC std_ss [GSYM events_def] THEN
                						MATCH_MP_TAC EVENTS_ALGEBRA THEN
                						RW_TAC std_ss [PROB_SPACE_BERN]) THEN

                						CONJ_TAC THEN1 (
                        						MATCH_MP_TAC PROB_SPACE_POSITIVE THEN
                        						RW_TAC std_ss [PROB_SPACE_BERN]) THEN

                        						MATCH_MP_TAC PROB_SPACE_COUNTABLY_ADDITIVE THEN
                        						RW_TAC std_ss [PROB_SPACE_BERN],
(* 4 goals*)

        						ONCE_REWRITE_TAC [GSYM events_def] THEN
        						KNOW_TAC  `{s | FST (X s) < y} =
                        					((\z. z < y) o FST o X)` THEN1
                						PSET_TAC [o_DEF] THEN
        						ASM_REWRITE_TAC [] THEN
        						MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
        						RW_TAC std_ss [],
(* 3 goals*)	
        						KNOW_TAC `COMPL {s | FST (X s) < y} = ((\z. z >= y) o FST o X)`
								THEN1
								PSET_TAC [o_DEF, GREATER_EQ, NOT_LESS] THEN
	       						ASM_REWRITE_TAC [] THEN
							ONCE_REWRITE_TAC [GSYM events_def] THEN
							MATCH_MP_TAC INDEP_FN_FST_EVENTS THEN
        						RW_TAC std_ss [],
(* 2 goals*)	

        						RW_TAC std_ss [DISJOINT_DEF] THEN
        						REWRITE_TAC [EXTENSION] THEN
        						PSET_TAC [GSPECIFICATION, IN_COMPL, IN_INTER],
(* 1 goals*)
        						REWRITE_TAC [EXTENSION] THEN
        						PSET_TAC [GSPECIFICATION, IN_COMPL, IN_UNION]]) THEN

						RW_TAC std_ss [real_sub, REAL_LE_LADD, REAL_LE_NEG] THEN
						MATCH_MP_TAC REAL_EQ_IMP_LE THEN
						MATCH_MP_TAC SUM_PMF_CDF THEN
						RW_TAC std_ss [],

					KNOW_TAC `(\n. (\n.
             				sum (0,ceiling (expec X + a * std_dev X)) (\n. prob bern {s | FST (X s) = n}) +
             				sum (ceiling (expec X + a * std_dev X),n) (\n. prob bern {s | FST (X s) = n})) n - 
					(\n. sum (0,ceiling (expec X + a * std_dev X)) (\n. prob bern {s | FST (X s) = n})) n) --> 
						(1 - sum (0,ceiling (expec X + a * std_dev X)) (\n. prob bern {s | FST (X
						s) = n}))` THEN1 (
						MATCH_MP_TAC SEQ_SUB THEN
						RW_TAC std_ss [SEQ_CONST, SUM_TWO] THEN
						NTAC 4 (POP_ASSUM K_TAC) THEN
						Q.SPEC_TAC (`ceiling (expec X + a * std_dev X)`, `y`) THEN
						Induct THEN1 (
							RW_TAC arith_ss [GSYM sums] THEN
							MATCH_MP_TAC PMF_SUMS_1 THEN
							ASM_REWRITE_TAC []) THEN
						

						KNOW_TAC `(\n. sum (0,SUC y + n) (\n. prob bern {s | FST (X s) = n})) = 
						(\n. (\n. sum (0,y + n) (\n. prob bern {s | FST (X s) = n})) (SUC n))`
							THEN1
							RW_TAC arith_ss [ADD1] THEN
						ASM_REWRITE_TAC [] THEN
						ONCE_REWRITE_TAC [GSYM SEQ_SUC] THEN	
						ASM_REWRITE_TAC []) THEN
					KNOW_TAC `!a b. (a + b) - a = b` THEN1 (
						REPEAT GEN_TAC THEN
						REAL_ARITH_TAC) THEN
					FULL_SIMP_TAC std_ss [] THEN
					POP_ASSUM K_TAC THEN	
					MATCH_MP_TAC SEQ_LE THEN
					EXISTS_TAC (--`(\n.
             				sum (ceiling (expec X + a * std_dev X),n)
               				(\n. prob bern {s | FST ((X: (num -> bool) -> num#(num -> bool)) s) = n}))`--) THEN
					EXISTS_TAC (--`(\n.
             				sum (ceiling (expec X + a * std_dev X),n)
               				(\n.(& n - expec X) pow 2 / (std_dev X * a) pow 2 *
                  			prob bern {s | FST ((X: (num -> bool) -> num#(num -> bool)) s) = n}))`--) THEN
					RW_TAC std_ss [] THEN
					EXISTS_TAC (--`0:num`--) THEN
					RW_TAC arith_ss [] THEN
					MATCH_MP_TAC SUM_LE THEN
					NTAC 5 (POP_ASSUM K_TAC) THEN
					RW_TAC arith_ss [] THEN
					KNOW_TAC `(prob bern {s | FST (X s) = r} <=
    					(& r - expec X) pow 2 / (std_dev X * a) pow 2 * prob bern {s | FST (X s) = r}) = 
					(1 * prob bern {s | FST (X s) = r} <=
    					(& r - expec X) pow 2 / (std_dev X * a) pow 2 * prob bern {s | FST (X s) = r})`
						THEN1
						RW_TAC real_ss [] THEN
					ONCE_ASM_REWRITE_TAC [] THEN
					MATCH_MP_TAC REAL_LE_MUL2 THEN
					RW_TAC real_ss [REAL_LE_RDIV_EQ] THENL [
						MATCH_MP_TAC PROB_POSITIVE THEN
						RW_TAC std_ss [PROB_SPACE_BERN, INDEP_FN_SET_FST_EVENTS],
					
						MATCH_MP_TAC REAL_LE_RDIV THEN	
						RW_TAC real_ss [REAL_POW_LT, REAL_LT_MUL, SQRT_POS_LT, std_dev_def] THEN
						REWRITE_TAC [GSYM std_dev_def, POW_2] THEN
						MATCH_MP_TAC REAL_LE_MUL2 THEN
						RW_TAC std_ss [std_dev_def, SQRT_POS_LT, REAL_LT_MUL, REAL_LT_IMP_LE] THENL
						[
							REWRITE_TAC [GSYM std_dev_def, REAL_LE_SUB_LADD] THEN
							ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
							MATCH_MP_TAC REAL_LE_TRANS THEN
							EXISTS_TAC (--`& (ceiling (expec 
							(X: (num -> bool) -> num#(num -> bool)) + a * std_dev X))`--) THEN
							PROVE_TAC [REAL_LE, LB_CEILING, REAL_MUL_SYM],
		
							REWRITE_TAC [GSYM std_dev_def, REAL_LE_SUB_LADD] THEN
							ONCE_REWRITE_TAC [REAL_ADD_SYM] THEN
							MATCH_MP_TAC REAL_LE_TRANS THEN
							EXISTS_TAC (--`& (ceiling (expec 
							(X: (num -> bool) -> num#(num -> bool)) + a * std_dev X))`--) THEN
							PROVE_TAC [REAL_LE, LB_CEILING, REAL_MUL_SYM]]]]);
							
val CHEBYSHEVS_INEQUALITY_ALT = store_thm
 ("CHEBYSHEVS_INEQUALITY_ALT",
 (--`!(X: (num -> bool) -> num#(num -> bool)) b .
         X IN indep_fn /\ (0 < b) /\ (0 < variance X) /\
         summable (\n. & n * prob bern {s | FST (X s) = n}) /\
         summable (\n. (\x. & x pow 2) n * prob bern {s | FST (X s) = n})  ==>
	 (prob bern {s | abs (&(FST (X s)) - expec X) >= b} <= 
		(variance X)/(b pow 2))`--),
	RW_TAC std_ss [] THEN
	MP_TAC (Q.SPECL [`X`, `b/(std_dev X)`] CHEBYSHEVS_INEQUALITY) THEN
	RW_TAC std_ss [] THEN
	KNOW_TAC `0 < b / std_dev X` THEN1
		RW_TAC real_ss [real_div, REAL_LT_LMUL_0, std_dev_def, SQRT_POS_LT] THEN
	FULL_SIMP_TAC std_ss [] THEN
	KNOW_TAC `variance X / b pow 2 = 1 / (b / std_dev X) pow 2` THEN1 (
		RW_TAC real_ss [real_div, std_dev_def, POW_2, POW_MUL, REAL_INV_MUL,
		REAL_POS_NZ, SQRT_POS_LT, GSYM REAL_MUL_ASSOC] THEN
		KNOW_TAC `0 < (b * (inv (sqrt (variance X)) * inv (sqrt (variance X))))` THEN1
			RW_TAC real_ss [REAL_POS_NZ, REAL_LT_LMUL_0, SQRT_POS_LT] THEN	
		RW_TAC std_ss [REAL_INV_MUL, REAL_POS_NZ, SQRT_POS_LT] THEN
		KNOW_TAC `0 < (inv (sqrt (variance X)) * inv (sqrt (variance X)))` THEN1 (
			RW_TAC std_ss [REAL_INV_MUL, REAL_POS_NZ, SQRT_POS_LT, REAL_POASQ,
			REAL_INV_POS]) THEN
		RW_TAC real_ss [REAL_INV_MUL, REAL_POS_NZ, SQRT_POS_LT, REAL_INV_INV,
			GSYM POW_2,  REAL_LT_IMP_LE, SQRT_POW_2] THEN	
		RW_TAC std_ss [POW_2] THEN
		REAL_ARITH_TAC) THEN
	ASM_REWRITE_TAC [] THEN
	POP_ASSUM K_TAC THEN
	KNOW_TAC `b =  b / std_dev X * std_dev X` THEN1 (
		RW_TAC real_ss [real_div, std_dev_def, SQRT_POS_LT, REAL_MUL_LINV,
		REAL_POS_NZ, GSYM REAL_MUL_ASSOC ]) THEN
	ONCE_ASM_REWRITE_TAC [] THEN
	PROVE_TAC []);

val _ = export_theory();
